CREATE TABLE IF NOT EXISTS tblUserProp
(
   `UserID` INT NOT NULL,
   `PropName` VARCHAR(50),
   `PropValue` VARCHAR(50)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblPlanVisibility`
(
   `PlanVisibleId` INT NOT NULL  AUTO_INCREMENT,
   `PlanId` INT NOT NULL,
   `VisibleTo` INT NOT NULL,
   PRIMARY KEY(`PlanVisibleId`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblResourceProperties`
(
   `ResourcePropertyID` INT NOT NULL,
   `ResourceID` INT NOT NULL,
   `ResourcePropertyName` VARCHAR(50) NOT NULL,
   `ResourcePropertyDescName` VARCHAR(100) NOT NULL,
   `ResourcePropertyDesc` LONGTEXT,
   `IsBinary` BOOLEAN NOT NULL,
   `DisplayIndex` INT NOT NULL,
   `DefaultValue` INT NOT NULL,
   PRIMARY KEY(`ResourcePropertyID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

INSERT INTO `tblResourceProperties` (`ResourcePropertyID`,`ResourceID`,`ResourcePropertyName`,`ResourcePropertyDescName`,`ResourcePropertyDesc`,`IsBinary`,`DisplayIndex`,`DefaultValue`)  VALUES (1,8,'mailboxsize','Mailbox Size','Mailbox Size',0,5,50); 

go
CREATE TABLE IF NOT EXISTS `tblMailDomains`
(
   `MailDomainID` INT NOT NULL  AUTO_INCREMENT,
   `MailDomainName` VARCHAR(50) NOT NULL,
   `WebsiteID` INT NOT NULL,
   `MailboxUsage` INT NOT NULL,
   `ServerRoleID` INT,
   `DiskSpaceUsage` DOUBLE   NOT NULL  DEFAULT 0,
   `DistributionListUsage` INT   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`MailDomainID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblUserConsumedResources`
(
   `ConsumedResourceID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `ResourceID` INT NOT NULL,
   `ConsumedQuantity` INT NOT NULL DEFAULT 0,
   PRIMARY KEY(`ConsumedResourceID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblSecondaryDNSServer`
(
   `SDNSID` INT NOT NULL  AUTO_INCREMENT,
   `DNSID` INT NOT NULL,
   `ServerRoleID` INT NOT NULL,
   PRIMARY KEY(`SDNSID`)
)ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblCountries`
(
   `CountryID` INT NOT NULL  AUTO_INCREMENT,
   `CountryName` VARCHAR(250),
   PRIMARY KEY(`CountryID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

INSERT INTO tblCountries(CountryName) VALUES ('United States'),('Afghanistan'),('Albania'),('Algeria'),('American Samoa'),('Andorra'),('Angola'),('Anguilla'),('Antarctica'),('Antigua And Barbuda'),('Argentina'),('Armenia'),('Aruba'),('Australia'),('Austria'),('Azerbaijan'),('Bahamas'),('Bahrain'),('Bangladesh'),('Barbados'),('Belarus'),('Belgium'),('Belize'),('Benin'),('Bermuda'),('Bhutan'),('Bolivia'),('Bosnia And Herzegowina'),('Botswana'),('Bouvet Island'),('Brazil'),('British Indian Ocean Territory'),('Brunei Darussalam'),('Bulgaria'),('Burkina Faso'),('Burundi'),('Cambodia'),('Cameroon'),('Canada'),('Cape Verde'),('Cayman Islands'),('Central African Republic'),('Chad'),('Chile'),('China'),('Christmas Island'),('Cocos (Keeling) Islands'),('Colombia'),('Comoros'),('Congo'),('Cook Islands'),('Costa Rica'),('Cote D ivoire'),('Croatia'),('Cuba'),('Cyprus'),('Czech Republic'),('Denmark'),('Djibouti'),('Dominica'),('Dominican Republic'),('East Timor'),('Ecuador'),('Egypt'),('El Salvador'),('Equatorial Guinea'),('Eritrea'),('Estonia'),('Ethiopia'),('Falkland Islands (Malvinas)'),('Faroe Islands'),('Fiji'),('Finland'),('France'),('France, Metropolitan'),('French Guiana'),('French Polynesia'),('French Southern Territories'),('Gabon'),('Gambia'),('Georgia'),('Germany'),('Ghana'),('Gibraltar'),('Greece'),('Greenland'),('Grenada'),('Guadeloupe'),('Guam'),('Guatemala'),('Guinea'),('Guinea-bissau'),('Guyana'),('Haiti'),('Heard And Mc Donald Islands'),('Honduras'),('Hong Kong'),('Hungary'),('Iceland'),('India'),('Indonesia'),('Iran (Islamic Republic Of)'),('Iraq'),('Ireland'),('Israel'),('Italy'),('Jamaica'),('Japan'),('Jordan'),('Kazakhstan'),('Kenya'),('Kiribati'),('Korea (North)'),('Korea (South)'),('Kuwait'),('Kyrgyzstan'),('Laos'),('Latvia'),('Lebanon'),('Lesotho'),('Liberia'),('Libya'),('Liechtenstein'),('Lithuania'),('Luxembourg'),('Macau'),('Macedonia'),('Madagascar'),('Malawi'),('Malaysia'),('Maldives'),('Mali'),('Malta'),('Marshall Islands'),('Martinique'),('Mauritania'),('Mauritius'),('Mayotte'),('Mexico'),('Micronesia'),('Moldova'),('Monaco'),('Mongolia'),('Montserrat'),('Morocco'),('Mozambique'),('Myanmar'),('Namibia'),('Nauru'),('Nepal'),('Netherlands'),('Netherlands Antilles'),('New Caledonia'),('New Zealand'),('Nicaragua'),('Niger'),('Nigeria'),('Niue'),('Norfolk Island'),('Northern Mariana Islands'),('Norway'),('Oman'),('Pakistan'),('Palau'),('Panama'),('Papua New Guinea'),('Paraguay'),('Peru'),('Philippines'),('Pitcairn'),('Poland'),('Portugal'),('Puerto Rico'),('Qatar'),('Reunion'),('Romania'),('Russian Federation'),('Rwanda'),('Saint Kitts And Nevis'),('Saint Lucia'),('Saint Vincent And The Grenadines'),('Samoa'),('Saudi Arabia'),('Senegal'),('Seychelles'),('Sierra Leone'),('Singapore'),('Slovakia (Slovak Republic)'),('Slovenia'),('Solomon Islands'),('Somalia'),('South Africa'),('S. Georgia  The S. Sandwich Islands'),('Spain'),('Sri Lanka'),('St. Helena'),('St. Pierre And Miquelon'),('Sudan'),('Suriname'),('Svalbard And Jan Mayen Islands'),('Swaziland'),('Sweden'),('Switzerland'),('Syrian Arab Republic'),('Taiwan, Province Of China'),('Tajikistan'),('Tanzania'),('Thailand'),('Togo'),('Tokelau'),('Tonga'),('Trinidad And Tobago'),('Tunisia'),('Turkey'),('Turkmenistan'),('Turks And Caicos Islands'),('Tuvalu'),('Uganda'),('Ukraine'),('United Arab Emirates'),('United Kingdom'),('United States Minor Outlying Islands'),('Uruguay'),('Uzbekistan'),('Vanuatu'),('Vatican City State (Holy See)'),('Venezuela'),('Viet Nam'),('Virgin Islands (British)'),('Virgin Islands (U.S.)'),('Wallis And Futuna Islands'),('Western Sahara'),('Yemen'),('Yugoslavia'),('Zambia'),('Zimbabwe');


go
CREATE TABLE IF NOT EXISTS `tblDiskUsageSettings`
(
   `DiskUsageID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `EmailDUReport` BOOLEAN,
   `DUReportFreq` INT,
   `DUWarningEmail` BOOLEAN,
   `DULimit` DOUBLE   DEFAULT 0,
   `CCToOwner` BOOLEAN,
   `ThresholdLimit` DOUBLE   DEFAULT 0,
   `ThresholdAction` INT,
   `AddOnQuantity` INT,
   `DUCalcFreq` INT,
   `DUCalcStartTime` INT,
   PRIMARY KEY(`DiskUsageID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblBandwidth`
(
   `ConsumedID` INT NOT NULL  AUTO_INCREMENT,
   `WebsiteID` INT   NOT NULL  DEFAULT 0,
   `BandwidthUsage` DOUBLE   NOT NULL  DEFAULT 0,
   `LastUpdated` TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
   `DayPeriod` INT   NOT NULL  DEFAULT 0,
   `MonthPeriod` INT   NOT NULL  DEFAULT 0,
   `YearPeriod` INT   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`ConsumedID`)
)  ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblMailDeliverySettings`
(
   `MailDeliverySettingID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `MailDeliveryType` VARCHAR(255) NOT NULL,
   `DNSServer` VARCHAR(255),
   `SMTPServer` VARCHAR(255),
   `FromAddress`VARCHAR(255),
   `SMTPAuth` tinyint(1)   NOT NULL  DEFAULT 0,
   `AuthUser` VARCHAR(255),
   `AuthPassword` VARCHAR(255),
   PRIMARY KEY(`MailDeliverySettingID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblServerRoles`
(
   `ServerRoleID` INT NOT NULL  AUTO_INCREMENT,
   `ServerID` INT   NOT NULL  DEFAULT 0,
   `RoleID` INT   NOT NULL  DEFAULT 0,
   `ServerRoleConfiguration` mediumtext,	
   `RoleCapacity` INT   DEFAULT 0,
   `BackupRoleCapacity` INT   DEFAULT 0,
   `LastHeartBeatReport` DATETIME,
   `IsResellerOnly` BOOLEAN   NOT NULL  DEFAULT 0,
   `IsbackupResellerOnly` BOOLEAN   NOT NULL  DEFAULT 0,
   `RoleStatus` BOOLEAN NOT NULL DEFAULT 0,	
   PRIMARY KEY(`ServerRoleID`)
)  ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblDatabases`
(
   `DatabaseID` INT NOT NULL  AUTO_INCREMENT,
   `DatabaseName` VARCHAR(100) NOT NULL,
   `DatabaseType` VARCHAR(50)   NOT NULL  DEFAULT 'MYSQL',
   `DatabaseUserName` VARCHAR(100) NOT NULL,
   `DatabaseUserPassword` VARCHAR(100) NOT NULL,	
   `DatabasePath` VARCHAR(256),
   `WebsiteID` INT NOT NULL,
   `ServerRoleID` INT NOT NULL,
   `DiskSpaceUsage` DOUBLE   NOT NULL  DEFAULT 0,
   `InstanceName` VARCHAR(256),
   PRIMARY KEY(`DatabaseID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblTempVDir`
(
   `TempVDirID` INT NOT NULL  AUTO_INCREMENT,
   `VDirName` VARCHAR(50),
   `MasterWebsiteID` INT,
   `SlaveWebsiteID` INT,
   PRIMARY KEY(`TempVDirID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblSoldPlans`
(
   `SoldPlanID` INT NOT NULL  AUTO_INCREMENT,
   `PlanID` INT NOT NULL,
   `NextInvoice` DATETIME DEFAULT NULL,
   `UserID` INT   NOT NULL  DEFAULT 0,
   `SetUpPriceDiscount` DOUBLE   NOT NULL  DEFAULT 0,
   `RecurringPriceDiscount` DOUBLE   NOT NULL  DEFAULT 0,
   `DateCreated` DATETIME NOT NULL,
   `CurrStatus` BOOLEAN   NOT NULL  DEFAULT 1,
   `IsDeleted` BOOLEAN   NOT NULL  DEFAULT 0,
   `LastRecurringPriceAlterDate` DATETIME DEFAULT NULL,
   `AlertSent` BOOLEAN   NOT NULL  DEFAULT 0,
   `RecurringDuration` INT   NOT NULL  DEFAULT 1,
   `PaidTill` TIMESTAMP,
   `ReminderSent` BOOLEAN   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`SoldPlanID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblMailOnlyMailDomains`
(
   `MailDomainID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `ServerRoleID` INT NOT NULL,
   `MailDomainName` NATIONAL VARCHAR(50) NOT NULL,
   `MailboxUsage` INT   NOT NULL  DEFAULT 0,
   `DistributionListUsage` INT   NOT NULL  DEFAULT 0,
   `DiskSpaceUsage` DOUBLE   NOT NULL  DEFAULT 0.0,
   PRIMARY KEY(`MailDomainID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblStates`
(
   `StateID` INT NOT NULL  AUTO_INCREMENT,
    `CountryID` INT NOT NULL ,
   `StateName` VARCHAR(250),
   PRIMARY KEY(`StateID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

INSERT INTO tblStates(CountryID,StateName) VALUES (1,'Alabama'),(1,'Alaska'),(1,'Arizona'),(1,'Arkansas'),(1,'California'),(1,'Colorado'),(1,'Connecticut'),(1,'Delaware'),(1,'Florida'),(1,'Georgia'),(1,'Hawaii'),(1,'Idaho   State'),(1,'Illinois'),(1,'Indiana'),(1,'Iowa'),(1,'Kansas'),(1,'Kentucky'),(1,'Louisiana'),(1,'Maine'),(1,'Maryland'),(1,'Massachusetts'),(1,'Michigan'),(1,'Minnesota'),(1,'Mississippi'),(1,'Missouri'),(1,'Montana'),(1,'Nebraska'),(1,'Nevada'),(1,'New Hampshire'),(1,'New Jersey'),(1,'New Mexico'),(1,'New York'),(1,'North Carolina'),(1,'North Dakota'),(1,'Ohio'),(1,'Oklahoma'),(1,'Oregon'),(1,'Pennsylvania'),(1,'Rhode Island'),(1,'South Carolina'),(1,'South Dakota'),(1,'Tennessee'),(1,'Texas'),(1,'Utah'),(1,'Vermont'),(1,'Virginia'),(1,'Washington'),(1,'West Virginia'),(1,'Wisconsin'),(1,'Wyoming');


go
CREATE TABLE IF NOT EXISTS `tblServers`
(
   `ServerID` INT NOT NULL  AUTO_INCREMENT,
   `ServerName` VARCHAR(100) NOT NULL,
   `ServerIP` VARCHAR(50) NOT NULL,
   `ServerType` VARCHAR(50)   NOT NULL  DEFAULT 'Linux',
   `WebRoot` VARCHAR(100),
   `IsMaster` BOOLEAN   NOT NULL  DEFAULT 0,
   `IsDeleted` BOOLEAN   NOT NULL  DEFAULT 0,
   `Status` BOOLEAN   NOT NULL  DEFAULT 1,
   `BuildNo` VARCHAR(50),
   PRIMARY KEY(`ServerID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblUsersProfile`
(
   `UserProfileID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `FirstName` VARCHAR(100),
   `LastName` VARCHAR(100),
   `EmailAddress` VARCHAR(100),
   `Country` INT,
   `State` INT,
   `City` VARCHAR(50),
   `StreetAddress` VARCHAR(100),
   `StreetAddress2` VARCHAR(100),
   `PostalCode` VARCHAR(50),
   `PhoneNo` VARCHAR(50),
   `FaxNo` VARCHAR(50),
   `Company` VARCHAR(250),
   `SocialSecurityNo` VARCHAR(50),
   PRIMARY KEY(`UserProfileID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblResourcePropertiesLimits`
(
   `ResourcePropertyLimitID` INT NOT NULL  AUTO_INCREMENT,
   `ResourcePropertyID` INT NOT NULL,
   `UserID` INT NOT NULL,
   `MaximumValue` INT   NOT NULL  DEFAULT 0,
   `MinimumValue` INT   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`ResourcePropertyLimitID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblNATManager`
(
   `NATID` INT NOT NULL  AUTO_INCREMENT,
   `ExternalIP` VARCHAR(100) NOT NULL,
   `InternalIP` VARCHAR(100) NOT NULL,
   `ServerID` INT,
   PRIMARY KEY(`NATID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblDNSServer`
(
   `DNSID` INT NOT NULL  AUTO_INCREMENT,
   `WebsiteID` INT NOT NULL,
   `ServerRoleID` INT NOT NULL,
   `WebsiteZoneName` VARCHAR(100),
   PRIMARY KEY(`DNSID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblPlanResourceQty`
(
   `PlanID` INT NOT NULL,
   `ResourceID` INT NOT NULL,
   `QtyIncluded` INT NOT NULL
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

INSERT INTO tblPlanResourceQty values (1,1,1),(1,2,1),(1,3,1),(1,4,1),(1,5,250),(1,6,500),(1,7,1),(1,8,10),(1,9,5),(1,10,1),(1,11,1),(1,12,1),(1,13,5),(1,14,0),(1,15,0),(1,16,0),(1,17,0),(1,18,0),(1,19,0),(1,20,0),(1,21,0),(1,22,0),(1,23,0),(1,24,0),(2,1,-1),(2,2,-1),(2,3,-1),(2,4,-1),(2,5,-1),(2,6,-1),(2,7,-1),(2,8,-1),(2,9,-1),(2,10,-1),(2,11,-1),(2,12,-1),(2,13,-1),(2,14,1),(2,15,1),(2,16,1),(2,17,1),(2,18,1),(2,19,1),(2,20,1),(2,21,1),(2,22,1),(2,23,1),(2,24,1);

go
CREATE TABLE IF NOT EXISTS `tblWebsites`
(
   `WebsiteID` INT NOT NULL  AUTO_INCREMENT,
   `WebsiteName` VARCHAR(50) NOT NULL,
   `OwnerID` INT NOT NULL,
   `IsNameBased` BOOLEAN   NOT NULL  DEFAULT 1,
   `IsSubDomain` BOOLEAN   NOT NULL  DEFAULT 0,
   `SoldPlanID` INT NOT NULL,
   `IPAddress` VARCHAR(50) NOT NULL,
   `DiskSpaceUsage` DOUBLE   DEFAULT 0,
   `AdminVDirAccess` BOOLEAN   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`WebsiteID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblUsersServers`
(
   `UserID` INT   NOT NULL  DEFAULT 0,
   `ServerRoleID` INT   NOT NULL  DEFAULT 0,
   `BackupServerID` INT   DEFAULT 0,
   `BornHere` BOOLEAN   NOT NULL  DEFAULT 0,
   `IsLive` BOOLEAN   NOT NULL  DEFAULT 1
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblWebsiteResources`
(
   `WebsiteRecouceID` INT NOT NULL  AUTO_INCREMENT,
   `WebsiteID` INT   NOT NULL  DEFAULT 0,
   `DotnetEnabled` BOOLEAN   NOT NULL  DEFAULT 0,
   `CFMXEnabled` BOOLEAN   NOT NULL  DEFAULT 0,
   `PHPEnabled` BOOLEAN   NOT NULL  DEFAULT 0,
   `PerlEnabled` BOOLEAN   NOT NULL  DEFAULT 0,
   `StatsEnabled` BOOLEAN   NOT NULL  DEFAULT 0,
   `Status` BOOLEAN   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`WebsiteRecouceID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblRegisteredServers`
(
   `RegistrationID` INT NOT NULL  AUTO_INCREMENT,
   `ServerName` VARCHAR(100) NOT NULL,
   `ServerIP`  VARCHAR(50) NOT NULL,
   `ServerType` VARCHAR(50)   DEFAULT 'Linux',
   PRIMARY KEY(RegistrationID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblPlanMailServerType`
(
   `PlanID` INT NOT NULL,
   `MailServerType` VARCHAR(50) NOT NULL
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblBandwidthUsageSettings`
(
   `BandwidthUsageID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `EmailBWReport` tinyint(1),
   `BWReportFreq` INT,
   `BWWarningEmail` tinyint(1),
   `BWWarningLimit` DOUBLE DEFAULT 0,
   `CCToOwner` tinyint(1),
   `ThresholdLimit` DOUBLE DEFAULT 0,
   `ThresholdAction` INT,
   `BandwidthCalcFreq` INT,
   `AddonQuantity` INT,
   `BandwidthCalcStartTime` INT,
   PRIMARY KEY(`BandwidthUsageID`)
)  ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblMailTemplates`
(
   `MailTemplateId` INT NOT NULL  AUTO_INCREMENT,
   `MailName` VARCHAR(100) NOT NULL,
   `LanguageID` INT NOT NULL,
   `Body` LONGTEXT,
   `Subject` VARCHAR(1000),
   `UserId` INT NOT NULL,
   `DefaultOn` tinyint(1)   NOT NULL  DEFAULT 0,
   `DisplayLevel` INT   NOT NULL  DEFAULT 2,
   `DisplayIndex` INT   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`MailTemplateId`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go
INSERT INTO tblMailTemplates (`MailName`, `LanguageID`,`Body`,`Subject`,`UserId`,`DefaultOn`,`DisplayLevel`,`DisplayIndex`) VALUES ("diskreport",1,"<TABLE cellSpacing=0 cellPadding=0 width=""90%"" align=center border=0>
<TBODY>
<TR vAlign=top>
<TD style=""FONT-SIZE: 30px"" width=""50%""><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc size=5>Disk Usage 
Report</FONT></TD></TR>
<TR>
<TD>
<HR noShade SIZE=1>
</TD></TR>
<TR>
<TD 
style=""BORDER-RIGHT: #0066cc 1px solid; PADDING-RIGHT: 0px; BORDER-TOP: #0066cc 1px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; VERTICAL-ALIGN: top; BORDER-LEFT: #0066cc 1px solid; PADDING-TOP: 0px; BORDER-BOTTOM: #0066cc 1px solid"">
<TABLE cellSpacing=1 cellPadding=5 width=850 align=center bgColor=#ffffff 
border=0>
<TBODY>
<TR style=""BACKGROUND-COLOR: #d3e6f8"">
<TD width=""100%"">&nbsp;</TD></TR>
<TR>
<TD align=left bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Dear 
<!--CUSTOMER_NAME-->, <BR><BR>Below is the scheduled disk utilization 
report generated on <!--DATE-->.</FONT></TD></TR>
<TR>
<TD align=left><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 
size=2><B>Allocated / Utilized Disk </B></FONT></TD></TR>
<TR>
<TD>
<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">
<TBODY>
<TR>
<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR>
<TR>
<TD align=left bgColor=#ffffff colSpan=2 height=15><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>&nbsp;</FONT></TD></TR>
<TR>
<TD colSpan=2>
<TABLE style=""BACKGROUND-COLOR: #cccccc"" cellSpacing=1 cellPadding=1 width=""97%"" 
align=center border=0>
                          <TBODY>
                            <TR style=""BACKGROUND-COLOR: #d3e6f8""> 
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc size=2>Web 
                                </FONT></TD>
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 
size=2>Mail</FONT></TD>
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 
size=2>Database</FONT></TD>
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 
size=2>Total Consumed</FONT></TD>
<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 
size=2>Total Purchased</FONT></TD>
<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 
size=2>Remaining</FONT></TD>
                            </TR>
                            <TR  style=""BACKGROUND-COLOR: #f9f9f9""> 
                              <TD height=20><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
                                <!--WEB_CONSUMED-->
                                </FONT></TD>
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
                                <!--MAIL_CONSUMED-->
                                </FONT></TD>
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
                                <!--DATABASE_CONSUMED-->
                                </FONT></TD>
                              <TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
                                <!--TOTAL_CONSUMED-->
                                </FONT></TD>
				<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
                                <!--TOTAL_PURCHASED-->
                                </FONT></TD>
				<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
                                <!--REMAINING-->
                                </FONT></TD>
                            </TR>
                          </TBODY>
                        </TABLE>
                        <FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2><BR>Regards, <BR>Technical 
Support Team.</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif""><BR><FONT 
size=2><!--OWNER_COMPANY--></FONT></FONT></TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE>","Disk Usage Report",0,0,2,15),("bandwidthreport",1,"<TABLE cellSpacing=0 cellPadding=0 width=""90%"" align=center border=0>

<TBODY>

<TR vAlign=top>

<TD style=""FONT-SIZE: 30px"" width=""50%""><FONT 

face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc size=5>Bandwidth 

Usage Report</FONT></TD></TR>

<TR>

<TD>

<HR noShade SIZE=1>

</TD></TR>

<TR>

<TD 

style=""BORDER-RIGHT: #0066cc 1px solid; PADDING-RIGHT: 0px; BORDER-TOP: #0066cc 1px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; VERTICAL-ALIGN: top; BORDER-LEFT: #0066cc 1px solid; PADDING-TOP: 0px; BORDER-BOTTOM: #0066cc 1px solid"">

<TABLE cellSpacing=1 cellPadding=5 width=850 align=center bgColor=#ffffff 

border=0>

<TBODY>

<TR style=""BACKGROUND-COLOR: #d3e6f8"">

<TD width=""100%"">&nbsp;</TD></TR>

<TR>

<TD align=left bgColor=#ffffff><FONT 

face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Dear 

<!--CUSTOMER_NAME-->, <BR><BR>Below is the scheduled bandwidth utilization report generated on <!--DATE-->.</FONT></TD></TR>

<TR>

<TD align=left><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 

size=2><B>Allocated / Utilized Bandwidth</B></FONT></TD></TR>

<TR>

<TD>

<TABLE height=205 cellSpacing=0 cellPadding=0 width=""100%"">

<TBODY>

<TR>

<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR>

<TR>

<TD align=left bgColor=#ffffff colSpan=2 height=15><FONT 

face=""Verdana, Arial, Helvetica, sans-serif"" size=2>&nbsp;</FONT></TD></TR>

<TR>

<TD height=""186"" colSpan=2>

<TABLE style=""BACKGROUND-COLOR: #cccccc"" cellSpacing=1 cellPadding=1 width=""97%"" 

align=center border=0>

<TBODY>

<TR style=""BACKGROUND-COLOR: #d3e6f8"">

<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 

size=2>Allocated</FONT></TD>

<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 

size=2>Consumed</FONT></TD>

<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc 

size=2>Remaining</FONT></TD></TR>

<TR  style=""BACKGROUND-COLOR: #f9f9f9"">

<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2><!--ALLOCATED--></FONT></TD>

<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2><!--CONSUMED--></FONT></TD>

<TD><FONT face=""Verdana, Arial, Helvetica, sans-serif"" 

size=2><!--REMAINING--></FONT></TD></TR>

<!--WEBADMIN_START-->

</TBODY></TABLE><FONT 

face=""Verdana, Arial, Helvetica, sans-serif"" size=2><BR>

                        Regards, <BR>

                        Technical Support Team.</FONT><FONT size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><BR>

                        <!--OWNER_COMPANY--></--OWNER_COMPANY--></FONT></TD>

                    </TR></TBODY></TABLE></TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE>","Bandwidth Usage Report",0,0,2,14),("accountsetup",1,"<TABLE cellSpacing=0 cellPadding=0 width=""90%"" align=center border=0>

<TBODY>

<TR vAlign=top>

<TD style=""FONT-SIZE: 30px"" width=""50%""><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc size=5>Account Setup </FONT></TD></TR>

<TR>

<TD>

<HR noShade SIZE=1>

</TD></TR>

<TR>

<TD style=""BORDER-RIGHT: #0066cc 1px solid; PADDING-RIGHT: 0px; BORDER-TOP: #0066cc 1px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; VERTICAL-ALIGN: top; BORDER-LEFT: #0066cc 1px solid; PADDING-TOP: 0px; BORDER-BOTTOM: #0066cc 1px solid"">

<TABLE cellSpacing=1 cellPadding=5 width=850 align=center bgColor=#ffffff border=0>

<TBODY>

<TR style=""BACKGROUND-COLOR: #d3e6f8"">

<TD colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc>&nbsp;</FONT></TD></TR>

<TR>

<TD align=left bgColor=#ffffff colSpan=2>

<P><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Dear <!--CUSTOMER_NAME-->;, <BR><BR></FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Thank you for signing-up for web hosting. Your Hosting Account has been created and configured along with all the services.</FONT></P></TD></TR>

<TR>

<TD align=left colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif""><B><FONT color=#0066cc size=2>Customer Information</FONT></B></FONT> </TD></TR>

<TR>

<TD colSpan=2>

<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">

<TBODY>

<TR>

<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR></TBODY></TABLE></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Customer Name</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2> :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--CUSTOMER_NAME--></FONT></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Address :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--CUSTOMER_ADDRESS--></FONT></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Email Address :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--EMAIL_ADDRESS--></FONT></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Phone :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--CUSTOMER_PHONE--></FONT></TD></TR>

<TR>

<TD align=left bgColor=#ffffff colSpan=2 height=15></TD></TR>

<TR>

<TD align=left colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif""><B><FONT color=#0066cc size=2>Control Panel Information</FONT></B></FONT></TD></TR>

<TR>

<TD colSpan=2>

<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">

<TBODY>

<TR>

<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR></TBODY></TABLE></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Control Panel URL</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2> :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><A href=""<!--CONTROL_PANEL_URL-->"" target=_blank><!--CONTROL_PANEL_URL--> </A></FONT></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Login Name :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--LOGIN_NAME--> </FONT></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Password :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--LOGIN_PASSWORD--></FONT></TD></TR>

<TR>

<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Hosting Package :</FONT></TD>

<TD width=""66%"" bgColor=#ffffff><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><!--PLAN_NAME--> </FONT></TD></TR>

<TR>

<TD colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2><BR>Regards, <BR>Technical Support Team.</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif""><BR><FONT size=2><!--OWNER_COMPANY--></FONT></FONT></TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE>","Account Setup",0,0,2,1),("domaincreation",1,"<TABLE cellSpacing=0 cellPadding=0 width=""90%"" align=center border=0>
<TBODY>
<TR vAlign=top>
<TD style=""FONT-SIZE: 30px"" width=""50%""><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc size=5>Domain 
Creation </FONT></TD></TR>
<TR>
<TD>
<HR noShade SIZE=1>
</TD></TR>
<TR>
<TD 
style=""BORDER-RIGHT: #0066cc 1px solid; PADDING-RIGHT: 0px; BORDER-TOP: #0066cc 1px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; VERTICAL-ALIGN: top; BORDER-LEFT: #0066cc 1px solid; PADDING-TOP: 0px; BORDER-BOTTOM: #0066cc 1px solid"">
<TABLE cellSpacing=1 cellPadding=5 width=850 align=center bgColor=#ffffff 
border=0>
<TBODY>
<TR style=""BACKGROUND-COLOR: #d3e6f8"">
<TD colSpan=2>&nbsp;</TD></TR>
<TR>
              <TD align=left bgColor=#ffffff colSpan=2> <P><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Dear 
                  <!--CUSTOMER_NAME-->, <BR>
                  <BR>
                  </FONT><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Thank you for signing-up for 
                  web hosting. Your Hosting Account has been created and configured 
                  along with all the services. Please note down the account information 
                  for <!--DOMAIN_NAME-->.<B></B></FONT></P></TD></TR>
<TR>
<TD align=left colSpan=2><FONT 
face=""Verdana, Arial, Helvetica, sans-serif""><B><FONT color=#0066cc 
size=2>Control Panel&nbsp;Information</FONT></B></FONT></TD></TR>
<TR>
<TD colSpan=2>
<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">
<TBODY>
<TR>
<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR></TBODY></TABLE></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Control Panel URL 
</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2>:</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2><A 
href=""<!--CONTROL_PANEL_URL-->"" target=_blank><!--CONTROL_PANEL_URL--> 
</A></FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Login Name 
:</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--LOGIN_NAME--> </FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Password 
:</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--LOGIN_PASSWORD--></FONT></TD></TR>
<TR>
<TD align=left bgColor=#ffffff colSpan=2 height=15><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>&nbsp;</FONT></TD></TR>
<TR>
<TD align=left colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif"" 
size=2><B><FONT color=#0066cc>Domain Information</FONT></B></FONT><FONT 
face=""Verdana, Arial, Helvetica, sans-serif""><B></B></FONT></TD></TR>
<TR>
<TD colSpan=2>
<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">
<TBODY>
<TR>
<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR></TBODY></TABLE></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Domain Name 
:</FONT></TD>
<TD align=left width=""66%""><FONT face=""Verdana, Arial, Helvetica, sans-serif"" 
color=#000000 size=2><A href=""<!--DOMAIN_NAME-->"" 
target=_blank><!--DOMAIN_NAME--> </A></FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Instant Access 
:</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--TEMP_DOMAIN_NAME--> </FONT></TD></TR>
<TR>
<TD align=left bgColor=#ffffff colSpan=2 height=15><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>&nbsp;</FONT></TD></TR>
<!--MAILINFO-START-->
<TR>
<TD align=left colSpan=2><FONT 
face=""Verdana, Arial, Helvetica, sans-serif""><B><FONT color=#0066cc size=2>Mail 
Access Information</FONT></B></FONT><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2><B></B></FONT><FONT 
face=""Verdana, Arial, Helvetica, sans-serif""><B></B></FONT></TD></TR>
<TR>
<TD colSpan=2>
<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">
<TBODY>
<TR>
<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR></TBODY></TABLE></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>SMTP/POP 
Server Address</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> 
: </FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--SMTPSERVER_ADDRESS--> </FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Email Client URL</FONT><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2> :</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" 
size=2><!--EMAIL_CLIENT_URL--></FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Login For 
Email Administration :</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--EMAIL_LOGIN--></FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Password 
:</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--EMAIL_PASSWORD--></FONT></TD></TR>
<TR>
<TD align=left bgColor=#ffffff colSpan=2 height=15><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2>&nbsp;</FONT></TD></TR>
<!--MAILINFO-END-->
<!--NSINFO-START-->
<TR>
<TD align=left colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif"" 
color=#0066cc size=2><B>NameServer Information</B></FONT></TD></TR>
<TR>
<TD colSpan=2>
<TABLE height=1 cellSpacing=0 cellPadding=0 width=""100%"">
<TBODY>
<TR>
<TD bgColor=#dfdfdf><IMG height=1 width=1></TD></TR></TBODY></TABLE></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff height=27><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>NameServer 
1</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2> : 
</FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--NS1--> </FONT></TD></TR>
<TR>
<TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>NameServer 
2</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2> 
: </FONT></TD>
<TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--NS2--> </FONT></TD></TR>
<!--NS3_START-->
<TR>
              <TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>NameServer 3 
                : </FONT></TD>
              <TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--NS3--> </FONT></TD>
            </TR>
<!--NS3_END-->
<!--NS4_START-->
<TR>
              <TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>NameServer 4 
                : </FONT></TD>
              <TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--NS4--> </FONT></TD>
            </TR>
<!--NS4_END-->
<!--NSINFO-END-->
<TR>
<TD align=left bgColor=#ffffff colSpan=2><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2><BR>Regards, <BR>Technical 
Support Team.</FONT><FONT face=""Verdana, Arial, Helvetica, sans-serif""><BR><FONT 
size=2><!--OWNER_COMPANY--></FONT></FONT> 
</TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE>","Domain Creation",0,0,2,1),("forgotpassword",1,"<TABLE cellSpacing=0 cellPadding=0 width=""90%"" align=center border=0>
	<TBODY>
		<TR vAlign=top>
		   
      <TD style=""FONT-SIZE: 30px"" width=""50%""><FONT color=#0066cc size=5 face=""Verdana, Arial, Helvetica, sans-serif"">Password 
        Recovery </FONT></TD>
		</TR>
		<TR>
			<TD>
			<HR noShade SIZE=1>
			</TD>
		</TR>
		
		<tr>
			<TD style=""BORDER-RIGHT: #0066cc 1px solid; PADDING-RIGHT: 0px; BORDER-TOP: #0066cc 1px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; VERTICAL-ALIGN: top; BORDER-LEFT: #0066cc 1px solid; PADDING-TOP: 0px; BORDER-BOTTOM: #0066cc 1px solid"" >
				<TABLE cellSpacing=1 cellPadding=5 align=center bgColor=#ffffff border=0 width=850>
          <TR style=""BACKGROUND-COLOR: #d3e6f8""> 
            <TD width=""100%"">&nbsp;</TD>
          </TR>
          <TR> 
            <TD align=left bgColor=#ffffff><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif"">Dear 
              <!--CUSTOMER_NAME-->, <br/>
              <br/>
              </font> <FONT size=2 face=""Verdana, Arial, Helvetica, sans-serif"">Someone, 
              may be you, has requested for password retrieval using Control Panel</FONT> 
              <FONT size=2 face=""Verdana, Arial, Helvetica, sans-serif"">. To receive 
              the password, please click on the link</FONT> 
              <P><font face=""Verdana, Arial, Helvetica, sans-serif""><A href=""<!--LINK-->""><FONT size=2><!--LINK--></FONT></A></font></P>
              <P><FONT size=2 face=""Verdana, Arial, Helvetica, sans-serif"">or 
                just copy and paste this URL in your browser<br/><br/></FONT><FONT size=2 face=""Verdana, Arial, Helvetica, sans-serif""><!--LINK--></FONT> 
              </P>
              <P><FONT size=2 face=""Verdana, Arial, Helvetica, sans-serif"">Regards, 
                <BR>
                Technical Support Team.</FONT><font face=""Verdana, Arial, Helvetica, sans-serif""><br/>
                <FONT size=2> <!--OWNER_COMPANY--></FONT></font></P></TD>
          </TR>
        </TABLE>
			</td>
		</tr>
	</TBODY>
</TABLE>","Forgot Password",0,0,2,18),("passwordrecovery",1,"<TABLE cellSpacing=0 cellPadding=0 width=""90%"" align=center border=0>
<TBODY>
<TR vAlign=top>
<TD style=""FONT-SIZE: 30px"" width=""50%""><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#0066cc size=5>Password 
Recovery </FONT></TD></TR>
<TR>
<TD>
<HR noShade SIZE=1>
</TD></TR>
<TR>
<TD 
style=""BORDER-RIGHT: #0066cc 1px solid; PADDING-RIGHT: 0px; BORDER-TOP: #0066cc 1px solid; PADDING-LEFT: 0px; PADDING-BOTTOM: 0px; VERTICAL-ALIGN: top; BORDER-LEFT: #0066cc 1px solid; PADDING-TOP: 0px; BORDER-BOTTOM: #0066cc 1px solid"">
<TABLE cellSpacing=1 cellPadding=5 width=850 align=center bgColor=#ffffff 
border=0>
          <TBODY>
            <TR style=""BACKGROUND-COLOR: #d3e6f8""> 
              <TD width=""100%"" colSpan=2>&nbsp;</TD>
            </TR>
            <TR> 
              <TD align=left bgColor=#ffffff colSpan=2> <P><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2>Dear 
                  <!--CUSTOMER_NAME-->, <BR>
                  <BR>
                  Your Control Panel password retrieval request was successful. 
                  For security reasons it is not possible for us to obtain your&nbsp;previous 
                  password, therefore a new password has been assigned to you.</FONT></P>
                <P><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><FONT face=""Verdana, Arial, Helvetica, sans-serif"" size=2><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" size=2><SPAN 
style=""FONT-FAMILY: Symbol; mso-fareast-font-family: Symbol; mso-bidi-font-family: Symbol""><SPAN 
style=""mso-list: Ignore""><SPAN 
style=""FONT: 7pt 'Times New Roman'"">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                  </SPAN></SPAN></SPAN><SPAN style=""FONT-SIZE: 10pt; FONT-FAMILY: Verdana"">The 
                  new password is valid for the following accounts:</SPAN> <o:p></o:p></font></P>
                <P class=MsoNormal 
style=""MARGIN: 0in 0in 0pt 0.75in; TEXT-INDENT: -0.25in; mso-list: l0 level2 lfo1; mso-margin-top-alt: auto; mso-margin-bottom-alt: auto; tab-stops: list .75in""><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><SPAN 
style=""FONT-FAMILY: 'Courier New'; mso-fareast-font-family: 'Courier New'""><SPAN 
style=""mso-list: Ignore"">o<SPAN 
style=""FONT: 7pt 'Times New Roman'"">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </SPAN></SPAN></SPAN><SPAN style=""FONT-SIZE: 10pt; FONT-FAMILY: Verdana"">Control 
                  Panel account</SPAN></font></P>
                <P class=MsoNormal 
style=""MARGIN: 0in 0in 0pt 0.75in; TEXT-INDENT: -0.25in; mso-list: l0 level2 lfo1; mso-margin-top-alt: auto; mso-margin-bottom-alt: auto; tab-stops: list .75in""><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><SPAN 
style=""FONT-FAMILY: 'Courier New'; mso-fareast-font-family: 'Courier New'""><SPAN 
style=""mso-list: Ignore"">o<SPAN 
style=""FONT: 7pt 'Times New Roman'"">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </SPAN></SPAN></SPAN><SPAN style=""FONT-SIZE: 10pt; FONT-FAMILY: Verdana"">FTP 
                  account (if applicable)<BR>
                  <BR>
                  </SPAN><o:p></o:p></font></P>
                <P class=MsoNormal 
style=""MARGIN: 0in 0in 0pt 0.25in; TEXT-INDENT: -0.25in; mso-list: l0 level1 lfo1; mso-margin-top-alt: auto; mso-margin-bottom-alt: auto; tab-stops: list .25in""><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><SPAN 
style=""FONT-FAMILY: Symbol; mso-fareast-font-family: Symbol; mso-bidi-font-family: Symbol""><SPAN 
style=""mso-list: Ignore""><SPAN 
style=""FONT: 7pt 'Times New Roman'"">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
                  </SPAN></SPAN></SPAN><SPAN style=""FONT-SIZE: 10pt; FONT-FAMILY: Verdana"">The 
                  new password is NOT valid for the following accounts:<BR>
                  ( For these accounts, login to the Control Panel and then reset 
                  the password from appropriate section.) <BR>
                  <BR>
                  </SPAN><o:p></o:p></font></P>
                <P class=MsoNormal 
style=""MARGIN: 0in 0in 0pt 0.75in; TEXT-INDENT: -0.25in; mso-list: l0 level2 lfo1; mso-margin-top-alt: auto; mso-margin-bottom-alt: auto; tab-stops: list .75in""><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><SPAN 
style=""FONT-FAMILY: 'Courier New'; mso-fareast-font-family: 'Courier New'""><SPAN 
style=""mso-list: Ignore"">o<SPAN 
style=""FONT: 7pt 'Times New Roman'"">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </SPAN></SPAN></SPAN><SPAN style=""FONT-SIZE: 10pt; FONT-FAMILY: Verdana"">Mail 
                  Server account</SPAN></font></P>
                <P class=MsoNormal 
style=""MARGIN: 0in 0in 0pt 0.75in; TEXT-INDENT: -0.25in; mso-list: l0 level2 lfo1; mso-margin-top-alt: auto; mso-margin-bottom-alt: auto; tab-stops: list .75in""><font size=""2"" face=""Verdana, Arial, Helvetica, sans-serif""><SPAN 
style=""FONT-FAMILY: 'Courier New'; mso-fareast-font-family: 'Courier New'""><SPAN 
style=""mso-list: Ignore"">o<SPAN 
style=""FONT: 7pt 'Times New Roman'"">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </SPAN></SPAN></SPAN><SPAN style=""FONT-SIZE: 10pt; FONT-FAMILY: Verdana"">Serv-U 
                  account (if applicable)</SPAN></font></P></TD>
            </TR>
            <TR> 
              <TD align=left colSpan=2><FONT 
face=""Verdana, Arial, Helvetica, sans-serif""><B><FONT color=#0066cc 
size=2>Customer Information</FONT></B></FONT> </TD>
            </TR>
            <TR> 
              <TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Login Name :</FONT></TD>
              <TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--LOGIN_NAME--> </FONT></TD>
            </TR>
            <TR> 
              <TD noWrap align=left width=""34%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 size=2>Password :</FONT></TD>
              <TD width=""66%"" bgColor=#ffffff><FONT 
face=""Verdana, Arial, Helvetica, sans-serif"" color=#000000 
size=2><!--LOGIN_PASSWORD--></FONT></TD>
            </TR>
            <TR> 
              <TD colSpan=2><FONT face=""Verdana, Arial, Helvetica, sans-serif"" 
size=2><BR>
                Regards, <BR>
                Technical Support Team.<BR>
                <!--OWNER_COMPANY--></FONT></TD>
            </TR>
          </TBODY>
        </TABLE></TD></TR></TBODY></TABLE>","Password Recovery",0,0,2,19);



go
CREATE TABLE IF NOT EXISTS `tblViolatedResources`
(
   `ViolatedID` INT NOT NULL  AUTO_INCREMENT,
   `ResourceID` INT NOT NULL,
   `UserID` INT,
   `ActionID` INT NOT NULL,
   `Reason` VARCHAR(50) NOT NULL,
   PRIMARY KEY(`ViolatedID`)
)  ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE tblEmailFrequency
(
   `EmailFrequencyID` INT NOT NULL AUTO_INCREMENT,
   `EmailFrequency` INT,
   `EmailFrequencyDesc` VARCHAR(500),
   PRIMARY KEY(EmailFrequencyID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblEMails`
(
   `MailID` INT NOT NULL  AUTO_INCREMENT,
   `ToAddress` VARCHAR(256) NOT NULL,
   `FromAddress` VARCHAR(256) NOT NULL,
   `CCAddress` VARCHAR(500),
   `BCCAddress` VARCHAR(500),
   `MailSubject` VARCHAR(256) NOT NULL,
   `MailBody` LONGTEXT NOT NULL,
   `MailType` INT,
   `MailStatus` INT   DEFAULT 0,
   `RetryCount` INT   DEFAULT 0,
   `MailError` VARCHAR(500),
   `SentTime` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
   `OwnerId` INT,
   PRIMARY KEY(`MailID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblUsers`
(
   `UserID` INT NOT NULL  AUTO_INCREMENT,
   `UserName` VARCHAR(50) NOT NULL,
   `UserLevel` VARCHAR(50) NOT NULL,
   `UserPassword` VARCHAR(100) NOT NULL,
   `Description` VARCHAR(200),
   `OwnerID` INT   NOT NULL  DEFAULT 0,
   `IsDisabled` BOOLEAN   NOT NULL  DEFAULT 0,
   `IsDeleted` BOOLEAN   NOT NULL  DEFAULT 0,
   `SetupDate` TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
   `LastModifiedDate` TIMESTAMP,
   `SoldPlanID` INT NOT NULL DEFAULT 0,
   `TrashId` INT NOT NULL DEFAULT 0,
   `DateDeleted` DATETIME,
   `DiskspaceUsage` DOUBLE   NOT NULL  DEFAULT 0.0,
   `IsDedicated` tinyint(1) NOT NULL DEFAULT 0,	
   PRIMARY KEY(`UserID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE tblAllocatedIPs
(
   `IPID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   `ServerID` INT NOT NULL,
   `IPAddress` VARCHAR(50) NOT NULL,
   PRIMARY KEY(IPID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblPlans`
(
   `PlanID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT   NOT NULL  DEFAULT 0,
   `PlanName` VARCHAR(1000),
   `PromotionPrice` DECIMAL(19,2)   NOT NULL  DEFAULT 0,
   `PlanDesc` NATIONAL VARCHAR(4000),
   `RecurringPrice` DOUBLE   DEFAULT 0,
   `Status` INT   NOT NULL  DEFAULT 1,
   `PromotionDuration` INT   NOT NULL  DEFAULT 0,
   `RecurringDuration` INT   NOT NULL  DEFAULT 0,
   `SetupPrice` DOUBLE   NOT NULL  DEFAULT 0,
   `CancellationPolicy` VARCHAR(4000),
   `IsDeleted` BOOLEAN   NOT NULL  DEFAULT 0,
   `AutoSignupDisplay` BOOLEAN   NOT NULL  DEFAULT 1,
   `DisplayIndex` INT   DEFAULT 0,
   `MonthlyPrice` DOUBLE   NOT NULL  DEFAULT 0,
   `QuarterlyPrice` DOUBLE   NOT NULL  DEFAULT 0,
   `BiAnnualPrice` DOUBLE   NOT NULL  DEFAULT 0,
   `YearlyPrice` DOUBLE   NOT NULL  DEFAULT 0,
   `DefaultDuration` INT   NOT NULL  DEFAULT 1,
   `IsWindows` INT   NOT NULL  DEFAULT 1,
   `DefaultSetupDiscount` DOUBLE   DEFAULT 0,
   `DefaultRecurringDiscount` DOUBLE   DEFAULT 0,
   `PlanModeID` INT   NOT NULL  DEFAULT 1,
   PRIMARY KEY(`PlanID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

INSERT INTO tblPlans (UserID,PlanName,PromotionPrice,PlanDesc,RecurringPrice,Status,PromotionDuration,RecurringDuration,SetupPrice,CancellationPolicy,IsDeleted,AutoSignupDisplay,DisplayIndex,MonthlyPrice,QuarterlyPrice,BiAnnualPrice,YearlyPrice,DefaultDuration,IsWindows,DefaultSetupDiscount,DefaultRecurringDiscount,PlanModeID) values (1,'Basic Plan',0.0,'Default Basic Plan added by Hosting Controller.',0,1,0,0,0,'',0,0,0,0,0,0,0,0,0,0,0,1),
	(1,'Unlimited Plan',0.0,'Default Unlimited Plan added by Hosting Controller.',0,1,0,0,0,'',0,0,0,0,0,0,0,0,0,0,0,1);

go
CREATE TABLE tblActions
(
   `ActionID` INT NOT NULL  AUTO_INCREMENT,
   `ActionDesc` VARCHAR(100),
   `IsResellerAction` BOOLEAN   NOT NULL  DEFAULT 0,
   PRIMARY KEY(ActionID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblDatabaseUsers`
(
   `DatabaseUserID` INT NOT NULL  AUTO_INCREMENT,
   `DatabaseID` INT NOT NULL,
   `UserName` VARCHAR(100) NOT NULL,
   `UserPassword` VARCHAR(100) NOT NULL,	
   PRIMARY KEY(`DatabaseUserID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblDatabaseTasks`
(
   `DatabaseTaskID` INT NOT NULL  AUTO_INCREMENT,
   `DatabaseID` INT NOT NULL,
   `DatabaseTask` VARCHAR(50) NOT NULL,
   `DatabaseFilePath` VARCHAR(256) NOT NULL,
   `DatabaseTaskStatus` INT NOT NULL,
   `SourceServerID` INT NOT NULL,
   `TargetServerID` INT NOT NULL,
   `RetryCount` INT NOT NULL,
   `ErrorReason` VARCHAR(1000) NOT NULL,
   `ActionPerformedUserID` INT NOT NULL,
   `ScheduleDate` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
   PRIMARY KEY(`DatabaseTaskID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblResources`
(
   `ResourceID` INT NOT NULL ,
   `ResourceName` VARCHAR(50) NOT NULL,
   `ResourceDescName` VARCHAR(100),
   `ResourceDesc` LONGTEXT,
   `UserID` INT   NOT NULL  DEFAULT 0,
   `IsInternal` BOOLEAN   NOT NULL  DEFAULT 0,
   `IsDeleted` BOOLEAN   NOT NULL  DEFAULT 0,
   `RecurringPrice` DECIMAL(19,2)   NOT NULL  DEFAULT 0,
   `SetupPrice` DECIMAL(19,2)   NOT NULL  DEFAULT 0,
   `IsBinary` BOOLEAN   DEFAULT 0,
   `DisplayIndex` INT   DEFAULT 9999,
   `AutoSignupDisplay` BOOLEAN   DEFAULT 1,
   `AutoSignupAddon` BOOLEAN   DEFAULT 1,
   `BillingMethod` INT,
   `IsWindows` BOOLEAN,
   `IsLinux` BOOLEAN,
   `DefaultValue` INT DEFAULT 1,
   `GlobalSettingsDisplayIndex` INT   NOT NULL  DEFAULT 0,
   `DependentOn` INT   NOT NULL  DEFAULT 0,
   `IsClickAndInstallResource` BOOLEAN   NOT NULL  DEFAULT 0,
   `ResourceImage` VARCHAR(250),
   `IsDisabled` BOOLEAN   NOT NULL  DEFAULT 0,
   PRIMARY KEY(`ResourceID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

insert into `tblResources` values 
(1,'accounts','User Accounts','Number of user accounts',0,1,0,.00,.00,0,5,1,1,1,1,1,1,5,0,0,NULL,0), 
(2,'domains','Domains','Number of domains',0,1,0,.00,.00,0,10,1,1,1,1,1,1,31,0,0,NULL,0),
(3,'subdomains','Sub-Domains','Number of third level domains',0,1,0,.00,.00,0,15,1,1,1,1,1,1,6,0,0,NULL,0),
(4,'ipaddress','IP Based Domains','Number of IP based domains',0,1,0,.00,.00,0,20,1,1,1,1,1,1,8,0,0,NULL,0),
(5,'diskspace','Disk Space (MB)','Disk space per domain',0,1,0,.00,.00,0,25,1,1,1,1,1,250,29,0,0,NULL,0),
(6,'bandwidth','Bandwidth (MB)','Bandwidth per domain per month',0,1,0,.00,.00,0,30,1,1,1,1,1,500,30,0,0,NULL,0),
(7,'maildomains','Mail Domains','Number of mail domains',0,1,0,.00,.00,1,35,1,1,1,1,1,1,32,0,0,NULL,0),
(8,'mailboxes','Mailboxes','Number of mail boxes',0,1,0,.00,.00,0,40,1,1,1,1,1,10,33,7,0,NULL,0),
(9,'distributionlists','Distribution Lists','Distribution Lists of Mail Domain',0,1,0,.00,.00,0,45,1,1,NULL,1,1,5,34,7,0,NULL,0),
(10,'statsdomains','Statistic Sites','Number of statistic sites',0,1,0,.00,.00,1,55,1,1,1,1,1,1,11,0,0,NULL,0),
(11,'php','PHP','PHP enabled',0,1,0,.00,.00,1,65,1,1,1,1,1,1,12,0,0,NULL,0),
(12,'perl','Perl','Perl enabled',0,1,0,.00,.00,1,70,1,1,1,1,1,1,13,0,0,NULL,0),
(13,'mysqldb','MySQL Databases','Number of MySQL databases',0,1,0,.00,.00,0,85,1,1,1,1,1,5,35,0,0,NULL,0);


go
CREATE TABLE IF NOT EXISTS `tblPlanModes`
(
   `PlanModeID` INT NOT NULL  AUTO_INCREMENT,
   `PlanMode` VARCHAR(50) NOT NULL,
   `PlanModeDesc` VARCHAR(50) NOT NULL,
   `ResourceID` INT NOT NULL,
   PRIMARY KEY(`PlanModeID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblLoadBalancerSettings`
(
   `LoadBalancerID` INT NOT NULL  AUTO_INCREMENT,
   `UserID` INT NOT NULL,
   PRIMARY KEY(`LoadBalancerID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblResellerDNS`
(
   `ResellerDNSID` INT NOT NULL  AUTO_INCREMENT,
   `PNameServer` VARCHAR(50),
   `SNameServer` VARCHAR(50),
   `EmailAddress` VARCHAR(50),
   `UserId` INT NOT NULL,
   `NameServer3` VARCHAR(50),
   `NameServer4` VARCHAR(50),
   PRIMARY KEY(`ResellerDNSID`)
)ENGINE=MyISAM  DEFAULT CHARSET=latin1;


go
CREATE TABLE IF NOT EXISTS `tblPlanResourcePropertyQty`
(
   `PlanResourcePropertyQtyID` INT NOT NULL  AUTO_INCREMENT,
   `ResourcePropertyID` INT NOT NULL,
   `PlanID` INT NOT NULL,
   `QtyIncluded` INT NOT NULL,
   PRIMARY KEY(`PlanResourcePropertyQtyID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblStats`
(
   `StatsSiteID` INT NOT NULL  AUTO_INCREMENT,
   `WebsiteID` INT NOT NULL,
   PRIMARY KEY(`StatsSiteID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go
CREATE TABLE IF NOT EXISTS `tblRoles`
(
   `RoleID` INT NOT NULL,
   `Role` VARCHAR(50),
   `RoleDescName` VARCHAR(200),
   `RoleDesc` VARCHAR(200),
   `RoleGlobalSettings` MEDIUMTEXT DEFAULT NULL,
   `DefaultCapacity` INT   DEFAULT 0,
   `BackupDefaultCapacity` INT   DEFAULT 0,
   `HeartBeatInterval` INT   DEFAULT 0,
   `DowntimeThreshold` INT   DEFAULT 0,
   `DisplayTabIndex` INT   NOT NULL  DEFAULT 0,
   `DisplayIndex` INT,
   PRIMARY KEY(`RoleID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;
go

INSERT INTO tblRoles VALUES (1,'webserver','Web Server','Websites',NULL,700,300,300,900,1,10),
(2,'dnsserver','DNS Server','DNS Zones',NULL,500,200,300,900,2,20),
(3,'mailserver','Mail Server','Mail Domains',NULL,500,300,300,900,3,30),
(4,'databaseserver','Database Server','Databases',NULL,300,100,300,900,4,50);


go
CREATE PROCEDURE `sp_get_resource_sold_qty`(in resource_id INT, in user_id INT)
BEGIN
	DECLARE total_quantity INT DEFAULT 0;
	SET total_quantity=0;
	IF(SELECT DISTINCT QtyIncluded into total_quantity FROM tblPlanResourceQty WHERE ResourceID=resource_id AND QtyIncluded=-1 AND PlanID IN (Select PlanID FROM tblSoldPlans Where PlanID in ( Select PlanID from tblPlans WHERE UserID=user_id AND IsDeleted=0))) THEN
		SET total_quantity = -1;
	ELSE
	#IF((SELECT DependentOn FROM tblResources WHERE ResourceID=resource_id) = 0 )THEN
	SELECT SUM(tblPlanResourceQty_Temp.QtyIncluded) into total_quantity  FROM tblPlanResourceQty tblPlanResourceQty_Temp INNER JOIN tblSoldPlans ON tblPlanResourceQty_Temp.PlanID=tblSoldPlans.PlanID  WHERE tblPlanResourceQty_Temp.ResourceID=resource_id AND tblSoldPlans.PlanID IN (Select PlanID FROM tblPlans WHERE UserID=user_id AND IsDeleted=0);
	#ELSE
	#	SELECT	SUM( tblPlanResourceQty_Temp.QtyIncluded * (select QtyIncluded from tblPlanResourceQty where tblPlanResourceQty.ResourceID = (select tblResources.DependentOn from tblResources where tblResources.ResourceID = resource_id AND tblPlanResourceQty.PlanID=tblPlanResourceQty_Temp.PlanID))) into total_quantity  FROM tblPlanResourceQty tblPlanResourceQty_Temp INNER JOIN tblSoldPlans ON tblPlanResourceQty_Temp.PlanID=tblSoldPlans.PlanID  WHERE tblPlanResourceQty_Temp.ResourceID=resource_id AND tblSoldPlans.PlanID IN (Select PlanID FROM tblPlans WHERE UserID=user_id AND IsDeleted=0);
	#END IF;
	END IF;
	IF(total_quantity IS NULL ) THEN
		SET total_quantity = 0;
	END IF;
	SELECT total_quantity;
END

go
CREATE PROCEDURE `sp_get_plans`(in offset int, in no_of_records int, in user_id INT,in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT)
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
SET @USERID = user_id;
set @query = " SELECT SQL_CALC_FOUND_ROWS tblPlans.PlanID,tblPlans.PlanName,tblPlans.Status, COUNT(tblSoldPlans.SoldPlanID) AS SoldInstances FROM `tblPlans` LEFT JOIN tblSoldPlans ON tblPlans.PlanID=tblSoldPlans.PlanID WHERE tblPlans.UserID=? AND tblPlans.IsDeleted=0 ";
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' GROUP BY tblPlans.PlanID',' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' GROUP BY tblPlans.PlanID',' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' GROUP BY tblPlans.PlanID',' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' GROUP BY tblPlans.PlanID',' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_plan_visibility_select`(in field INT,in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblPlanVisibility` WHERE `PlanId`= field;
WHEN 2 THEN
	SELECT tblPlanVisibility.PlanID,tblPlans.PlanName FROM tblPlans INNER JOIN tblPlanVisibility ON tblPlans.PlanID=tblPlanVisibility.PlanID WHERE tblPlanVisibility.VisibleTo=field;
END CASE;
END

go
CREATE PROCEDURE `sp_reseller_dns_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblResellerDNS` WHERE `UserID`= user_id;
END CASE;
END

go
CREATE PROCEDURE `sp_roles_update`(in role_id smallint, in global_settings mediumtext,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
UPDATE `tblRoles` SET `RoleGlobalSettings`=global_settings WHERE `RoleID`=role_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_database_task_insert`(in database_id INT, in database_task varchar(50),in database_file_path varchar(256),in database_task_status int(11),in source_server_id int(11),in target_server_id int(11), in retry_count int(11),in error_reason varchar(1000),in action_performed_user_id int(11), out status VARCHAR(10))
BEGIN
INSERT INTO `tblDatabaseTasks` (`DatabaseID`, `DatabaseTask`,`DatabaseFilePath`,`DatabaseTaskStatus`,`SourceServerID`,`TargetServerID`,`RetryCount`,`ErrorReason`,`ActionPerformedUserID`) values (database_id,database_task,database_file_path,database_task_status,source_server_id,target_server_id,retry_count,error_reason,action_performed_user_id);
SET status='success';
END

go
CREATE PROCEDURE `sp_users_select`(in user_name VARCHAR(100),in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblUsers` WHERE `UserName`= user_name AND `IsDeleted`=0;
WHEN 2 THEN
	SELECT * FROM `tblUsers` WHERE `UserID`= user_id AND `IsDeleted`=0;
WHEN 3 THEN
	SELECT `UserID`,`UserName`,`IsDisabled` FROM `tblUsers` WHERE `OwnerID`= user_id AND `IsDeleted`=0;
WHEN 4 THEN
	SELECT `UserID`,`UserName`,`IsDedicated` FROM `tblUsers` WHERE `UserID`= (SELECT `OwnerID` FROM `tblUsers` WHERE `UserID`=user_id);
WHEN 5 THEN
	SELECT `UserPassword` FROM `tblUsers` WHERE `UserName`= user_name;
WHEN 6 THEN
	SELECT `UserID`,`UserName` FROM `tblUsers` WHERE `UserID`=(SELECT `UserID` FROM `tblUsers` WHERE `OwnerID`=0);
WHEN 7 THEN
	SELECT `UserID` FROM `tblUsers` WHERE `OwnerID` = 0;
END CASE;
END

go
CREATE PROCEDURE `sp_server_role_insert`(in server_id int, in role_id int, in server_role_configuration mediumtext,in role_capacity int,in backup_role_capacity int, in last_heartbeat_report datetime, in is_reseller_only tinyint(1), in is_backup_reseller_only tinyint(1),in role_status tinyint(1), out status VARCHAR(10))
BEGIN
DECLARE no_record int;
DECLARE r_id int;
DECLARE cur CURSOR FOR SELECT `ServerRoleID` FROM `tblServerRoles` WHERE `ServerID`=server_id AND `RoleID`=role_id;
DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET no_record=1;
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
OPEN cur;
FETCH cur INTO r_id;
IF ( no_record ) THEN
	INSERT INTO `tblServerRoles` (`ServerID`, `RoleID`,`ServerRoleConfiguration`,`RoleCapacity`,`BackupRoleCapacity`, `LastHeartBeatReport`,`IsResellerOnly`,`IsbackupResellerOnly`,`RoleStatus`) values (server_id,role_id,server_role_configuration,role_capacity, backup_role_capacity, last_heartbeat_report,is_reseller_only,is_backup_reseller_only,role_status);	
ELSE
UPDATE `tblServerRoles` SET `RoleCapacity`=role_capacity,`BackupRoleCapacity`=backup_role_capacity,`LastHeartBeatReport`=last_heartbeat_report,`IsResellerOnly`=is_reseller_only,`IsbackupResellerOnly`=is_backup_reseller_only ,`RoleStatus`=role_status WHERE `ServerID`= server_id AND `RoleID`=role_id;
END IF;
SET status='success';
CLOSE cur;
END

go
CREATE PROCEDURE prosplit(v_pString VARCHAR(5000),v_pSplitChar CHAR(1))


   SWL_return:
begin
   DECLARE v_vStartPosition INT;
   DECLARE v_vSplitPosition INT;
   DECLARE v_vSplitValue VARCHAR(1000);
   DECLARE v_vCounter INT;
   DROP TABLE IF EXISTS tt_tbltemp;
   CREATE TABLE tt_tbltemp
   (
      tid INT,
      `value` VARCHAR(1000)
   ) TYPE = ISAM;
   set v_vCounter = 1;
   SET v_vStartPosition = 1;
   SET v_vSplitPosition = 0;
   set v_vSplitPosition = LOCATE(v_pSplitChar,v_pString,v_vStartPosition);
   if (v_vSplitPosition = 0 and LENGTH(v_pString) != 0) then
 
      INSERT INTO tt_tbltemp(tid  ,
   `value`)
  VALUES(1 ,
   v_pString);
   

        -- select * from tt_tbltemp;

      LEAVE SWL_return;
   end if;
   set v_pString = CONCAT(v_pString,v_pSplitChar);
   while (v_vSplitPosition > 0) DO
      set v_vSplitValue = SUBSTRING(v_pString,v_vStartPosition,v_vSplitPosition -v_vStartPosition);
      set v_vSplitValue = ltrim(rtrim(v_vSplitValue));
      INSERT INTO tt_tbltemp(tid  ,
   `value`)
  VALUES(v_vCounter ,
   v_vSplitValue);
  
      set v_vCounter = v_vCounter+1;
      set v_vStartPosition = v_vSplitPosition+1;
      set v_vSplitPosition = LOCATE(v_pSplitChar,v_pString,v_vStartPosition);
   END WHILE;
 
 --     select * from tt_tbltemp;

end;


go
CREATE PROCEDURE `sp_mail_template_select`(in user_id INT, in template varchar(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	IF(select MailTemplateId from tblMailTemplates where MailName=template AND UserID=user_id) THEN
		select MailTemplateId,Body,Subject from tblMailTemplates where MailName=template AND UserID=user_id;
	ELSE
		IF( select MailTemplateId from tblMailTemplates where MailName=template AND UserID=(SELECT OwnerID from tblUsers where UserID=user_id)) THEN
			select MailTemplateId,Body,Subject from tblMailTemplates where MailName=template AND UserID=(SELECT OwnerID from tblUsers where UserID=user_id);
		ELSE
			IF(select MailTemplateId from tblMailTemplates where MailName=template AND UserID=(select UserID from tblUsers where OwnerID=0)) THEN
				select MailTemplateId,Body,Subject from tblMailTemplates where MailName=template AND UserID=(select UserID from tblUsers where OwnerID=0);
			ELSE
				IF(select MailTemplateId from tblMailTemplates where MailName=template AND UserID=0) THEN
					select MailTemplateId,Body,Subject from tblMailTemplates where MailName=template AND UserID=0;
				END IF;	
			END IF;
		END IF;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_load_balancer_settings_delete`(out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblLoadBalancerSettings` ;
SET status='success';
END

go
CREATE PROCEDURE `sp_get_purchased_plans`(in offset int, in no_of_records int, in user_id INT,in date_created DATETIME, in criteria varchar(3), in sorted_field varchar(100))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
set @query = "";
SET @START = offset;
SET @LIMIT = no_of_records;
SET @USERID = user_id;
IF( criteria = '' ) THEN
	set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblPlans.PlanID,tblPlans.PlanName,tblSoldPlans.DateCreated FROM tblPlans INNER JOIN tblSoldPlans ON tblPlans.PlanID=tblSoldPlans.PlanID WHERE tblSoldPlans.UserID=",user_id);
ELSE
	set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblPlans.PlanID,tblPlans.PlanName,tblSoldPlans.DateCreated FROM tblPlans INNER JOIN tblSoldPlans ON tblPlans.PlanID=tblSoldPlans.PlanID WHERE tblSoldPlans.UserID=",user_id," AND DATEDIFF(tblSoldPlans.DateCreated",",'",date_created,"')"," ",criteria," 0");
END IF;
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
END

go
CREATE PROCEDURE `sp_server_update`(in server_id int, in field1 tinyint(1), in field2 varchar(100),in selection int,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
CASE selection
WHEN 1 THEN
	UPDATE `tblServers` SET `IsMaster`=field1 WHERE `ServerID`=server_id;
END CASE;	
SET status='success';
END

go
CREATE PROCEDURE `sp_reseller_dns_delete`(in user_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE from `tblResellerDNS` WHERE `UserID` = user_id;
SET status='success';
END

go
CREATE PROCEDURE sp_parse_query_condition(v_pString1 VARCHAR(2000),v_pString2 VARCHAR(2000), in seperator CHAR(1), in selection int,out result VARCHAR(5000))
BEGIN
declare start_position int;
declare split_position int;
declare prev_split_position int;
declare start_position1 int;
declare split_position1 int;
declare prev_split_position1 int;
set start_position = 1;
set split_position = 1;
set prev_split_position = 1;
set start_position1 = 1;
set split_position1 = 1;
set prev_split_position1 = 1;
set result = "";
while( split_position > 0 ) do
	set split_position = LOCATE(seperator,v_pString1,start_position);
	set split_position1 = LOCATE(seperator,v_pString2,start_position1);
	IF( split_position > 0 ) THEN
		IF( selection = 1 ) THEN
			set result = CONCAT(result,' AND ',SUBSTR(v_pString1,prev_split_position,split_position-prev_split_position),'=',SUBSTR(v_pString2,prev_split_position1,split_position1-prev_split_position1));
		ELSE
			set result = CONCAT(result,' AND ',SUBSTR(v_pString1,prev_split_position,split_position-prev_split_position),' like ''%',SUBSTR(v_pString2,prev_split_position1,split_position1-prev_split_position1),'%''');
		END IF;
		set prev_split_position = split_position+1;
		set start_position = split_position + 1;
		set prev_split_position1 = split_position1+1;
		set start_position1 = split_position1 + 1;  
	END IF;
		
end while;
END

go
CREATE PROCEDURE `sp_user_consumed_resources_qty_insert`(in user_id int, in resource_id int, in qty int,in selection int, out status VARCHAR(10))
BEGIN
DECLARE no_record int;
DECLARE cr_id int;
DECLARE cur CURSOR FOR SELECT `ConsumedResourceID` FROM `tblUserConsumedResources` WHERE `UserID`=user_id AND `ResourceID`=resource_id;
DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET no_record=1;
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
OPEN cur;
FETCH cur INTO cr_id;
IF ( no_record ) THEN
	INSERT INTO `tblUserConsumedResources` (`UserID`,`ResourceID`,`ConsumedQuantity`) values (user_id,resource_id,qty);	
ELSE
IF (selection=1) THEN
UPDATE `tblUserConsumedResources` SET `ConsumedQuantity`=`ConsumedQuantity`+qty WHERE `UserID`=user_id AND `ResourceID`=resource_id;
ELSEIF (selection=-1) THEN
UPDATE `tblUserConsumedResources` SET `ConsumedQuantity`=`ConsumedQuantity`-qty WHERE `UserID`=user_id AND `ResourceID`=resource_id;
END IF;
END IF;
SET status='success';
CLOSE cur;
END

go
CREATE PROCEDURE `sp_email_insert`(in to_address varchar(256),in from_address varchar(256),in cc_address varchar(500),in bcc_address varchar(500),in mail_subject varchar(256),in mail_body longtext,in mail_type int,in mail_status int,in retry_count int ,in owner_id int,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblEMails` (`ToAddress`, `FromAddress`,`CCAddress`,`BCCAddress`,`MailSubject`,`MailBody`,`MailType`,`MailStatus`,`RetryCount`,`OwnerId`) values (to_address,from_address,cc_address,bcc_address,mail_subject,mail_body,mail_type,mail_status,retry_count,owner_id);
END

go
CREATE PROCEDURE `sp_sold_plans_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT DISTINCT tblSoldPlans.PlanID,tblPlans.PlanName FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.UserID=user_id AND tblSoldPlans.IsDeleted=0;
WHEN 2 THEN
	SELECT tblUsers.UserID,tblUsers.UserName FROM tblUsers WHERE UserID IN ( SELECT tblSoldPlans.UserID FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.UserID=user_id);
WHEN 3 THEN
	SELECT tblSoldPlans.SoldPlanID,tblPlans.PlanName,tblSoldPlans.DateCreated FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.PlanModeID=2 AND tblSoldPlans.UserID=user_id ORDER BY tblSoldPlans.SoldPlanID ASC ;
WHEN 4 THEN
SELECT Count(tblSoldPlans.SoldPlanID) FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.UserID=user_id AND tblSoldPlans.IsDeleted=0;
WHEN 5 THEN
SELECT Count(SoldPlanID) FROM tblSoldPlans WHERE UserID=user_id AND IsDeleted=0;
END CASE;
END

go
CREATE PROCEDURE `sp_stats_delete`(in website_id INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
   DELETE FROM tblStats   WHERE WebsiteID = website_id;
SET status = 'success';
END

go
CREATE PROCEDURE `sp_allocated_ips_select`(in user_id INT, in server_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	IF(user_id = 0 and server_id = 0) THEN
	SELECT * FROM tblAllocatedIPs, tblServers, tblUsers WHERE tblAllocatedIPs.ServerID = tblServers.ServerID AND tblAllocatedIPs.UserID = tblUsers.UserID 		AND (tblUsers.IsDeleted = 0 or tblUsers.IsDeleted  is null);
   	ELSE
	SELECT IPAddress from tblAllocatedIPs, tblUsers  WHERE tblAllocatedIPs.UserID = user_id AND tblAllocatedIPs.ServerID = server_id AND
	tblUsers.UserID = user_id and (tblUsers.IsDeleted = 0 or tblUsers.IsDeleted  is null);
   	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_is_server_role_deleteable`(in server_id INT,in role_id INT)
BEGIN
DECLARE server_role_id INT DEFAULT -1;
DECLARE resource_count INT DEFAULT 1;
SELECT ServerRoleID INTO server_role_id FROM tblServerRoles WHERE ServerID=server_id AND RoleID=role_id;
CASE role_id
WHEN 1 THEN
	SELECT COUNT(UserID) FROM tblUsersServers WHERE ServerRoleID=server_role_id;
WHEN 2 THEN
	SELECT COUNT(DNSID) FROM tblDNSServer WHERE ServerRoleID=server_role_id;
WHEN 3 THEN
	IF((SELECT COUNT(MailDomainID) FROM tblMailDomains WHERE ServerRoleID=server_role_id) = 0) THEN
		SELECT COUNT(MailDomainID) FROM tblMailOnlyMailDomains WHERE ServerRoleID=server_role_id;
	ELSE
		SELECT COUNT(MailDomainID) FROM tblMailDomains WHERE ServerRoleID=server_role_id;
	END IF;	
WHEN 4 THEN
	SELECT COUNT(DatabaseID) FROM tblDatabases WHERE ServerRoleID=server_role_id;
END CASE;
END

go
CREATE PROCEDURE `sp_websites_insert`(in website_name VARCHAR(50), in owner_id INT, in is_name_based tinyint(1), in is_subdomain tinyint(1), in sold_plan_id int, in ip_address VARCHAR(100), in admin_vdir tinyint(1), in disk_usage FLOAT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblWebsites` (`WebsiteName`, `OwnerID`,`IsNameBased`,`IsSubDomain`,`SoldPlanID`,`IPAddress`,`DiskSpaceUsage`,`AdminVdirAccess`) values (website_name,owner_id,is_name_based,is_subdomain,sold_plan_id,ip_address,disk_usage,admin_vdir);
END

go
CREATE PROCEDURE `sp_website_resource_select`(in website_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `PHPEnabled` FROM `tblWebsiteResources` WHERE `WebsiteID`= website_id;
WHEN 2 THEN
	SELECT `PerlEnabled` FROM `tblWebsiteResources` WHERE `WebsiteID`= website_id;
WHEN 3 THEN
	SELECT `StatsEnabled` FROM `tblWebsiteResources` WHERE `WebsiteID`= website_id;
END CASE;
END

go
CREATE PROCEDURE `sp_get_child_users`(in offset int, in no_of_records int, in user_id INT,in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT)
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
SET @USERID = user_id;
set @query = " SELECT SQL_CALC_FOUND_ROWS UserID,UserName FROM tblUsers WHERE UserID IN (SELECT UserID from tblUsers WHERE OwnerID=?)";
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_user_prop_select`(in prop_name VARCHAR(100),in user_id INT, in selection INT)
BEGIN
CASE selection
WHEN 1 THEN
	SELECT * FROM `tblUserProp` WHERE `UserID`= user_id AND `PropName` = prop_name;
END CASE;
END

go
CREATE PROCEDURE `sp_user_delete`(in user_id INT, in user_level varchar(10),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblUsersProfile` WHERE `UserID`= user_id;
DELETE FROM `tblUsersServers` WHERE `UserID`= user_id;
DELETE FROM `tblPlans` WHERE `UserID`= user_id;
DELETE FROM `tblSoldPlans` WHERE `UserID`= user_id;
DELETE FROM `tblBandwidthUsageSettings` WHERE `UserID`=user_id;
DELETE FROM `tblLoadBalancerSettings` WHERE `UserID`=user_id;
DELETE FROM `tblMailDeliverySettings` WHERE `UserID`=user_id;
DELETE FROM `tblMailTemplates` WHERE `UserID`=user_id;
DELETE FROM `tblPlanVisibility` WHERE `VisibleTo`=user_id;
DELETE FROM `tblUserConsumedResources` WHERE `UserID`=user_id;
DELETE FROM `tblViolatedResources` WHERE `UserID`=user_id;
DELETE FROM `tblUserProp` WHERE `UserID`= user_id;
DELETE FROM `tblAllocatedIPs` WHERE `UserID`= user_id;
DELETE FROM `tblUsers` WHERE `UserID`= user_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_dns_server_delete`(in website_id INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
Delete from tblDNSServer where WebsiteID = website_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_plan_visibility_insert`(in plan_id INT, in visible_to INT,out status VARCHAR(10))
BEGIN
DECLARE no_record int;
DECLARE pv_id int;
DECLARE cur CURSOR FOR SELECT `PlanVisibleId` FROM `tblPlanVisibility` WHERE `PlanId`=plan_id AND `VisibleTo`=visible_to;
DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET no_record=1;
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
OPEN cur;
FETCH cur INTO pv_id;
IF ( no_record ) THEN
INSERT INTO `tblPlanVisibility` (`PlanId`, `VisibleTo`) values (plan_id,visible_to);
END IF;
SET status='success';
END

go
CREATE PROCEDURE `sp_states_select`(in country_id int,in state_get VARCHAR(100),in selection int)
BEGIN
CASE selection 
WHEN 1 THEN 
	SELECT * FROM `tblStates` ;
WHEN 2 THEN 
       SELECT * FROM `tblStates`  WHERE `CountryID`=country_id;
WHEN 3 THEN 
       SELECT `StateID`  FROM `tblStates`  WHERE `CountryID`=country_id AND `StateName`=state_get;
END CASE;
END

go
CREATE PROCEDURE `sp_dns_server_select`(in field1 INT, in field2 varchar(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT (SELECT ServerRoleID FROM tblDNSServer WHERE WebsiteID=field1) AS ServerRoleID, ServerID, ServerIP FROM tblServers WHERE ServerID=(SELECT ServerID FROM tblServerRoles WHERE ServerRoleID=(SELECT ServerRoleID FROM tblDNSServer WHERE WebsiteID=field1));
END CASE;
END

go
CREATE PROCEDURE `sp_get_resource_purchased_qty`(in resource_id INT, in user_id INT)
BEGIN
DECLARE total_quantity INT DEFAULT 0;
SET total_quantity=0;
IF(SELECT DISTINCT QtyIncluded FROM tblPlanResourceQty WHERE ResourceID=resource_id AND QtyIncluded=-1 AND PlanID IN (Select PlanID FROM tblSoldPlans WHERE UserID=user_id AND CurrStatus=1 AND IsDeleted=0) ) THEN
	SET total_quantity = -1;
ELSE
	#IF((SELECT DependentOn FROM tblResources WHERE ResourceID=resource_id) = 0 )THEN
	SELECT SUM(tblPlanResourceQty.QtyIncluded) into total_quantity FROM tblPlanResourceQty INNER JOIN tblSoldPlans ON tblPlanResourceQty.PlanID=tblSoldPlans.PlanID   WHERE tblPlanResourceQty.ResourceID=resource_id AND tblSoldPlans.UserID=user_id AND tblSoldPlans.CurrStatus=1 AND tblSoldPlans.IsDeleted=0;
	#ELSE
	#	SELECT SUM(tblPlanResourceQty_Temp.QtyIncluded * (select QtyIncluded from tblPlanResourceQty where tblPlanResourceQty.ResourceID = (select tblResources.DependentOn from tblResources where tblResources.ResourceID = resource_id AND tblPlanResourceQty.PlanID=tblPlanResourceQty_Temp.PlanID))) into total_quantity FROM tblPlanResourceQty tblPlanResourceQty_Temp INNER JOIN tblSoldPlans ON tblPlanResourceQty_Temp.PlanID=tblSoldPlans.PlanID   WHERE tblPlanResourceQty_Temp.ResourceID=resource_id AND tblSoldPlans.UserID=user_id AND tblSoldPlans.CurrStatus=1 AND tblSoldPlans.IsDeleted=0;
	#END IF;
END IF;
IF(total_quantity IS NULL ) THEN
		SET total_quantity = 0;
	END IF;
SELECT total_quantity;
END

go
CREATE PROCEDURE `sp_secondary_dns_server_delete`(in field1 INT, in field2 INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
Delete From	tblSecondaryDNSServer
   Where		DNSID = field1
   And ServerRoleID =(Select ServerRoleID
   From tblServerRoles
   Where ServerID = field2 And RoleID =(Select RoleID From tblRoles Where  Role = 'dnsserver'));
SET status='success';
END

go
CREATE PROCEDURE `sp_sold_plans_select1`(in field1 INT, in field2 INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT MAX(`SoldPlanID`) FROM `tblSoldPlans` WHERE `PlanID`=field2 AND `UserID`=field1; 
WHEN 2 THEN
	 SELECT tblSoldPlans.PlanID,tblPlanResourceQty.QtyIncluded FROM tblSoldPlans INNER JOIN tblPlanResourceQty ON tblSoldPlans.PlanID=tblPlanResourceQty.PlanID WHERE tblSoldPlans.UserID=field1 AND tblPlanResourceQty.ResourceID=field2;
WHEN 3 THEN
	 SELECT PlanID,UserID FROM tblSoldPlans WHERE SoldPlanID=field1;
END CASE;
END

go
CREATE PROCEDURE `sp_database_delete`(in database_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
DELETE FROM `tblDatabases` WHERE `DatabaseID`= database_id;      
END

go
CREATE PROCEDURE `sp_get_dns`(in offset int, in no_of_records int, in user_ids VARCHAR(500),in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
#set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS #tblDNSServer.WebsiteID,tblDNSServer.ServerRoleID,tblDNSServer.WebsiteZoneName,tblUsers.UserName FROM tblDNSServer INNER #JOIN tblWebsites ON tblDNSServer.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers ON #tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID IN (",user_ids,")");
#IF( @USERLEVEL = "host" ) THEN
#set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS #tblDNSServer.WebsiteID,tblDNSServer.ServerRoleID,tblDNSServer.WebsiteZoneName,WebAdmins.UserName,(select UserName from #tblUsers where UserID = WebAdmins.OwnerID) as ResellerName FROM tblDNSServer INNER JOIN tblWebsites ON #tblDNSServer.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID #WHERE tblWebsites.OwnerID IN (",user_ids,")");
#set @query = "SELECT SQL_CALC_FOUND_ROWS #tblDNSServer.WebsiteID,tblDNSServer.ServerRoleID,tblDNSServer.WebsiteZoneName,WebAdmins.UserName,(select UserName from #tblUsers where UserID = WebAdmins.OwnerID) as ResellerName FROM tblDNSServer INNER JOIN tblWebsites ON #tblDNSServer.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID";
IF( user_level = "host" ) THEN
set @query = "SELECT SQL_CALC_FOUND_ROWS tblDNSServer.WebsiteID,tblDNSServer.ServerRoleID,tblDNSServer.WebsiteZoneName,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblDNSServer INNER JOIN tblWebsites ON tblDNSServer.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID";
ELSE
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblDNSServer.WebsiteID,tblDNSServer.ServerRoleID,tblDNSServer.WebsiteZoneName,tblUsers.UserName FROM tblDNSServer INNER JOIN tblWebsites ON tblDNSServer.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID IN (",user_ids,")");
END IF;
#END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_server_insert`(in server_name VARCHAR(50), in server_ip VARCHAR(25), in server_type varchar(50), in web_root varchar(100), in is_master tinyint(1), in is_deleted tinyint(1), in server_status tinyint(1), in build_no varchar(50),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblServers` (`ServerName`, `ServerIP`,`ServerType`,`WebRoot`,`IsMaster`,`IsDeleted`,`Status`,`BuildNo`) values (server_name,server_ip,server_type,web_root,is_master,is_deleted,server_status,build_no);
END

go
CREATE PROCEDURE `sp_plan_resource_qty_select`(in plan_id INT, in resource_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblPlanResourceQty` WHERE `PlanID`= plan_id;
WHEN 2 THEN
	SELECT `QtyIncluded` FROM `tblPlanResourceQty` WHERE `PlanID`= plan_id AND ResourceID=`resource_id`;
END CASE;
END

go
CREATE PROCEDURE `sp_get_sold_plans`(in offset int, in no_of_records int, in user_id INT,in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT)
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
SET @USERID = user_id;
set @query = " SELECT SQL_CALC_FOUND_ROWS tblSoldPlans.SoldPlanID,tblSoldPlans.PlanID,tblUsers.UserName,tblPlans.PlanName,tblSoldPlans.DateCreated FROM tblSoldPlans INNER JOIN tblUsers ON tblSoldPlans.UserID= tblUsers.UserID INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE  tblPlans.UserID=? AND tblSoldPlans.IsDeleted=0 ";
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_user_profile_insert`(in user_id int, in first_name VARCHAR(100), in last_name VARCHAR(100), in email_address VARCHAR(100), in country int, in state int, in city VARCHAR(50), in street_address VARCHAR(100),in street_address2 VARCHAR(100),in postal_code VARCHAR(50),in phone_no VARCHAR(50),in fax_no VARCHAR(50),in company VARCHAR(250),social_security_no VARCHAR(50),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblUsersProfile` (`UserID`, `FirstName`,`LastName`,`EmailAddress`,`Country`,`State`,`City`,`StreetAddress`,`StreetAddress2`,`PostalCode`,`PhoneNo`,`FaxNo`,`Company`,`SocialSecurityNo`) values (user_id,first_name,last_name,email_address,country,state,city,street_address,street_address2,postal_code,phone_no,fax_no,company,social_security_no);
END

go
CREATE PROCEDURE `sp_website_resource_insert`(in website_id int, in dotnet_enabled tinyint(1), in cfmx_enabled tinyint(1),in php_enabled tinyint(1),in perl_enabled tinyint(1),in stats_enabled tinyint(1),in stts tinyint(1),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
INSERT INTO `tblWebsiteResources` (`WebsiteID`, `DotnetEnabled`,`CFMXEnabled`,`PHPEnabled`,`PerlEnabled`, `StatsEnabled`,`Status`) values (website_id,dotnet_enabled,cfmx_enabled,php_enabled,perl_enabled,stats_enabled,stts);	
SET status='success';
END

go
CREATE PROCEDURE `sp_registered_server_delete`(in server_ip varchar(25),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
DELETE FROM `tblRegisteredServers` WHERE `ServerIP`=server_ip;
END

go
CREATE PROCEDURE `sp_mail_only_mail_domain_insert`(in user_id INT, in server_role_id INT, in mail_domain_name varchar(100),in mail_box_usage INT,in distribution_list_usage INT,in disk_space_usage DOUBLE,out status VARCHAR(10))
BEGIN
INSERT INTO `tblMailOnlyMailDomains` (`UserID`,`ServerRoleID`,`MailDomainName`,`MailboxUsage`,`DistributionListUsage`,`DiskSpaceUsage`) VALUES (user_id,server_role_id,mail_domain_name,mail_box_usage,distribution_list_usage,disk_space_usage);
SET status='success';
END

go
CREATE PROCEDURE `sp_website_resource_update`(in website_id INT, in resource_status tinyint(1),in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection
WHEN 1 THEN 
	UPDATE `tblWebsiteResources` SET `PHPEnabled`= resource_status WHERE `WebsiteID`=website_id;
WHEN 2 THEN 
	UPDATE `tblWebsiteResources` SET `PerlEnabled`= resource_status WHERE `WebsiteID`=website_id; 
WHEN 3 THEN 
	UPDATE `tblWebsiteResources` SET `StatsEnabled`= resource_status WHERE `WebsiteID`=website_id; 
END CASE;      
END

go
CREATE PROCEDURE `sp_user_server_select`(in id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblUsersServers` WHERE `UserID`= id;
WHEN 2 THEN
	SELECT * FROM `tblUsersServers` WHERE `ServerRoleID`= id;
END CASE;
END

go
CREATE PROCEDURE `sp_mail_domain_delete`(in mail_domain_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
DELETE FROM `tblMailDomains` WHERE `MailDomainID`=mail_domain_id;      
END

go
CREATE PROCEDURE `sp_mail_only_mail_domain_delete`(in field1 INT, in field2 varchar(100),in selection INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
CASE selection
WHEN 1 THEN
DELETE FROM `tblMailOnlyMailDomains` WHERE `MailDomainID`= field1;
WHEN 2 THEN
DELETE FROM `tblMailOnlyMailDomains` WHERE `MailDomainName`= field2;
END CASE;
SET status='success';
END

go
CREATE PROCEDURE `sp_mail_domain_select`(in field1 INT,in field2 VARCHAR(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblMailDomains` WHERE `MailDomainID` = field1;
WHEN 2 THEN
	SELECT * FROM `tblMailDomains` WHERE `MailDomainName` = field2;
WHEN 3 THEN
	SELECT * FROM `tblMailDomains` WHERE `WebsiteID` = field1;
WHEN 4 THEN
	SELECT WebsiteID FROM `tblMailDomains` WHERE `MailDomainID` = field1;
WHEN 5 THEN 
	select SUM(DiskSpaceUsage) from tblMailDomains where WebsiteID IN (select WebsiteID from tblWebsites where OwnerID=field1);
WHEN 6 THEN 
	select OwnerID from tblWebsites where WebsiteID = (select WebsiteID from tblMailDomains where `MailDomainName` = field2);
WHEN 50 THEN
	SELECT COUNT(MailDomainID) from tblMailDomains;
END CASE;
END

go
CREATE PROCEDURE `sp_load_balancer_settings_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `LoadBalancerID` FROM `tblLoadBalancerSettings` WHERE `UserID` = user_id;
WHEN 2 THEN
	SELECT * FROM `tblLoadBalancerSettings` WHERE `UserID`= user_id;
WHEN 3 THEN
	SELECT `UserID` FROM `tblLoadBalancerSettings` WHERE `UserID` != user_id;
END CASE;
	
END

go
CREATE PROCEDURE `sp_plan_resource_qty_delete`(in plan_id INT, in resource_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblPlanResourceQty` WHERE `PlanID`= plan_id AND `ResourceID`=resource_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_registered_servers_select`()
BEGIN
SELECT * FROM `tblRegisteredServers`;
END

go
CREATE PROCEDURE `sp_database_insert`(in database_name varchar(100), in database_type  varchar(50),in database_user_name varchar(100),in database_user_name_password varchar(100),in database_path varchar(256),in website_id int, in server_role_id int,in diskspace_usage double, instance_name varchar(256),out status VARCHAR(10))
BEGIN
INSERT INTO `tblDatabases` (`DatabaseName`, `DatabaseType`,`DatabaseUserName`,`DatabaseUserPassword`,`DatabasePath`,`WebsiteID`,`ServerRoleID`,`DiskSpaceUsage`,`InstanceName`) values (database_name,database_type,database_user_name,database_user_name_password,database_path,website_id,server_role_id,diskspace_usage, instance_name);
SET status='success';
END

go
CREATE PROCEDURE `sp_database_task_delete`(in database_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
DELETE FROM `tblDatabaseTasks` WHERE `DatabaseID`=database_id; 
END

go
CREATE PROCEDURE `sp_mail_only_mail_domain_select`(in field1 INT,in field2 VARCHAR(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblMailOnlyMailDomains` WHERE `MailDomainID` = field1;
WHEN 2 THEN
	SELECT * FROM `tblMailOnlyMailDomains` WHERE `MailDomainName` = field2;
WHEN 3 THEN
	SELECT COUNT(MailDomainID) FROM `tblMailOnlyMailDomains` WHERE `SoldPlanID` = field1; 
WHEN 4 THEN
	SELECT * FROM `tblMailOnlyMailDomains` WHERE `UserID` = field1;
WHEN 5 THEN
	SELECT SUM(MailboxUsage) FROM tblMailOnlyMailDomains WHERE UserID=field1;
WHEN 6 THEN
	SELECT UserID FROM tblMailOnlyMailDomains WHERE `MailDomainName` = field2;
WHEN 50 THEN
	SELECT COUNT(MailDomainID) FROM `tblMailOnlyMailDomains`;
END CASE;
END

go
CREATE PROCEDURE `sp_database_user_insert`(in database_id INT, in user_name VARCHAR(100), in user_password varchar(100),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblDatabaseUsers` (`DatabaseID`, `UserName`,`UserPassword`) values (database_id,user_name,user_password);
END

go
CREATE PROCEDURE `sp_user_server_insert`(in user_id INT, in server_role_id INT, in backup_server_id INT, in born_here TINYINT(1), in is_live tinyint(1),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblUsersServers` (`UserID`, `ServerRoleID`,`BackupServerID`,`BornHere`,`IsLive`) values (user_id,server_role_id,backup_server_id,born_here,is_live);
END

go
CREATE PROCEDURE `sp_sold_plan_insert`(in plan_id INT, in next_invoice DATETIME, in user_id INT, in setup_price_discount DOUBLE, in recurring_price_discount DOUBLE, in date_created DATETIME, in curr_status BOOLEAN, in is_deleted BOOLEAN, in last_recurring_price_alter_date DATETIME,in alert_sent BOOLEAN,in recurring_duration INT,in paid_till TIMESTAMP,in reminder_sent BOOLEAN, in no_of_instances INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
while( no_of_instances > 0 ) do
INSERT INTO `tblSoldPlans` (`PlanID`, `NextInvoice`,`UserID`,`SetUpPriceDiscount`,`RecurringPriceDiscount`,`DateCreated`,`CurrStatus`,`IsDeleted`,`LastRecurringPriceAlterDate`,`AlertSent`,`RecurringDuration`,`PaidTill`,`ReminderSent`) values (plan_id,next_invoice,user_id,setup_price_discount,recurring_price_discount,date_created,curr_status,is_deleted,last_recurring_price_alter_date,alert_sent,recurring_duration,paid_till,reminder_sent);
set no_of_instances = no_of_instances - 1;
END WHILE;
END

go
CREATE PROCEDURE `sp_user_prop_insert`(in user_id INT, in prop_name VARCHAR(50), in prop_value VARCHAR(4000), in selection INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
CASE selection
WHEN 1 THEN
	IF EXISTS(SELECT UserID FROM tblUserProp WHERE `UserID` = user_id and `PropName` = prop_name) THEN
		UPDATE tblUserProp SET `PropValue` = prop_value WHERE `UserID` = user_id AND `PropName` = prop_name;
	ELSE
		INSERT INTO `tblUserProp` (`UserID`,`PropName`,`PropValue`) values (user_id,prop_name,prop_value);
	END IF;
END CASE;
SET status='success';
END

go
CREATE PROCEDURE `sp_tempvdir_select`(in master_website_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
   select   SlaveWebsiteID from tblTempVDir where MasterWebsiteID = master_website_id;
END CASE;
END;

go
CREATE PROCEDURE `sp_website_insert`(in website_name VARCHAR(50), in owner_id INT, in is_name_based tinyint(1), in is_subdomain tinyint(1), in sold_plan_id int, in ip_address VARCHAR(100), in admin_vdir tinyint(1), in disk_usage FLOAT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblWebsites` (`WebsiteName`, `OwnerID`,`IsNameBased`,`IsSubDomain`,`SoldPlanID`,`IPAddress`,`DiskSpaceUsage`,`AdminVdirAccess`) values (website_name,owner_id,is_name_based,is_subdomain,sold_plan_id,ip_address,admin_vdir,disk_usage);
END

go
CREATE PROCEDURE `sp_reseller_dns_insert`(in user_id INT, in primary_ns VARCHAR(150), in secondary_ns VARCHAR(100), in ns_3 VARCHAR(100), in ns_4 VARCHAR(100), in email VARCHAR(100),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF EXISTS(select `UserId` from `tblResellerDNS` where `UserId` = user_id) THEN
	update tblResellerDNS
	set 	`PNameServer` = primary_ns,`SNameServer` = secondary_ns,`NameServer3` = ns_3,
        `NameServer4` = ns_4,`EmailAddress` = email where `UserId` = user_id;
SET status='success';
ELSE
	insert into `tblResellerDNS` (`UserId`,`PNameServer`,`SNameServer`,`NameServer3`,`NameServer4`,`EmailAddress`) values 
	(user_id,primary_ns,secondary_ns,ns_3,ns_4,email);
SET status='success';
END IF;
END

go
CREATE PROCEDURE `sp_user_profile_update`(in user_id int, in first_name VARCHAR(100), in last_name VARCHAR(100), in email_address VARCHAR(100), in country int, in state int, in city VARCHAR(50), in street_address VARCHAR(100),in street_address2 VARCHAR(100),in postal_code VARCHAR(50),in phone_no VARCHAR(50),in fax_no VARCHAR(50),in company VARCHAR(250),social_security_no VARCHAR(50),in selection INT,out status VARCHAR(10))
BEGIN
DECLARE user_level VARCHAR(100);
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';

SET status='success';
CASE selection
WHEN 1 THEN
IF EXISTS(SELECT `UserProfileID` FROM `tblUsersProfile` WHERE `UserID`=user_id) THEN
 UPDATE `tblUsersProfile` SET `FirstName`=first_name,`LastName`=last_name,`EmailAddress`=email_address,`Country`=country,`State`=state,`City`=city,`StreetAddress`=street_address,`StreetAddress2`=street_address2,`PostalCode`=postal_code,`PhoneNo`=phone_no,`FaxNo`=fax_no,`Company`=company,`SocialSecurityNo`=social_security_no WHERE `UserID`=user_id;
ELSE
INSERT INTO `tblUsersProfile` (`UserID`, `FirstName`,`LastName`,`EmailAddress`,`Country`,`State`,`City`,`StreetAddress`,`StreetAddress2`,`PostalCode`,`PhoneNo`,`FaxNo`,`Company`,`SocialSecurityNo`) values (user_id,first_name,last_name,email_address,country,state,city,street_address,street_address2,postal_code,phone_no,fax_no,company,social_security_no);
END IF;
WHEN 2 THEN 

SET user_level = (SELECT `UserLevel` From `tblUsers` WHERE `UserID` = user_id);
IF EXISTS(SELECT `UserID` FROM `tblUsersProfile` WHERE `UserID`=user_id) THEN
	UPDATE `tblUsersProfile` SET `Company`=company WHERE `UserID`=user_id;
END IF;
ELSE IF(user_level != 'webadmin') THEN
	INSERT into `tblUsersProfile` (`UserID`,`Company`) values(user_id,compnay);
END IF;

END CASE;
END

go
CREATE PROCEDURE `sp_states_insert`(in country_id INT, in state_name VARCHAR(100),out status VARCHAR(10) )
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblStates` (`CountryID`,`StateName`) values (country_id,state_name);
END

go
CREATE PROCEDURE `sp_allocated_ips_delete`(in ip_address VARCHAR(250), out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF exists(select * from tblAllocatedIPs where IPAddress = ip_address) then
	delete from tblAllocatedIPs where IPAddress = ip_address;
END IF;
SET status='success';
END

go
CREATE PROCEDURE `sp_bandwidth_usage_settings_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblBandwidthUsageSettings` WHERE `UserID`= user_id;
END CASE;
END

go
CREATE PROCEDURE `sp_bandwidth_usage_settings_insert`(in user_id INT,in send_bandwidth_report BOOLEAN,in bandwidth_usage_report_frequency INT,in send_bandwidth_usage_warnings BOOLEAN, in bandwidth_usage_limit DOUBLE,in cc_warning_email_toowner BOOLEAN,in threshold_limit DOUBLE,in threshold_action INT,
in add_on_quantity INT,in bandwidth_usage_calc_frequency INT,in bandwidth_usage_calc_start_time INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF EXISTS(SELECT * FROM tblBandwidthUsageSettings WHERE UserID = user_id) THEN
		
      UPDATE tblBandwidthUsageSettings SET
      UserID	 = user_id,EmailBWReport = send_bandwidth_report,BWReportFreq = bandwidth_usage_report_frequency,
      BWWarningEmail = send_bandwidth_usage_warnings,BWWarningLimit = bandwidth_usage_limit,CCToOwner = cc_warning_email_toowner,ThresholdLimit = threshold_limit,
      ThresholdAction = threshold_action,AddonQuantity = add_on_quantity,BandwidthCalcFreq = bandwidth_usage_calc_frequency,BandwidthCalcStartTime =
      bandwidth_usage_calc_start_time WHERE (UserID = user_id);
ELSE
      INSERT INTO tblBandwidthUsageSettings			   (UserID,EmailBWReport,BWReportFreq,BWWarningEmail,BWWarningLimit,CCToOwner,ThresholdLimit,ThresholdAction,BandwidthCalcFreq,AddonQuantity,BandwidthCalcStartTime)
			values(	user_id,
				send_bandwidth_report,
				bandwidth_usage_report_frequency,
				send_bandwidth_usage_warnings,
				bandwidth_usage_limit,
				cc_warning_email_toowner,
				threshold_limit,
				threshold_action,
				add_on_quantity,
				bandwidth_usage_calc_frequency,
				bandwidth_usage_calc_start_time);
   END IF;
	
SET status='success';
END

go
CREATE PROCEDURE `sp_plans_select`(in field1 INT,in field2 varchar(1000), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblPlans` WHERE `PlanID`= field1 AND `IsDeleted`=0;
WHEN 2 THEN
	SELECT * FROM `tblPlans` WHERE `PlanName`= field2 AND `IsDeleted`=0;
WHEN 3 THEN
	SELECT `PlanID`,`PlanName` FROM `tblPlans` WHERE `UserID`= field1 AND `IsDeleted`=0 AND `Status`=1;
WHEN 4 THEN
	SELECT `PlanID`,`PlanName` FROM `tblPlans` WHERE `UserID`= field1 AND `PlanModeID`=2 AND `IsDeleted`=0 AND `Status`=1;
WHEN 5 THEN
	SELECT `PlanName` FROM `tblPlans` WHERE `PlanID`= field1;
WHEN 6 THEN
	SELECT COUNT(`PlanID`) FROM `tblPlans` WHERE `UserID`= field1 AND `IsDeleted`=0;
END CASE;
END

go
CREATE PROCEDURE `sp_plan_resource_qty_insert`(in plan_id INT, in resource_id INT, in qty_included INT,out status VARCHAR(10))
BEGIN
DECLARE no_record int;
DECLARE qty int;
DECLARE cur CURSOR FOR SELECT `QtyIncluded` FROM `tblPlanResourceQty` WHERE `PlanID`=plan_id AND `ResourceID`=resource_id;
DECLARE CONTINUE HANDLER FOR SQLSTATE '02000' SET no_record=1;
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
OPEN cur;
FETCH cur INTO qty;
IF ( no_record ) THEN
INSERT INTO `tblPlanResourceQty` (`PlanID`, `ResourceID`,`QtyIncluded`) values (plan_id,resource_id,qty_included);
ELSE
UPDATE `tblPlanResourceQty` SET `QtyIncluded`= qty_included WHERE `PlanID`= plan_id AND `ResourceID`=resource_id;
END IF;
SET status='success';
END

go
CREATE PROCEDURE `sp_mail_domain_insert`(in mail_domain_name varchar(100), in website_id  INT,in mail_box_usage INT,in server_role_id INT,in disk_space_usage DOUBLE,in distribution_list_usage INT,out status VARCHAR(10))
BEGIN
INSERT INTO `tblMailDomains` (`MailDomainName`, `WebsiteID`,`MailboxUsage`,`ServerRoleID`,`DiskSpaceUsage`,`DistributionListUsage`) VALUES (mail_domain_name, website_id,mail_box_usage,server_role_id,disk_space_usage,distribution_list_usage);
SET status='success';
END

go
CREATE PROCEDURE `sp_get_websites1`(in offset int, in no_of_records int, in user_ids VARCHAR(500),in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);


SET @START = offset;
SET @LIMIT = no_of_records;

DROP TABLE IF EXISTS tt_Websites;

create TEMPORARY table tt_Websites
   (
	WebsiteID INT,
	WebsiteName VARCHAR(250),
	IsNameBased tinyint(1) default 1,
	IsSubDomain tinyint(1) default 0,
	IPAddress VARCHAR(50),
	ServerName VARCHAR(250),
	ServerIP VARCHAR(25),
	UserName  VARCHAR(250)
   ) TYPE = ISAM;


IF( user_level = "host" ) THEN
set @query = "INSERT INTO tt_Websites SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.IsNameBased,tblWebsites.IsSubDomain,tblWebsites.IPAddress,tblServers.ServerName,tblServers.ServerIP,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblWebsites INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID INNER JOIN tblUsersServers ON tblUsersServers.UserID=tblWebsites.OwnerID INNER JOIN tblServerRoles ON tblServerRoles.ServerRoleID=tblUsersServers.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE 1=1";
ELSE
set @query = CONCAT("INSERT INTO tt_Websites SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.IsNameBased,tblWebsites.IsSubDomain,tblWebsites.IPAddress,tblServers.ServerName,tblServers.ServerIP,(select UserName from tblUsers where UserID = WebAdmins.UserID) AS UserName FROM tblWebsites INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID INNER JOIN tblUsersServers ON tblUsersServers.UserID=tblWebsites.OwnerID INNER JOIN tblServerRoles ON tblServerRoles.ServerRoleID=tblUsersServers.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE tblWebsites.OwnerID IN (",user_ids,")");

END IF;

CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Websites LIMIT ? , ?";
		PREPARE STMT FROM @query2;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Websites";
		PREPARE STMT FROM @query2;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Websites LIMIT ? , ?";
		PREPARE STMT FROM @query2;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Websites";
		PREPARE STMT FROM @query2;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_plan_mail_server_type_insert`(in plan_id INT, in plan_mail_server_type VARCHAR(50),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblPlanMailServerType` (`PlanID`,`MailServerType`) values (plan_id,plan_mail_server_type);
END

go
CREATE PROCEDURE `sp_resources_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `ResourceID`,`ResourceName`,`ResourceDescName`,`IsBinary`,`DefaultValue`,`DisplayIndex` FROM `tblResources` WHERE `IsInternal`= 1 AND `IsDeleted`=0 AND `IsLinux`=1 AND `IsDisabled`=0 ORDER BY `DisplayIndex` ASC;
WHEN 2 THEN
	SELECT `ResourceID` FROM `tblResources` WHERE `ResourceName`=field1;
WHEN 3 THEN
	SELECT `ResourceName` FROM `tblResources` WHERE `ResourceID`=field2;
END CASE;
END

go
CREATE PROCEDURE `sp_websites_select`(in field1 INT,in field2 VARCHAR(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	set @query = CONCAT("SELECT `WebsiteID`,`WebsiteName` FROM `tblWebsites` WHERE `OwnerID` IN (",field2,")");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
WHEN 2 THEN
	set @query = CONCAT("SELECT tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblUsers.UserName FROM `tblWebsites` INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID IN (",field2,")");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
WHEN 3 THEN
	SELECT (SELECT ServerRoleID FROM tblUsersServers WHERE UserID=(SELECT OwnerID FROM tblWebsites WHERE WebsiteID=field1)) AS ServerRoleID, ServerID, ServerIP FROM tblServers WHERE ServerID=(SELECT ServerID FROM tblServerRoles WHERE ServerRoleID=(SELECT ServerRoleID FROM tblUsersServers WHERE UserID=(SELECT OwnerID FROM tblWebsites WHERE WebsiteID=field1)));
WHEN 4 THEN
	SELECT UserID,UserName FROM tblUsers WHERE UserID = (SELECT OwnerID FROM tblWebsites WHERE WebsiteID=field1);
WHEN 5 THEN
	SELECT `WebsiteName` FROM tblWebsites WHERE `WebsiteID`=field1;
WHEN 6 THEN
	SELECT `WebsiteID`,`WebsiteName` FROM tblWebsites WHERE `OwnerID` IN (SELECT UserID FROM tblUsers WHERE OwnerID=field1);
WHEN 7 THEN
	SELECT `WebsiteID`,`WebsiteName` FROM tblWebsites WHERE `OwnerID`=field1;
WHEN 8 THEN
	SELECT SUM(DiskSpaceUsage) FROM tblWebsites WHERE OwnerID=field1;
WHEN 9 THEN
	select count(WebsiteID) as TotalWebsites from tblWebsites,tblUsers,tblUsersServers,tblServerRoles,tblServers Where (tblUsers.isdeleted =0 or 		tblUsers.isdeleted is null) and tblWebsites.OwnerID = tblUsers.UserID and tblUsers.UserID = tblUsersServers.UserID and tblUsersServers.ServerRoleID = 		tblServerRoles.ServerRoleID and tblServerRoles.ServerID = tblServers.ServerID and tblServers.ServerID = field1;
WHEN 10 THEN
	SELECT WebsiteID FROM `tblWebsites` WHERE `WebsiteName`= field2;
WHEN 11 THEN
	SELECT * from tblWebsites WHERE WebsiteID = field1;
WHEN 50 THEN
	SELECT COUNT(WebsiteID) FROM tblWebsites;
END CASE;
END

go
CREATE PROCEDURE `sp_tempvdir_delete`(in website_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF exists(select MasterWebsiteID from tblTempVDir where MasterWebsiteID = website_id) then
      delete from tblTempVDir where MasterWebsiteID = website_id;
END IF; 
SET status='success';	
END

go
CREATE PROCEDURE `sp_websites_delete`(in website_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
   delete from `tblWebsites` WHERE `WebsiteID` = website_id;
SET status='success';	
END

go
CREATE PROCEDURE `sp_get_servers`(in offset int, in no_of_records int, in role_id INT,in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT)
BEGIN
DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
IF( role_id > 0 ) THEN
	set @query = CONCAT(" SELECT SQL_CALC_FOUND_ROWS tblServers.ServerID,tblServers.ServerName,tblServers.ServerIP,tblServers.Status,tblServers.BuildNo FROM `tblServers` INNER JOIN `tblServerRoles` ON tblServers.ServerID=tblServerRoles.ServerID WHERE tblServerRoles.RoleID=",role_id," AND tblServers.IsDeleted=0 ");
	
ELSE
	set @query = " SELECT SQL_CALC_FOUND_ROWS ServerID, ServerName, ServerIP, Status, BuildNo FROM `tblServers` WHERE IsDeleted=0 ";
END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
WHEN 3 THEN
	SELECT ServerID, ServerName, ServerIP, ServerType FROM tblServers WHERE ((IsDeleted = 0) OR (IsDeleted IS NULL));
WHEN 4 THEN 
	SELECT * FROM tblServers WHERE ((IsDeleted = 0) OR (IsDeleted IS NULL)) AND IsMaster=1;
END CASE;
END

go
CREATE PROCEDURE `sp_get_websites_with_scripting_status`(in offset int, in no_of_records int, in user_id VARCHAR(500),in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
IF( user_level = "host" ) THEN
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.OwnerID,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName,tblWebsiteResources.PHPEnabled,tblWebsiteResources.PerlEnabled FROM tblWebsites LEFT JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID WHERE 1=1 ");
ELSEIF (user_level = "reseller") THEN
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.OwnerID,tblUsers.UserName,tblWebsiteResources.PHPEnabled,tblWebsiteResources.PerlEnabled FROM tblWebsites LEFT JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID IN ( SELECT UserID FROM tblUsers Where OwnerID=",user_id,")");
ELSE
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.OwnerID,tblUsers.UserName,tblWebsiteResources.PHPEnabled,tblWebsiteResources.PerlEnabled FROM tblWebsites INNER JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID=",user_id);
END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_countries_select`(in selection int)
BEGIN
CASE selection 
WHEN 1 THEN 
	SELECT * FROM `tblCountries` ;
END CASE;
END

go
CREATE PROCEDURE `sp_disk_usage_settings_insert`(in user_id INT,in send_diskusage_report BOOLEAN,in disk_usage_report_frequency INT,in send_disk_usage_warnings BOOLEAN, in disk_usage_limit DOUBLE,in cc_warning_email_toowner BOOLEAN,in threshold_limit DOUBLE,in threshold_action INT,
in add_on_quantity INT,in disk_usage_calc_frequency INT,in disk_usage_calc_start_time INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF EXISTS(SELECT * FROM tblDiskUsageSettings WHERE UserID = user_id) THEN
		
      UPDATE tblDiskUsageSettings SET
      UserID	 = user_id,EmailDUReport = send_diskusage_report,DUReportFreq = disk_usage_report_frequency,
      DUWarningEmail = send_disk_usage_warnings,DULimit = disk_usage_limit,CCToOwner = cc_warning_email_toowner,ThresholdLimit = threshold_limit,
      ThresholdAction = threshold_action,AddOnQuantity = add_on_quantity,DUCalcFreq = disk_usage_calc_frequency,DUCalcStartTime = disk_usage_calc_start_time
      WHERE (UserID = user_id);
   ELSE
      INSERT INTO tblDiskUsageSettings			   (UserID,EmailDUReport,DUReportFreq,DUWarningEmail,DULimit,CCToOwner,ThresholdLimit,ThresholdAction,AddOnQuantity,DUCalcFreq,DUCalcStartTime)
			values(	user_id,
				send_diskusage_report,
				disk_usage_report_frequency,
				send_disk_usage_warnings,
				disk_usage_limit,
				cc_warning_email_toowner,
				threshold_limit,
				threshold_action,
				add_on_quantity,
				disk_usage_calc_frequency,
				disk_usage_calc_start_time);
   END IF;
	
SET status='success';
END



go
CREATE PROCEDURE `sp_allocated_ips_insert`(in user_id INT, in server_id INT, in ip_address VARCHAR(250), in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
CASE selection 
WHEN 1 THEN
	insert into tblAllocatedIPs(UserID,ServerID,IPAddress) values(user_id,server_id,ip_address);
END CASE;
SET status='success';
END

go
CREATE PROCEDURE `sp_nat_manager_insert`(in server_id INT,in eip VARCHAR(250), in iip VARCHAR(250),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
	Insert into tblNATManager (ExternalIP,InternalIP,ServerID) values (eip,iip,server_id);
SET status='success';
END

go
CREATE PROCEDURE `sp_plan_insert`(in user_id INT, in plan_name VARCHAR(1000), in promotion_price decimal(19,2), in plan_desc varchar(4000), in recurring_price double, in plan_status int, in promotion_duration int, in recurring_duration int, in setup_price double,in cancellation_policy varchar(4000),in is_deleted tinyint(1),in auto_signup_display tinyint(1),in display_index int,in monthly_price double,in quarterly_price double,in biAnnual_price double,in yearly_price double,in default_duration int,in is_windows int,in default_setup_discount double,in default_recurring_discount double,in plan_mode_id int, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblPlans` (`UserID`, `PlanName`,`PromotionPrice`,`PlanDesc`,`RecurringPrice`,`Status`,`PromotionDuration`,`RecurringDuration`,`SetupPrice`,`CancellationPolicy`,`IsDeleted`,`AutoSignupDisplay`,`DisplayIndex`,`MonthlyPrice`,`QuarterlyPrice`,`BiAnnualPrice`,`YearlyPrice`,`DefaultDuration`,`IsWindows`,`DefaultSetupDiscount`,`DefaultRecurringDiscount`,`PlanModeID`) values (user_id,plan_name,promotion_price,plan_desc,recurring_price,plan_status,promotion_duration,recurring_duration, setup_price,cancellation_policy,is_deleted,auto_signup_display,display_index,monthly_price,quarterly_price,biAnnual_price ,yearly_price,default_duration ,is_windows ,default_setup_discount ,default_recurring_discount,plan_mode_id);
END

go
CREATE PROCEDURE `sp_server_role_select`(in server_id int, in role_id int,in selection INT)
BEGIN
CASE selection
WHEN 1 THEN SELECT `ServerRoleConfiguration`  FROM `tblServerRoles` WHERE `ServerID`=server_id AND `RoleID`=role_id AND `ServerRoleConfiguration` != "" AND  `ServerRoleConfiguration` IS NOT NULL AND `RoleStatus` = 1;
WHEN 2 THEN SELECT *  FROM `tblServerRoles` WHERE `ServerID`=server_id AND `RoleID`=role_id AND `RoleStatus` = 1;
WHEN 3 THEN SELECT * FROM `tblServerRoles` WHERE `ServerID`=server_id AND `RoleStatus` = 1;
WHEN 4 THEN SELECT `ServerID` FROM `tblServerRoles` WHERE `RoleID`=role_id AND `RoleStatus` = 1;
WHEN 5 THEN SELECT `ServerID`,`ServerName`,`ServerIP` FROM `tblServers` WHERE `ServerID` IN (SELECT `ServerID` FROM `tblServerRoles` WHERE `RoleID`=role_id AND `RoleStatus` = 1) AND Status = 1;
WHEN 6 THEN SELECT `ServerRoleConfiguration`  FROM `tblServerRoles` WHERE `ServerRoleID`=role_id AND `ServerRoleConfiguration` != "" AND  `ServerRoleConfiguration` IS NOT NULL AND `RoleStatus` = 1;
WHEN 7 THEN SELECT `ServerIP` FROM `tblServers` WHERE `ServerID` = (SELECT `ServerID` FROM `tblServerRoles` WHERE `ServerRoleID`=role_id AND `RoleStatus` = 1);
WHEN 8 THEN SELECT `ServerID` FROM `tblServerRoles` WHERE `ServerRoleID` = role_id;
WHEN 9 THEN SELECT `ServerRoleID`,`ServerID` FROM `tblServerRoles` WHERE `RoleID` = role_id AND `IsResellerOnly`=1 AND `RoleStatus`=1;
WHEN 10 THEN SELECT `ServerRoleID` FROM `tblServerRoles` WHERE `RoleID`=role_id AND `RoleStatus` = 1;
WHEN 11 THEN SELECT `ServerID`,`ServerName`,`ServerIP` FROM `tblServers` WHERE `ServerID` IN (SELECT `ServerID` FROM `tblServerRoles` WHERE `RoleID`=role_id AND `RoleStatus` = 1);
WHEN 12 THEN SELECT `ServerRoleID`,`ServerRoleConfiguration` FROM `tblServerRoles` WHERE `RoleID`=role_id AND `RoleStatus` = 1;
END CASE;
END

go
CREATE PROCEDURE `sp_get_property_enabled_websites`(in offset int, in no_of_records int, in user_ids VARCHAR(500),in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10),in website_property VARCHAR(20))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
DECLARE field_name varchar(50);
SET @START = offset;
SET @LIMIT = no_of_records;
IF( website_property = "stats" ) THEN
	SET field_name = "tblWebsiteResources.StatsEnabled";
ELSEIF( website_property = "php" ) THEN
	SET field_name = "tblWebsiteResources.PHPEnabled";
ELSEIF( website_property = "perl" ) THEN
	SET field_name = "tblWebsiteResources.PerlEnabled"; 
END IF;
IF( user_level = "host" ) THEN
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.OwnerID,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblWebsites INNER JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID WHERE ",field_name,"=1");
ELSEIF (user_level = "reseller") THEN
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.OwnerID,tblUsers.UserName FROM tblWebsites INNER JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE ",field_name,"=1 AND tblWebsites.OwnerID IN ( SELECT UserID FROM tblUsers Where OwnerID=",user_ids,")");
ELSE
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblWebsites.OwnerID,tblUsers.UserName FROM tblWebsites INNER JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE ",field_name,"=1 AND tblWebsites.OwnerID=",user_ids);
END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_get_mailserver_resource_sold_qty`(in resource_id INT, in user_id INT,in mail_server_type VARCHAR(100))
BEGIN
DECLARE total_quantity INT DEFAULT 0;
SET total_quantity=0;
IF(SELECT DISTINCT tblPlanResourceQty.QtyIncluded FROM tblPlanResourceQty INNER JOIN tblSoldPlans ON tblPlanResourceQty.PlanID=tblSoldPlans.PlanID INNER JOIN tblPlanMailServerType ON tblPlanMailServerType.PlanID=tblSoldPlans.PlanID WHERE tblPlanResourceQty.ResourceID=resource_id AND tblPlanResourceQty.QtyIncluded=-1 AND tblSoldPlans.PlanID IN (Select PlanID from tblPlans WHERE UserID=user_id AND IsDeleted=0) AND  tblPlanMailServerType.MailServerType=mail_server_type AND tblSoldPlans.CurrStatus=1 AND tblSoldPlans.IsDeleted=0 ) THEN
	SET total_quantity = -1;
ELSE
	SELECT SUM(tblPlanResourceQty.QtyIncluded) into total_quantity FROM tblPlanResourceQty INNER JOIN tblSoldPlans ON tblPlanResourceQty.PlanID=tblSoldPlans.PlanID INNER JOIN tblPlanMailServerType ON tblPlanMailServerType.PlanID=tblSoldPlans.PlanID WHERE tblPlanResourceQty.ResourceID=resource_id AND tblSoldPlans.PlanID IN (Select PlanID from tblPlans WHERE UserID=user_id AND IsDeleted=0) AND  tblPlanMailServerType.MailServerType=mail_server_type AND tblSoldPlans.CurrStatus=1 AND tblSoldPlans.IsDeleted=0;
END IF;
IF(total_quantity IS NULL ) THEN
		SET total_quantity = 0;
	END IF;
SELECT total_quantity;
END

go
CREATE PROCEDURE `sp_get_database_users`(in offset int, in no_of_records int, in database_id int,in condition_name varchar(1000), in condition_value varchar(1000), in selection INT)
BEGIN
DECLARE result varchar(500);
SET @START = offset;
SET @LIMIT = no_of_records;
set @query = CONCAT("SELECT UserName FROM tblDatabaseUsers WHERE DatabaseID=",database_id);
CASE selection 
WHEN 1 THEN
IF( no_of_records > 0 ) THEN
	set @query = CONCAT(@query,' LIMIT ?,?');
	PREPARE STMT FROM @query;
	EXECUTE STMT USING @START,@LIMIT;
ELSE
	PREPARE STMT FROM @query;
	EXECUTE STMT;
END IF;
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_get_databases`(in offset int, in no_of_records int, in user_ids VARCHAR(500),in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
IF( user_level = "host" ) THEN
set @query = "SELECT SQL_CALC_FOUND_ROWS tblDatabases.DatabaseID,tblDatabases.DatabaseName,tblWebsites.WebsiteName,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName,tblDatabases.DiskSpaceUsage,tblServers.ServerName,tblServers.ServerIP FROM tblDatabases INNER JOIN tblWebsites ON tblDatabases.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID INNER JOIN tblServerRoles ON tblDatabases.ServerRoleID=tblServerRoles.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE 1=1 ";
ELSE
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblDatabases.DatabaseID,tblDatabases.DatabaseName,tblWebsites.WebsiteName,tblUsers.UserName,tblDatabases.DiskSpaceUsage,tblDatabases.ServerRoleID,tblDatabases.InstanceName  FROM tblDatabases INNER JOIN tblWebsites ON tblDatabases.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID IN (",user_ids,")");
END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_disk_usage_settings_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblDiskUsageSettings` WHERE `UserID`= user_id;
END CASE;
END

go
CREATE PROCEDURE `sp_get_mailserver_resource_purchased_qty`(in resource_id INT, in user_id INT,in mail_server_type VARCHAR(100))
BEGIN
DECLARE total_quantity INT DEFAULT 0;
SET total_quantity=0;
IF(SELECT DISTINCT tblPlanResourceQty.QtyIncluded FROM tblPlanResourceQty INNER JOIN tblSoldPlans ON tblPlanResourceQty.PlanID=tblSoldPlans.PlanID INNER JOIN tblPlanMailServerType ON tblPlanMailServerType.PlanID=tblSoldPlans.PlanID WHERE tblPlanResourceQty.ResourceID=resource_id AND tblPlanResourceQty.QtyIncluded=-1 AND tblSoldPlans.UserID = user_id AND  tblPlanMailServerType.MailServerType=mail_server_type AND tblSoldPlans.CurrStatus=1 AND tblSoldPlans.IsDeleted=0 ) THEN
	SET total_quantity = -1;
ELSE
	SELECT SUM(tblPlanResourceQty.QtyIncluded) into total_quantity FROM tblPlanResourceQty INNER JOIN tblSoldPlans ON tblPlanResourceQty.PlanID=tblSoldPlans.PlanID INNER JOIN tblPlanMailServerType ON tblPlanMailServerType.PlanID=tblSoldPlans.PlanID WHERE tblPlanResourceQty.ResourceID=resource_id AND tblSoldPlans.UserID = user_id AND  tblPlanMailServerType.MailServerType=mail_server_type AND tblSoldPlans.CurrStatus=1 AND tblSoldPlans.IsDeleted=0;
END IF;
IF(total_quantity IS NULL ) THEN
		SET total_quantity = 0;
	END IF;
SELECT total_quantity;
END

go
CREATE PROCEDURE `sp_servers_select`(in offset INT, in no_of_records INT, in server_id int,in server_ip varchar(50))
BEGIN
SET @START = offset;
SET @LIMIT = no_of_records;
SET @DEL_STATUS = 0;
IF (no_of_records > 0 ) THEN
	PREPARE STMT FROM " SELECT * FROM `tblServers` WHERE IsDeleted=0 ORDER By `ServerID` DESC LIMIT ?,? ";
	EXECUTE STMT USING @START, @LIMIT;
ELSE
	IF(server_id != -1) THEN
		SELECT * FROM `tblServers` WHERE `ServerID`=server_id AND IsDeleted=0;
	ELSEIF(server_ip != "" ) THEN
		SELECT * FROM `tblServers` WHERE `ServerIP`=server_ip AND IsDeleted=0;
	ELSE
		SELECT * FROM `tblServers` WHERE IsDeleted=0;	
	END IF;
END IF;
END

go
CREATE PROCEDURE `sp_get_host_plans_to_import`(in offset int, in no_of_records int, in user_id INT,in sorted_field VARCHAR(200))
BEGIN
SET @START = offset;
SET @LIMIT = no_of_records;
SET @USERID = user_id;
SET @query = " SELECT SQL_CALC_FOUND_ROWS tblPlanVisibility.PlanID,tblPlans.PlanName FROM tblPlans INNER JOIN tblPlanVisibility ON tblPlans.PlanID=tblPlanVisibility.PlanID WHERE tblPlanVisibility.VisibleTo=? AND tblPlans.Status=1 AND tblPlans.IsDeleted=0 ";
IF( no_of_records > 0 ) THEN
	set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
	PREPARE STMT FROM @query;
	EXECUTE STMT USING @USERID,@START,@LIMIT;
ELSE
	set @query = CONCAT(@query,' ORDER BY ',sorted_field);	
	PREPARE STMT FROM @query;
	EXECUTE STMT USING @USERID;
END IF;	
END

go
CREATE PROCEDURE `sp_database_user_select`(in database_id INT, in user_name varchar(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `DatabaseUserID`,`UserPassword` FROM `tblDatabaseUsers` WHERE `DatabaseID`= database_id AND `UserName`=user_name;
WHEN 2 THEN
	SELECT `DatabaseUserID`,`UserName` FROM `tblDatabaseUsers` WHERE `DatabaseID`= database_id;
END CASE;
END

go
CREATE PROCEDURE `sp_nat_manager_select`(in server_id INT,in internal_ip VARCHAR(100), in selection INT )
BEGIN
CASE selection 
WHEN 1 THEN
	Select * From `tblNATManager` where `ServerID` = server_id;
WHEN 2 THEN
	Select `ExternalIP` From `tblNATManager` where `ServerID` = server_id AND `InternalIP` = internal_ip;
END CASE;
END

go
CREATE PROCEDURE `sp_plan_delete`(in plan_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblPlans` WHERE `PlanID`= plan_id;
DELETE FROM `tblPlanVisibility` WHERE `PlanID`= plan_id;
DELETE FROM `tblPlanResourceQty` WHERE `PlanID`= plan_id;
DELETE FROM `tblPlanMailServerType` WHERE `PlanID`= plan_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_load_balancer_settings_insert`(in user_id INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
INSERT INTO `tblLoadBalancerSettings` (`UserID`) values (user_id);
SET status='success';
END

go
CREATE PROCEDURE `sp_email_frequency_select`(in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblEmailFrequency`;
END CASE;
END

go
CREATE PROCEDURE `sp_get_mail_domains`(in offset int, in no_of_records int, in user_ids VARCHAR(500),in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
DROP TABLE IF EXISTS tt_MailDomains;
DROP TABLE IF EXISTS tt_MailOnlyDomains;
create TEMPORARY table tt_MailDomains
   (
      MailDomainID INT,
      MailDomainName VARCHAR(250),
      ServerRoleID int,
      WebsiteName VARCHAR(250),
	IsNameBased tinyint(1) default 0,
	IPAddress VARCHAR(25),		
	ServerName VARCHAR(250),
	ServerIP VARCHAR(25),
	UserName  VARCHAR(250)
   ) TYPE = ISAM;
IF( user_level = "host" ) THEN
set @query = "INSERT INTO tt_MailDomains SELECT SQL_CALC_FOUND_ROWS tblMailDomains.MailDomainID,tblMailDomains.MailDomainName,tblMailDomains.ServerRoleID,tblWebsites.WebsiteName,tblWebsites.IsNameBased,tblWebsites.IPAddress,tblServers.ServerName,tblServers.ServerIP,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblMailDomains INNER JOIN tblWebsites ON tblMailDomains.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID INNER JOIN tblServerRoles ON tblMailDomains.ServerRoleID=tblServerRoles.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE 1=1 ";
set @query1 = "INSERT INTO tt_MailDomains (MailDomainID,MailDomainName,ServerRoleID,IPAddress,ServerName,ServerIP,UserName) SELECT SQL_CALC_FOUND_ROWS tblMailOnlyMailDomains.MailDomainID,tblMailOnlyMailDomains.MailDomainName,tblMailOnlyMailDomains.ServerRoleID,tblServers.ServerIP AS IPAddress,tblServers.ServerName,tblServers.ServerIP, (select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblMailOnlyMailDomains INNER JOIN tblUsers WebAdmins ON tblMailOnlyMailDomains.UserID=WebAdmins.UserID INNER JOIN tblServerRoles ON tblMailOnlyMailDomains.ServerRoleID=tblServerRoles.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE 1=1 ";
ELSE
set @query = CONCAT("INSERT INTO tt_MailDomains SELECT SQL_CALC_FOUND_ROWS tblMailDomains.MailDomainID,tblMailDomains.MailDomainName,tblMailDomains.ServerRoleID,tblWebsites.WebsiteName,tblWebsites.IsNameBased,tblWebsites.IPAddress,tblServers.ServerName,tblServers.ServerIP,tblUsers.UserName  FROM tblMailDomains INNER JOIN tblWebsites ON tblMailDomains.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers  ON tblWebsites.OwnerID=tblUsers.UserID INNER JOIN tblServerRoles ON tblMailDomains.ServerRoleID=tblServerRoles.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE tblWebsites.OwnerID IN (",user_ids,")");
set @query1 = CONCAT("INSERT INTO tt_MailDomains (MailDomainID,MailDomainName,ServerRoleID,IPAddress,ServerName,ServerIP,UserName) SELECT SQL_CALC_FOUND_ROWS tblMailOnlyMailDomains.MailDomainID,tblMailOnlyMailDomains.MailDomainName,tblMailOnlyMailDomains.ServerRoleID,tblServers.ServerIP AS IPAddress,tblServers.ServerName,tblServers.ServerIP,tblUsers.UserName  FROM tblMailOnlyMailDomains INNER JOIN tblUsers  ON tblMailOnlyMailDomains.UserID=tblUsers.UserID INNER JOIN tblServerRoles ON tblMailOnlyMailDomains.ServerRoleID=tblServerRoles.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE tblMailOnlyMailDomains.UserID IN (",user_ids,")");
END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query1 = CONCAT(@query1,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query1;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_MailDomains LIMIT ? , ?";
		PREPARE STMT FROM @query2;
		EXECUTE STMT USING @START,@LIMIT;
		
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query1 = CONCAT(@query1,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query1;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_MailDomains";
		PREPARE STMT FROM @query2;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		#set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		#PREPARE STMT FROM @query;
		#EXECUTE STMT USING @START,@LIMIT;
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query1 = CONCAT(@query1,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query1;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_MailDomains LIMIT ? , ?";
		PREPARE STMT FROM @query2;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		#set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		#PREPARE STMT FROM @query;
		#EXECUTE STMT;
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query1 = CONCAT(@query1,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query1;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_MailDomains";
		PREPARE STMT FROM @query2;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_nat_manager_delete`(in nat_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblNATManager` WHERE `NATID` = nat_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_website_resource_delete`(in website_id INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
	DELETE from tblWebsiteResources where WebsiteID = website_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_dns_server_insert`(in website_id INT, in website_zone_name VARCHAR(100), in server_ip VARCHAR(250), in selection INT, out status VARCHAR(10))
BEGIN
DECLARE server_role_id INT;
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status= 'error';
CASE selection 
WHEN 1 THEN
select   ServerRoleID INTO server_role_id FROM tblServerRoles INNER JOIN
   tblRoles ON tblServerRoles.RoleID = tblRoles.RoleID INNER JOIN
   tblServers ON tblServerRoles.ServerID = tblServers.ServerID where  (tblRoles.Role = 'dnsserver') AND (tblServers.ServerIP = server_ip);
   Insert into
   tblDNSServer(WebsiteID,ServerRoleID,WebsiteZoneName)
values(website_id,server_role_id,website_zone_name);
END CASE;
END

go
CREATE PROCEDURE `sp_plan_update`(in plan_id INT, in plan_name VARCHAR(1000),in plan_desc varchar(4000), in cancellation_policy VARCHAR(4000), in plan_status int, in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection 
WHEN 1 THEN
	UPDATE `tblPlans` SET `PlanName`= plan_name,`PlanDesc`=plan_desc,`CancellationPolicy`=cancellation_policy,`Status`=plan_status WHERE `PlanID`=plan_id;      
WHEN 2 THEN 
	UPDATE `tblPlans` SET `Status`=plan_status WHERE `PlanID`=plan_id;
END CASE;
END

go
CREATE PROCEDURE `sp_database_user_update`(in database_user_id INT, in password varchar(50),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
UPDATE `tblDatabaseUsers` SET `UserPassword`= password WHERE `DatabaseUserID`=database_user_id;      
END

go
CREATE PROCEDURE `sp_server_role_update`(in server_id int, in role_id int, in role_configuration mediumtext,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
UPDATE `tblServerRoles` SET `ServerRoleConfiguration`=role_configuration WHERE `ServerID`=server_id AND `RoleID`=role_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_get_users_with_purchased_plans`(in offset int, in no_of_records int, in user_id INT,in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT)
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
SET @START = offset;
SET @LIMIT = no_of_records;
SET @USERID = user_id;
set @query = " SELECT SQL_CALC_FOUND_ROWS tblUsers.UserID,tblUsers.UserName,COUNT(tblSoldPlans.SoldPlanID) AS SoldInstances FROM `tblUsers` Left JOIN tblSoldPlans ON tblUsers.UserID=tblSoldPlans.UserID WHERE tblUsers.UserID IN (SELECT UserID from tblUsers WHERE OwnerID=?)";
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' GROUP BY tblSoldPlans.UserID',' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' GROUP BY tblSoldPlans.UserID',' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' GROUP BY tblSoldPlans.UserID',' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID,@START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' GROUP BY tblSoldPlans.UserID',' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @USERID;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_plan_visibility_delete`(in plan_id INT, in visible_to INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblPlanVisibility` WHERE `PlanId`=plan_id AND `VisibleTo`=visible_to;
SET status='success';
END

go
CREATE PROCEDURE `sp_plan_mail_server_type_select`(in field1 INT,in field2 varchar(500), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `MailServerType` FROM `tblPlanMailServerType` WHERE `PlanID`= field1;
WHEN 2 THEN
	set @query = CONCAT("SELECT DISTINCT `MailServerType` FROM `tblPlanMailServerType` WHERE `PlanID` IN ( SELECT DISTINCT `PlanID` FROM `tblSoldPlans` WHERE `UserID` IN (",field2,"))");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
WHEN 3 THEN
	SELECT tblPlanMailServerType.PlanID FROM tblPlanMailServerType INNER JOIN tblSoldPlans ON tblPlanMailServerType.PlanID=tblSoldPlans.PlanID WHERE tblSoldPlans.PlanID IN ( SELECT DISTINCT PlanID FROM tblSoldPlans WHERE UserID=field1 ) AND  tblPlanMailServerType.MailServerType=field2;
END CASE;
END

go
CREATE PROCEDURE `sp_sold_plan_delete`(in sold_plan_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
#UPDATE `tblSoldPlans` SET `IsDeleted`=1 WHERE `SoldPlanID`=sold_plan_id;
DELETE FROM `tblSoldPlans` WHERE `SoldPlanID`=sold_plan_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_authenticate_user`(in user_name VARCHAR(50), in user_password VARCHAR(100))
BEGIN
SELECT * FROM `tblUsers` WHERE (`UserLevel`!= 'ftpuser' AND `UserName`=user_name AND `UserPassword`=user_password AND `IsDisabled`=0 AND `IsDeleted`=0);
END

go
CREATE PROCEDURE `sp_server_delete`(in server_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
DELETE FROM tblServerRoles WHERE ServerID=server_id;
DELETE FROM tblServers WHERE ServerID=server_id;
END

go
CREATE PROCEDURE `sp_user_consumed_resources_qty_select`(in user_id int,in resource_id int,in selection INT)
BEGIN
CASE selection
WHEN 1 THEN SELECT `ConsumedQuantity`  FROM `tblUserConsumedResources` WHERE `UserID`=user_id AND `ResourceID`=resource_id;
END CASE;
END

go
CREATE PROCEDURE `sp_database_select`(in database_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblDatabases` WHERE `DatabaseID`= database_id;
WHEN 2 THEN
	SELECT `ServerID` FROM `tblServerRoles` WHERE `ServerRoleID`=(SELECT `ServerRoleID` FROM `tblUsersServers` WHERE `UserID`=(SELECT `OwnerID` FROM `tblWebsites` Where `WebsiteID`=(SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`=database_id)));
WHEN 3 THEN
	SELECT `UserID`,`UserName` FROM `tblUsers` WHERE `UserID`=(SELECT `OwnerID` FROM `tblWebsites` Where `WebsiteID`=(SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`=database_id));
WHEN 4 THEN
	SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`= database_id; 
WHEN 5 THEN 
	select SUM(DiskSpaceUsage) from tblDatabases where WebsiteID IN (select WebsiteID from tblWebsites where OwnerID=database_id);
WHEN 50 THEN 
	SELECT COUNT(DatabaseID) FROM tblDatabases;
END CASE;
END

go
CREATE PROCEDURE `sp_user_profile_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `FirstName`,`LastName` FROM `tblUsersProfile` WHERE `UserID`= user_id;
WHEN 2 THEN
	SELECT `EmailAddress` FROM `tblUsersProfile` WHERE `UserID`= user_id;
WHEN 3 THEN
	SELECT `Company` FROM `tblUsersProfile` WHERE `UserID`= user_id;
WHEN 4 THEN
	SELECT * FROM `tblUsersProfile` WHERE `UserID`= user_id;
END CASE;
END

go

CREATE PROCEDURE sp_get_users(v_UserID INT, 
v_ServerID INT ,
v_UserLevel NATIONAL VARCHAR(250) ,
v_ServerType NATIONAL VARCHAR(250) ,
v_SearchCritList NATIONAL VARCHAR(4000) ,
v_SearchValueList NATIONAL VARCHAR(4000) ,
v_PageSize INT ,
v_PageNumber INT,
v_SortField VARCHAR(50),
INOUT v_TotalRecords INT 

 )
BEGIN
   DECLARE v_Where NATIONAL VARCHAR(4000); 
   DECLARE v_SearchStr NATIONAL VARCHAR(4000);

   DECLARE v_SearchCrit NATIONAL VARCHAR(250); 
   DECLARE v_tid INT; 
   DECLARE v_SearchValue NATIONAL VARCHAR(250);
   DECLARE v_FirstRec INT;
   DECLARE v_LastRec INT;


   DECLARE v_TempQuery NATIONAL VARCHAR(4000);
   DECLARE NO_DATA INT DEFAULT 0;
   declare Search_Cursor cursor for select SearchCrit, tid from tt_tbltempSearchCrit;
   DECLARE CONTINUE HANDLER FOR SQLEXCEPTION
   BEGIN
      SET NO_DATA = -2;
   END;
   DECLARE CONTINUE HANDLER FOR NOT FOUND SET NO_DATA = -1;
   IF v_ServerID is null then
      set v_ServerID = 0;
   END IF;
   IF v_UserLevel is null then
      set v_UserLevel = '';
   END IF;
   IF v_ServerType is null then
      set v_ServerType = '';
   END IF;
   IF v_SearchCritList is null then
      set v_SearchCritList = '';
   END IF;
   IF v_SearchValueList is null then
      set v_SearchValueList = '';
   END IF;
   IF v_PageSize is null then
      set v_PageSize = 15;
   END IF;
   set v_SearchStr = ' and 1 = 1';

   set v_Where =  'where  ( tblUsers.isdeleted =0 or tblUsers.isdeleted is null)  ';

   if((select UserLevel from tblUsers where UserID = v_UserID) != 'host') then
      set v_Where = CONCAT(v_Where,' and OwnerID= ',cast(v_UserID as CHAR(30)));
   else 
      if(v_UserLevel != '') then
         set v_Where = CONCAT(v_Where,' and UserLevel = ''',v_UserLevel,'''');
      end if;
   end if;


   if(v_ServerType != '') then
      set v_Where = CONCAT(v_Where,' and ServerType = ''',v_ServerType,'''');
   end if;

   if(v_ServerID != 0) then
      set v_Where = CONCAT(v_Where,' and tblServers.ServerId = ',CAST(v_ServerID AS CHAR(30)));
   end if;


   DROP TEMPORARY TABLE IF EXISTS tt_tbltempSearchCrit;
   create TEMPORARY table tt_tbltempSearchCrit
   (
      tid INT,
      SearchCrit NATIONAL VARCHAR(250)
   ) TYPE = ISAM; 

   CALL prosplit(v_SearchCritList,',');
	insert into tt_tbltempSearchCrit select * from tt_tbltemp;

	DROP TABLE IF EXISTS tt_tbltemp;
   DROP TEMPORARY TABLE IF EXISTS tt_tbltempSearchValue;
   create TEMPORARY table tt_tbltempSearchValue
   (
      tid INT,
      SearchValue NATIONAL VARCHAR(250)
   ) TYPE = ISAM; 
CALL prosplit(v_SearchValueList,',');
   insert into tt_tbltempSearchValue select * from tt_tbltemp;

DROP TABLE IF EXISTS tt_tbltemp;

   open Search_Cursor;
   SET NO_DATA = 0;
   FETCH Search_Cursor
   INTO v_SearchCrit,v_tid;
   WHILE NO_DATA = 0 DO
      select   SearchValue INTO v_SearchValue from tt_tbltempSearchValue where tid = v_tid;
      set v_SearchStr = CONCAT(v_SearchStr,' and ',v_SearchCrit,' like ''%',v_SearchValue,'%''');
      SET NO_DATA = 0;
      FETCH Search_Cursor
      INTO v_SearchCrit,v_tid;
   END WHILE;
   CLOSE Search_Cursor;

   if(v_PageSize = 0) then
      select   count(*) INTO v_PageSize from tblUsers;
   end if; 



   Set v_FirstRec =(v_PageNumber -1)*v_PageSize;
   Set v_LastRec =(v_PageNumber*v_PageSize+1);

   DROP TEMPORARY TABLE IF EXISTS tt_TempTable;
   Create TEMPORARY Table tt_TempTable
   (
      IID INT PRIMARY KEY  AUTO_INCREMENT,
      UserID INT
   ) TYPE = ISAM;




   set v_TempQuery = 'Insert Into tt_TempTable ( UserID )';
   set v_TempQuery = CONCAT(v_TempQuery,'SELECT tblUsers.UserID FROM tblUsers Left Outer JOIN tblUsersProfile ON tblUsers.UserID = tblUsersProfile.UserID INNER JOIN');
   set v_TempQuery = CONCAT(v_TempQuery,'  tblUsersServers ON tblUsers.UserID = tblUsersServers.UserID INNER JOIN tblServerRoles ON tblUsersServers.ServerRoleID = tblServerRoles.ServerRoleID'); 
   set v_TempQuery = CONCAT(v_TempQuery,'  INNER JOIN tblServers ON tblServerRoles.ServerID = tblServers.ServerID ');
   set v_TempQuery = CONCAT(v_TempQuery,v_Where,v_SearchStr);
    set v_TempQuery = CONCAT(v_TempQuery,' Order By ',v_SortField);
SET @SWV_Stmt = v_TempQuery;

   PREPARE SWT_Stmt FROM @SWV_Stmt;
   EXECUTE SWT_Stmt;
   DEALLOCATE PREPARE SWT_Stmt;


   select   Count(*) INTO v_TotalRecords From tt_TempTable;

   if((select UserLevel from tblUsers where UserID = v_UserID) = 'host') then

      SELECT     tblUsers.UserID, tblUsers.UserName, tblUsers.Description, tblUsers.IsDisabled,tblUsersProfile.FirstName,tblUsersProfile.LastName,tblUsers.UserLevel, tblServers.ServerName, tblServers.ServerIP,tblServerRoles.IsResellerOnly,(select UserName from tblUsers as T1 where T1.UserID = tblUsers.OwnerID) as OwnerName
      FROM         tblUsers INNER JOIN
      tblUsersServers ON tblUsers.UserID = tblUsersServers.UserID INNER JOIN
      tt_TempTable ON tt_TempTable.UserID = tblUsers.UserID INNER JOIN
      tblServerRoles ON tblUsersServers.ServerRoleID = tblServerRoles.ServerRoleID INNER JOIN
      tblServers ON tblServerRoles.ServerID = tblServers.ServerID LEFT OUTER JOIN
      tblUsersProfile ON tblUsers.UserID = tblUsersProfile.UserID
      Where  tblUsers.UserLevel != 'host' And tblUsers.UserID = tt_TempTable.UserID and tt_TempTable.IID > v_FirstRec and tt_TempTable.IID < v_LastRec order by IID;
   else
      if((select UserLevel from tblUsers where UserID = v_UserID) = 'reseller' and(select UserID from tblLoadBalancerSettings where UserID = v_UserID) = v_UserID) then
			
         SELECT     tblUsers.UserID, tblUsers.UserName, tblUsers.Description, tblUsers.IsDisabled,tblUsersProfile.FirstName,tblUsersProfile.LastName,tblUsers.UserLevel, tblServers.ServerName, tblServers.ServerIP,tblServerRoles.IsResellerOnly,(select UserName from tblUsers as T1 where T1.UserID = tblUsers.OwnerID) as OwnerName
         FROM         tblUsers INNER JOIN
         tblUsersServers ON tblUsers.UserID = tblUsersServers.UserID INNER JOIN
         tt_TempTable ON tt_TempTable.UserID = tblUsers.UserID INNER JOIN
         tblServerRoles ON tblUsersServers.ServerRoleID = tblServerRoles.ServerRoleID INNER JOIN
         tblServers ON tblServerRoles.ServerID = tblServers.ServerID LEFT OUTER JOIN
         tblUsersProfile ON tblUsers.UserID = tblUsersProfile.UserID
         Where  tblUsers.UserID = tt_TempTable.UserID and tt_TempTable.IID > v_FirstRec and tt_TempTable.IID < v_LastRec order by IID;
      else
         SELECT     tblUsers.UserID, tblUsers.UserName, tblUsers.Description,tblUsers.IsDisabled, tblUsersProfile.FirstName,tblUsersProfile.LastName,tblUsers.UserLevel,(select UserName from tblUsers as T1 where T1.UserID = tblUsers.OwnerID) as OwnerName
         FROM         tblUsers INNER JOIN
         tt_TempTable ON tt_TempTable.UserID = tblUsers.UserID LEFT OUTER JOIN
         tblUsersProfile ON tblUsers.UserID = tblUsersProfile.UserID
         Where  tblUsers.UserID = tt_TempTable.UserID and tt_TempTable.IID > v_FirstRec and tt_TempTable.IID < v_LastRec order by IID;
      end if;
   end if;
END;

go
CREATE PROCEDURE `sp_import_plan`(in plan_ids VARCHAR(100),in user_id INT, out status VARCHAR(10))
BEGIN 
declare start_position int;
declare split_position int;
declare prev_split_position int;
DECLARE plan_id INT;
DECLARE plan_name VARCHAR(200);
DECLARE new_plan_name VARCHAR(200);
DECLARE new_plan_id INT;
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
set start_position = 1;
set split_position = 1;
set prev_split_position = 1;
while( split_position > 0 ) do
	set split_position = LOCATE(',',plan_ids,start_position);
	IF( split_position > 0 ) THEN
		set plan_id = SUBSTR(plan_ids,prev_split_position,split_position-prev_split_position); 
		SELECT PlanName INTO plan_name FROM tblPlans WHERE PlanID=plan_id;
		set new_plan_name = CONCAT(plan_name,'_',NOW());
		DROP TABLE IF EXISTS tt_ImportPlan; 	
		CREATE TEMPORARY TABLE tt_ImportPlan ENGINE=MEMORY SELECT `UserID`, 			`PlanName`,`PromotionPrice`,`PlanDesc`,`RecurringPrice`,Status,`PromotionDuration`,`RecurringDuration`,`SetupPrice`,`CancellationPolicy`,`IsDeleted`,`AutoSignupDisplay`,`DisplayIndex`,`MonthlyPrice`,`QuarterlyPrice`,`BiAnnualPrice`,`YearlyPrice`,`DefaultDuration`,`IsWindows`,`DefaultSetupDiscount`,`DefaultRecurringDiscount`,`PlanModeID` FROM tblPlans WHERE PlanID=plan_id;
  		UPDATE tt_ImportPlan SET PlanName=new_plan_name,UserID=user_id,`Status`=1;
		INSERT INTO tblPlans (`UserID`, 	`PlanName`,`PromotionPrice`,`PlanDesc`,`RecurringPrice`,`Status`,`PromotionDuration`,`RecurringDuration`,`SetupPrice`,`CancellationPolicy`,`IsDeleted`,`AutoSignupDisplay`,`DisplayIndex`,`MonthlyPrice`,`QuarterlyPrice`,`BiAnnualPrice`,`YearlyPrice`,`DefaultDuration`,`IsWindows`,`DefaultSetupDiscount`,`DefaultRecurringDiscount`,`PlanModeID`) SELECT * FROM tt_ImportPlan;
 		  DROP TABLE tt_ImportPlan;
		SELECT PlanID INTO new_plan_id FROM tblPlans WHERE PlanName=new_plan_name;
		DROP TABLE IF EXISTS tt_PlanResourceQty; 	
		CREATE TEMPORARY TABLE tt_PlanResourceQty ENGINE=MEMORY SELECT * FROM tblPlanResourceQty WHERE PlanID=plan_id;
		UPDATE tt_PlanResourceQty SET PlanID=new_plan_id;
		INSERT INTO tblPlanResourceQty SELECT * FROM tt_PlanResourceQty;
		DROP TABLE tt_PlanResourceQty;
	
		DROP TABLE IF EXISTS tt_tblPlanMailServerType; 	
		CREATE TEMPORARY TABLE tt_tblPlanMailServerType ENGINE=MEMORY SELECT * FROM tblPlanMailServerType WHERE PlanID=plan_id;
		UPDATE tt_tblPlanMailServerType SET PlanID=new_plan_id;
		INSERT INTO tblPlanMailServerType SELECT * FROM tt_tblPlanMailServerType;
		DROP TABLE tt_tblPlanMailServerType;
		set prev_split_position = split_position+1;
		set start_position = split_position + 1;
		
	END IF;
end while;
SET status='success';
END

go
CREATE PROCEDURE `sp_actions_select`(in selection INT )
BEGIN
CASE selection 
WHEN 1 THEN
	Select * From `tblActions` WHERE `IsResellerAction` = false;
WHEN 2 THEN
	Select * From `tblActions` WHERE `IsResellerAction` = true;
END CASE;
END

go
CREATE PROCEDURE `sp_get_total_user_consumed_maildomains`(in user_id INT, in server_role_id VARCHAR(100),in selection INT)
BEGIN
CASE selection
WHEN 1 THEN 
	SET @query = CONCAT("SELECT COUNT(ServerRoleID) INTO @mail_domains_count FROM tblMailDomains WHERE WebsiteID IN (SELECT WebsiteID FROM tblWebsites WHERE OwnerID=",user_id,") AND ServerRoleID IN (",server_role_id,")");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
	SET @query=CONCAT("SELECT COUNT(ServerRoleID) INTO @mail_only_domains_count FROM tblMailOnlyMailDomains WHERE UserID=",user_id," AND ServerRoleID IN (",server_role_id,")");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
	SET @mail_domains_count = @mail_domains_count + @mail_only_domains_count;
	SELECT @mail_domains_count;
END CASE;
END

go
CREATE PROCEDURE `sp_emails_select`(in offset int,in no_of_records int,in condition_name varchar(1000),in condition_value varchar(1000),in sorted_field varchar(100),in selection INT, in mail_status INT,in user_id INT)

BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);

SET @MAILSTATUS = mail_status;
SET @USERID = user_id;
SET @START = offset;
SET @LIMIT = no_of_records;

DROP TABLE IF EXISTS tt_Emails;

create TEMPORARY table tt_Emails
   (
	MailID INT,
	MailSubject VARCHAR(250),
	ToAddress VARCHAR(250),
	FromAddress VARCHAR(250),
	MailType VARCHAR(50),
	SentTime timestamp
   ) TYPE = ISAM;

set @query = "INSERT INTO tt_Emails SELECT SQL_CALC_FOUND_ROWS tblEMails.MailID,tblEMails.MailSubject,tblEMails.ToAddress,tblEMails.FromAddress, (SELECT tblMailTemplates.Subject From tblMailTemplates WHERE tblMailTemplates.MailTemplateId = tblEMails.MailType) AS MailType, tblEMails.SentTime AS SentTime From tblEMails WHERE tblEMails.MailStatus = ? AND tblEMails.OwnerId = ?";

CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @MAILSTATUS,@USERID;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Emails LIMIT ? , ?";
		PREPARE STMT FROM @query2;
		EXECUTE STMT USING @START,@LIMIT;

	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Emails";
		PREPARE STMT FROM @query2;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @MAILSTATUS,@USERID;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Emails LIMIT ? , ?";
		PREPARE STMT FROM @query2;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
		set @query2 = "select SQL_CALC_FOUND_ROWS * from tt_Emails";
		PREPARE STMT FROM @query2;
		EXECUTE STMT;
	END IF;
END CASE;
END

go
CREATE PROCEDURE `sp_user_insert`(in user_name VARCHAR(50), in user_level VARCHAR(50), in user_password varchar(100), in description varchar(200), in owner_id int, in is_disabled tinyint(1), in is_deleted tinyint(1), in setup_date TIMESTAMP,in last_modified_date TIMESTAMP,in sold_plan_id INT,in trash_id INT,in date_deleted DATETIME,in disk_space_usage DOUBLE,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblUsers` (`UserName`, `UserLevel`,`UserPassword`,`Description`,`OwnerID`,`IsDisabled`,`IsDeleted`,`SetupDate`,`LastModifiedDate`,`SoldPlanID`,`TrashId`,`DiskspaceUsage`) values (user_name,user_level,user_password,description,owner_id,is_disabled,is_deleted,setup_date,last_modified_date,sold_plan_id,trash_id,disk_space_usage);
END

go
CREATE PROCEDURE `sp_mail_delivery_settings_insert`(in user_id INT,in mail_delivery_type VARCHAR(250),in dns_server VARCHAR(250), in smtp_server VARCHAR(250),
in from_email VARCHAR(250),in smtp_auth BOOLEAN, in auth_user VARCHAR(250), in auth_pwd VARCHAR(250),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF exists(select * from tblMailDeliverySettings where UserID = user_id) then
      update tblMailDeliverySettings set
      MailDeliveryType = mail_delivery_type,DNSServer = dns_server,SMTPServer = smtp_server,
      FromAddress = from_email,SMTPAuth = smtp_auth,AuthUser = auth_user, AuthPassword = auth_pwd
      where UserID = user_id;
else
      insert into tblMailDeliverySettings(UserID, MailDeliveryType, DNSServer, SMTPServer, FromAddress, SMTPAuth, AuthUser, AuthPassword)
     values(user_id,mail_delivery_type,dns_server,smtp_server,from_email,smtp_auth,auth_user,auth_pwd);
end if;
SET status='success';
END

go
CREATE PROCEDURE `sp_user_update`(in user_id INT,in field1 VARCHAR(200), in field2 tinyint(1), in field3 TIMESTAMP, in field4 DATETIME,in field5 DOUBLE, in selection INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection
WHEN 1 THEN UPDATE `tblUsers` SET `UserPassword`=field1,`LastModifiedDate`=field3 WHERE `UserID`=user_id;
WHEN 2 THEN UPDATE `tblUsers` SET `Description`=field1,`LastModifiedDate`=field3 WHERE `UserID`=user_id;
WHEN 3 THEN UPDATE `tblUsers` SET `IsDisabled`=field2,`LastModifiedDate`=field3 WHERE `UserID`=user_id;
WHEN 4 THEN UPDATE `tblUsers` SET `IsDeleted`=field2,`DateDeleted`=field4 WHERE `UserID`=user_id;
WHEN 5 THEN UPDATE `tblUsers` SET `DiskspaceUsage`=field4,`LastModifiedDate`=field3 WHERE `UserID`=user_id;
WHEN 6 THEN UPDATE `tblUsers` SET `IsDedicated`=1 WHERE `UserID`=user_id;
END CASE;
END

go
CREATE PROCEDURE `sp_database_user_delete`(in id INT,in selection INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection
When 1 THEN
	DELETE FROM `tblDatabaseUsers` WHERE `DatabaseUserID`=id;      
When 2 THEN
	DELETE FROM `tblDatabaseUsers` WHERE `DatabaseID`=id;
END CASE;
END

go
CREATE PROCEDURE `sp_mail_delivery_settings_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblMailDeliverySettings` WHERE `UserID`= user_id;
END CASE;
END

go
CREATE PROCEDURE `sp_roles_select`(in role_id int,in selection INT)
BEGIN
CASE selection
WHEN 1 THEN SELECT `RoleGlobalSettings`  FROM `tblRoles` WHERE `RoleID`=role_id AND `RoleGlobalSettings` != "" AND `RoleGlobalSettings` IS NOT NULL;
WHEN 2 THEN SELECT `RoleID`,`RoleDescName`,`RoleDesc`,`DefaultCapacity`  FROM `tblRoles` WHERE `RoleGlobalSettings` != "" AND `RoleGlobalSettings` IS NOT NULL;
WHEN 3 THEN SELECT `RoleID` FROM `tblRoles`;
WHEN 4 THEN SELECT `RoleID` FROM `tblRoles` WHERE `RoleGlobalSettings` != "" AND `RoleGlobalSettings` IS NOT NULL;
ELSE
	SELECT * FROM `tblServerServices` WHERE `ServerServiceStatus`=1;
END CASE;
END

go
CREATE PROCEDURE `sp_emails_delete`(in mail_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
DELETE FROM `tblEMails` WHERE `MailID` = mail_id;
SET status='success';
END

go
CREATE PROCEDURE `sp_load_balancer`(in server_role varchar(50),in is_reseller_only tinyint(1),in selection INT)
BEGIN
IF(server_role = 'webserver') THEN
SELECT  COUNT(tblServers.ServerID), tblServers.ServerID FROM  tblRoles INNER JOIN tblServerRoles ON tblRoles.RoleID = tblServerRoles.RoleID LEFT OUTER JOIN tblUsersServers ON tblServerRoles.ServerRoleID = tblUsersServers.ServerRoleID LEFT OUTER JOIN tblWebsites ON tblUsersServers.UserID = tblWebsites.OwnerID INNER JOIN tblServers ON tblServerRoles.ServerID = tblServers.ServerID where ((tblServers.IsDeleted = 0) OR (tblServers.IsDeleted IS NULL) )  and tblServers.Status=1 and isResellerOnly=is_reseller_only and RoleStatus=1 and tblRoles.Role =server_role GROUP BY tblServers.ServerID ORDER BY COUNT(tblServers.ServerID);
ELSEIF(server_role='dnsserver') THEN
SELECT   tblServers.ServerID, COUNT(tblDNSServer.WebSiteID) AS Count FROM  tblRoles INNER JOIN tblServerRoles ON tblRoles.RoleID = tblServerRoles.RoleID LEFT OUTER JOIN tblDNSServer ON tblServerRoles.ServerRoleID = tblDNSServer.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID = tblServers.ServerID where ((tblServers.IsDeleted = 0) OR (tblServers.IsDeleted IS NULL) )  and tblServers.Status=1 and isResellerOnly=is_reseller_only and RoleStatus=1 and tblRoles.Role =server_role GROUP BY tblServers.ServerID, tblRoles.Role ORDER BY COUNT(tblDNSServer.WebSiteID);

ELSEIF(server_role='databaseserver') THEN
SELECT   tblServerRoles.ServerID, COUNT(tblDatabases.DatabaseID) AS Count FROM  tblRoles INNER JOIN tblServerRoles ON tblRoles.RoleID = tblServerRoles.RoleID LEFT OUTER JOIN tblDatabases ON tblServerRoles.ServerRoleID = tblDatabases.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID = tblServers.ServerID where ((tblServers.IsDeleted = 0) OR (tblServers.IsDeleted IS NULL) )  and tblServers.Status=1 and isResellerOnly=is_reseller_only and RoleStatus=1 and tblRoles.Role =server_role GROUP BY tblServers.ServerID ORDER BY COUNT(tblDatabases.DatabaseID);

ELSEIF(server_role='mailserver') THEN
DROP TABLE IF EXISTS tt_MailDomains;
DROP TABLE IF EXISTS tt_MailOnlyDomains;
CREATE TEMPORARY TABLE tt_MailDomains ENGINE=MEMORY SELECT tblServerRoles.ServerID, COUNT(tblMailDomains.MailDomainID) AS Count FROM  tblRoles INNER JOIN tblServerRoles ON tblRoles.RoleID = tblServerRoles.RoleID LEFT OUTER JOIN tblMailDomains ON tblServerRoles.ServerRoleID = tblMailDomains.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID = tblServers.ServerID where ((tblServers.IsDeleted = 0) OR (tblServers.IsDeleted IS NULL) )  and tblServers.Status=1 and isResellerOnly=is_reseller_only and RoleStatus=1 and tblRoles.Role =server_role GROUP BY tblRoles.Role, tblServerRoles.ServerID ORDER BY COUNT(tblMailDomains.MailDomainID);

CREATE TEMPORARY TABLE tt_MailOnlyDomains ENGINE=MEMORY SELECT tblServerRoles.ServerID, COUNT(tblMailOnlyMailDomains.MailDomainID) AS Count FROM  tblRoles INNER JOIN tblServerRoles ON tblRoles.RoleID = tblServerRoles.RoleID LEFT OUTER JOIN tblMailOnlyMailDomains ON tblServerRoles.ServerRoleID = tblMailOnlyMailDomains.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID = tblServers.ServerID where ((tblServers.IsDeleted = 0) OR (tblServers.IsDeleted IS NULL) )  and tblServers.Status=1 and isResellerOnly=is_reseller_only and RoleStatus=1 and tblRoles.Role =server_role GROUP BY tblRoles.Role, tblServerRoles.ServerID ORDER BY COUNT(tblMailOnlyMailDomains.MailDomainID);

Select	tt_MailDomains.ServerID, (tt_MailDomains.Count + tt_MailOnlyDomains.Count) as Count 
	From	tt_MailDomains INNER JOIN tt_MailOnlyDomains
	ON		tt_MailDomains.ServerID = tt_MailOnlyDomains.ServerID
	Order By Count Asc;
DROP TABLE tt_MailDomains;
DROP TABLE tt_MailOnlyDomains;	

END IF;
END

go

