DROP PROCEDURE IF EXISTS `sp_dns_server_select`;

go

CREATE PROCEDURE `sp_dns_server_select`(in field1 INT, in field2 varchar(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT (SELECT ServerRoleID FROM tblDNSServer WHERE WebsiteID=field1 AND WebsiteZoneName = field2) AS ServerRoleID, ServerID, ServerIP FROM tblServers WHERE ServerID=(SELECT ServerID FROM tblServerRoles WHERE ServerRoleID=(SELECT ServerRoleID FROM tblDNSServer WHERE WebsiteID=field1 AND WebsiteZoneName = field2));
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_dns_server_delete`;

go

CREATE PROCEDURE `sp_dns_server_delete`(in website_id INT, in zone_name VARCHAR(100), out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
Delete from tblDNSServer where WebsiteID = website_id AND WebsiteZoneName = zone_name;
SET status='success';
END

go

CREATE TABLE IF NOT EXISTS `tblClickAndInstallLicensedServer`
(
   `CANDIServerID` INT NOT NULL  AUTO_INCREMENT,
   `CANDIServerIP` VARCHAR(100),
   PRIMARY KEY(CANDIServerID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_lincesed_server_delete`;

go

CREATE PROCEDURE `sp_click_and_install_lincesed_server_delete`(in server_ip VARCHAR(250), out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
IF exists(select * from tblClickAndInstallLicensedServer where CANDIServerIP = server_ip) then
	delete from tblClickAndInstallLicensedServer where CANDIServerIP = server_ip;
END IF;
SET status='success';
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_lincesed_server_insert`;

go

CREATE PROCEDURE `sp_click_and_install_lincesed_server_insert`(in server_ip VARCHAR(250), in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
CASE selection 
WHEN 1 THEN
	insert into tblClickAndInstallLicensedServer(CANDIServerIP) values(server_ip);
END CASE;
SET status='success';
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_lincesed_server_select`;

go

CREATE PROCEDURE `sp_click_and_install_lincesed_server_select`()
BEGIN
SELECT * FROM `tblClickAndInstallLicensedServer`;
END

go

insert into tblResources values(14,'cms','Content Management System','Install on click cms',0,1,0,.00,.00,1,505,1,1,NULL,1,1,1,22,0,1,'cms-manager.png',0);

go

insert into tblResources values(15,'helpdesk','Customer Support Solution','Install on click helpdesk',0,1,0,.00,.00,1,510,1,1,NULL,1,1,1,21,0,1,'helpdesk-manager.png',0);

go

insert into tblResources values(16,'e-cards','E-Cards','Install on click E-Card Manager',0,1,0,.00,.00,1,515,1,1,NULL,1,1,1,26,0,1,'ECard-Manager.png',0);

go

insert into tblResources values(17,'e-commerce','E-Commerce','Install on click e-commerce',0,1,0,.00,.00,1,520,1,1,NULL,1,1,1,18,0,1,'ecom-manager.png',0);

go

insert into tblResources values(18,'mysqlwebdataadmin','MySQL Web Data Administrator','Install on click MySQL web data admin',0,1,0,.00,.00,1,525,1,1,NULL,1,1,1,20,0,1,'WebData-Administrators.png',0);

go

insert into tblResources values(19,'onlinecalendar','Online Calendar','Install on click online calendar',0,1,0,.00,.00,1,530,1,1,NULL,1,1,1,28,0,1,'onlinecalendar-manager.png',0);

go

insert into tblResources values(20,'photogallery','Photo Gallery','Install on click photogallery',0,1,0,.00,.00,1,535,1,1,NULL,1,1,1,24,0,1,'Photo-gallery.png',0);

go

insert into tblResources values(21,'polls','Polls Management','Install on click Polls Manager',0,1,0,.00,.00,1,540,1,1,NULL,1,1,1,27,0,1,'PollManagement.png',0);

go

insert into tblResources values(22,'blogs','Blogs','Install on click web blogs',0,1,0,.00,.00,1,545,1,1,NULL,1,1,1,17,0,1,'blogs-manager.png',0);

go

insert into tblResources values(23,'forums','Forums','Install on click web forums',0,1,0,.00,.00,1,550,1,1,1,1,1,1,16,0,1,'forums-manager.png',0);

go

insert into tblResources values(24,'sitebuilder','Website Builder','Install on click sitebuilder',0,1,0,.00,.00,1,555,1,1,NULL,1,1,1,23,0,1,'sitebuilder-manager.png',0);

go

CREATE TABLE IF NOT EXISTS tblClickAndInstallApps
(
   ApplicationID INT NOT NULL  AUTO_INCREMENT,
   ApplicationGuid NATIONAL VARCHAR(250) NOT NULL,
   ApplicationName NATIONAL VARCHAR(50) NOT NULL,
   ApplicationDescription NATIONAL VARCHAR(250),
   ResourceID INT NOT NULL,
   IsWindows BOOLEAN   NOT NULL  DEFAULT 0,
   IsLinux BOOLEAN   NOT NULL  DEFAULT 0,
   ApplicationVersion NATIONAL VARCHAR(50),
   UNIQUE(ApplicationID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (1,'D87C6264-016C-11DE-81F0-2A9456D89593','ZenCart','NULL',17,1,1,'V.1.3.8');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (2,'862AF61C-FF53-11DD-B8BE-868955D89593','phpBB','NULL',23,1,1,'V.3.0');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (3,'D67F6C4A-F02D-11DD-B1D1-B8A155D89593','WordPress','NULL',22,1,1,'V.2.3.3');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (4,'E7B1FD06-0019-11DE-85AB-8C8755D89593','Advanced Poll','NULL',21,1,1,'V.2.08');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (5,'58FE0314-001B-11DE-BB81-E39255D89593','osCommerce','NULL',17,1,1,'V.2.2');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (6,'A22D667E-017E-11DE-BB9F-7C7D55D89593','WebCards','NULL',16,1,1,'V.1.3');


go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (7,'999CB85E-0195-11DE-8384-AB1556D89593','Gallery2','NULL',20,1,1,'V.2.2.4');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (8,'3CF51CE2-0260-11DE-9CCF-75B956D89593','phpMyAdmin','NULL',18,1,1,'V.2.11.5');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (9,'8FF1FB9A-01A2-11DE-865D-786A56D89593','Crafty Syntax Live Help','NULL',15,1,1,'V.2.14.5');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (10,'726B6A2E-01B2-11DE-A76B-7B6355D89593','PHP Support Tickets','NULL',15,1,1,'V.2.2');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (11,'53C9D3E8-0181-11DE-893B-989055D89593','WebCalendar','NULL',19,1,1,'V.1.0.0');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (12,'624A41CA-0193-11DE-B129-E00756D89593','Plogger','NULL',20,1,1,'V.3.0');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (13,'588DDD50-0192-11DE-97B8-190256D89593','Coppermine','NULL',20,1,1,'V.1.4.16');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (14,'18A78318-0182-11DE-A222-039655D89593','Joomla','NULL',24,1,1,'V.1.0.15');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (15,'73D218A4-018F-11DE-B222-2EEF55D89593','Mambo','NULL',24,1,1,'V.4.6.2');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (16,'5BE759B2-01B6-11DE-A84F-C58555D89593','PostNuke','NULL',14,1,1,'V.0.7.64');

go

insert into tblClickAndInstallApps (ApplicationID,ApplicationGuid,ApplicationName,ApplicationDescription,ResourceID,IsWindows,IsLinux,ApplicationVersion) values (17,'E461FD06-01B6-11DE-86A0-B88A55D89593','PHPNuke','NULL',14,1,1,'V.8.00');

go

CREATE TABLE tblInstalledApps
(
   InstallAppID INT NOT NULL  AUTO_INCREMENT,
   ApplicationID INT NOT NULL,
   WebsiteID INT NOT NULL,
   VDirName NATIONAL VARCHAR(250) NOT NULL,
   DatabaseID INT,
   IsInstalled BOOLEAN   NOT NULL  DEFAULT 0,
   IsDisabled BOOLEAN   NOT NULL  DEFAULT 0,
   IsInstallAtRoot BOOLEAN   NOT NULL  DEFAULT 0,
   PRIMARY KEY(InstallAppID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go

CREATE TABLE IF NOT EXISTS tblClickAndInstallInfo
(
 InfoID int NOT NULL AUTO_INCREMENT,
 InstallAppID int NOT NULL,
 DatabaseID int NOT NULL,
 AdminName varchar(100) NOT NULL,
 AdminPass varchar(100) NOT NULL,
 AppPath varchar(1000) NOT NULL,
 VDirName varchar(50) NOT NULL,
 PRIMARY KEY(InfoID)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1;

go

DROP PROCEDURE IF EXISTS `sp_resource_delete`;

go

CREATE PROCEDURE `sp_resource_delete`(in resource_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
   delete from `tblResources` WHERE `ResourceID` = resource_id;
SET status='success';	
END

go

DROP PROCEDURE IF EXISTS `sp_resource_insert`;

go

CREATE PROCEDURE `sp_resource_insert`(in resource_id int(11), in resource_name varchar(50), in resource_desc_name varchar(100), in resource_desc longtext,in userid int(11) , in is_internal tinyint(1), in isdeleted tinyint(1), in recurringprice  decimal,in setupprice decimal,in is_binary tinyint(1),in displayindex int(11),in auto_signup_display tinyint(1),in auto_signup_addon tinyint(1),in billing_method int(11) ,in iswindows tinyint(1),in islinux  tinyint(1), in  defaultvalue int(11),in global_settings_displayIndex int(11),in dependent_on int(11) ,in is_click_and_install_resource tinyint(1),in resourceimage varchar(250) ,in isdisabled  tinyint(1),out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblResources` (`ResourceID`, `ResourceName`,`ResourceDescName`,`ResourceDesc`,`UserID`,`IsInternal`,`IsDeleted`,`RecurringPrice`,`SetupPrice`,`IsBinary`,`DisplayIndex`,`AutoSignupDisplay`,`AutoSignupAddon`,`BillingMethod`,`IsWindows`,`IsLinux`,`DefaultValue`,`GlobalSettingsDisplayIndex`,`DependentOn`,`IsClickAndInstallResource`,`ResourceImage`,`IsDisabled`) values (resource_id,resource_name,resource_desc_name,resource_desc,userid,is_internal,isdeleted,recurringprice,setupprice,is_binary,displayindex,auto_signup_display,auto_signup_addon,billing_method,iswindows,islinux,defaultvalue,global_settings_displayIndex,dependent_on,is_click_and_install_resource,resourceimage,isdisabled);
END

go

DROP PROCEDURE IF EXISTS `sp_resources_update`;

go

CREATE PROCEDURE `sp_resources_update`(in field1 INT, in fiels2 VARCHAR(1000),in field3 varchar(4000), in field4 VARCHAR(4000),in field5 INT ,in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection 
WHEN 1 THEN
	UPDATE `tblResources` SET `ResourceDescName`= fiels2,`ResourceDesc`=field3,`ResourceImage`=field4,`IsLinux` =field5 WHERE `ResourceID`=field1;      

END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_resources_select`;

go

CREATE PROCEDURE `sp_resources_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `ResourceID`,`ResourceName`,`ResourceDescName`,`IsBinary`,`DefaultValue`,`DisplayIndex` FROM `tblResources` WHERE `IsInternal`= 1 AND `IsDeleted`=0 AND `IsLinux`=1 AND `IsDisabled`=0 ORDER BY `DisplayIndex` ASC;
WHEN 2 THEN
	SELECT `ResourceID` FROM `tblResources` WHERE `ResourceName`=field1;
WHEN 3 THEN
	SELECT `ResourceName` FROM `tblResources` WHERE `ResourceID`=field2;
WHEN 4 THEN
	SELECT  `ResourceID` , `ResourceName` , `ResourceDescName` , `ResourceDesc` , `ResourceImage` FROM `tblResources` WHERE `IsClickAndInstallResource`= 1;
WHEN 5 THEN
	SELECT  `DisplayIndex`  FROM `tblResources` WHERE `IsClickAndInstallResource`= 1;
WHEN 6 THEN
	SELECT  max(ResourceID)  FROM `tblResources`;
WHEN 7 THEN
	SELECT  `IsLinux`  FROM `tblResources` where `ResourceID` =field2;
WHEN 8 THEN
	SELECT  `ResourceID`  FROM `tblResources` where `ResourceDescName` =field1;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_click_install_app_select`;

go

CREATE PROCEDURE `sp_click_install_app_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 

WHEN 1 THEN
	SELECT `ApplicationName` FROM `tblClickAndInstallApps` WHERE `ResourceID`=field2;
WHEN 2 THEN
	SELECT `ResourceID` FROM `tblClickAndInstallApps`;
WHEN 3 THEN
	SELECT `ApplicationID`,`ApplicationGuid`,`ApplicationName`, `ApplicationVersion` FROM `tblClickAndInstallApps` WHERE `ResourceID`=field2;
WHEN 4 THEN
	SELECT * FROM `tblClickAndInstallApps`;
WHEN 5 THEN
	SELECT `ApplicationGuid` FROM `tblClickAndInstallApps` where `ApplicationID`= field2;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_app_delete`;

go

CREATE PROCEDURE `sp_click_and_install_app_delete`(in resource_id int(250),in guid varchar(400), out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
delete from tblClickAndInstallApps where ResourceID = resource_id and ApplicationGuid = guid;
SET status='success';
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_app_insert`;

go

CREATE PROCEDURE `sp_click_and_install_app_insert`(in guid varchar(100), in name varchar(100),in description varchar(1000),in resource_id INT,in is_windows INT,in is_linux INT,in version varchar(100),out status VARCHAR(10))
BEGIN
INSERT INTO `tblClickAndInstallApps` (`ApplicationGuid`, `ApplicationName`,`ApplicationDescription`,`ResourceID`,`IsWindows`,`IsLinux`,`ApplicationVersion`) VALUES (guid, name,description,resource_id,is_windows,is_linux,version);
SET status='success';
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_app_update`;

go

CREATE PROCEDURE `sp_click_and_install_app_update`(in field1 INT, in fiels2 VARCHAR(1000), in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection 
WHEN 1 THEN
	UPDATE `tblClickAndInstallApps` SET `ResourceID`= field1  WHERE `ApplicationGuid`=fiels2;      

END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_installed_apps_delete`;

go

CREATE PROCEDURE `sp_installed_apps_delete`(in installed_app_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
   delete from `tblInstalledApps` WHERE `InstallAppID` = installed_app_id;
SET status='success';	
END

go

DROP PROCEDURE IF EXISTS `sp_installed_apps_insert`;

go

CREATE PROCEDURE `sp_installed_apps_insert`(in app_id int(11), in website_id int(11),in vdir_name varchar(1000),in db_id INT,in is_installed INT,in is_disabled INT,in is_install_at_root int,out status VARCHAR(10))
BEGIN
INSERT INTO `tblInstalledApps` (`ApplicationID`, `WebsiteID`,`VDirName`,`DatabaseID`,`IsInstalled`,`IsDisabled`,`IsInstallAtRoot`) VALUES (app_id,website_id,vdir_name,db_id,is_installed,is_disabled,is_install_at_root);
SET status='success';
END

go

DROP PROCEDURE IF EXISTS `sp_installed_apps_select`;

go

CREATE PROCEDURE `sp_installed_apps_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `InstallAppID` FROM `tblInstalledApps` WHERE `ApplicationID`= field2;
WHEN 2 THEN
	SELECT `WebsiteID` FROM `tblInstalledApps` ;
WHEN 3 THEN
	SELECT `IsDisabled` FROM `tblInstalledApps` WHERE `ApplicationID`= field2 and `WebsiteID` = field1;
WHEN 4 THEN
	SELECT `IsInstalled` FROM `tblInstalledApps` WHERE `ApplicationID`= field2 and `WebsiteID` = field1;
WHEN 5 THEN
	SELECT `InstallAppID` FROM `tblInstalledApps` WHERE `ApplicationID`= field2 and `WebsiteID` = field1;
WHEN 6 THEN
	SELECT `ApplicationID` FROM `tblInstalledApps` ;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_installed_apps_update`;

go

CREATE PROCEDURE `sp_installed_apps_update`(in field1 INT, in field2 INT,IN field3 INT,in selection INT, out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
CASE selection
WHEN 1 THEN 
UPDATE `tblInstalledApps` SET `IsDisabled`= field3 WHERE `ApplicationID`=field1 AND `WebsiteID` = field2;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_info_delete`;

go

CREATE PROCEDURE `sp_click_and_install_info_delete`(in installed_app_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
   delete from `tblClickAndInstallInfo` WHERE `InstallAppID` = installed_app_id;
SET status='success';	
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_info_insert`;

go

CREATE PROCEDURE `sp_click_and_install_info_insert`(in install_app_id int, in database_id int,in admin_name varchar(1000),in admin_pass varchar(1000),in app_path varchar(100),in vdir_name varchar(100),out status VARCHAR(10))
BEGIN
INSERT INTO `tblClickAndInstallInfo` (`InstallAppID`, `DatabaseID`,`AdminName`,`AdminPass`,`AppPath`,`VDirName`) VALUES (install_app_id, database_id,admin_name,admin_pass,app_path,vdir_name);
SET status='success';
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_info_select`;

go

CREATE PROCEDURE `sp_click_and_install_info_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 

WHEN 1 THEN
	SELECT `InfoID` FROM `tblClickAndInstallInfo` WHERE `AdminPass`=field1;
WHEN 2 THEN
	SELECT `InstallAppID`, `AdminName` , `AdminPass`, `AppPath`, `VDirName` FROM `tblClickAndInstallInfo` WHERE `InfoID`=field2;
WHEN 3 THEN
	SELECT `InfoID` FROM `tblClickAndInstallInfo` WHERE `InstallAppID`=field2;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_get_installed_apps`;

go

CREATE PROCEDURE `sp_get_installed_apps`(in offset int, in no_of_records int, in user_ids VARCHAR(500),in category_id int,in condition_name varchar(1000), in condition_value varchar(1000), in sorted_field varchar(100), in selection INT,in user_level varchar(10))
BEGIN
#DECLARE query varchar(2000);
DECLARE result varchar(2000);
DECLARE field_name varchar(50);

SET @START = offset;
SET @LIMIT = no_of_records;

IF( user_level = "host" ) THEN
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblInstalledApps.InstallAppID,tblWebsites.WebsiteName,tblInstalledApps.WebsiteID,tblInstalledApps.ApplicationID,tblClickAndInstallApps.ApplicationName,tblInstalledApps.IsDisabled,tblClickAndInstallInfo.AppPath,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblWebsites INNER JOIN tblInstalledApps ON tblWebsites.WebsiteID=tblInstalledApps.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID INNER JOIN tblClickAndInstallInfo ON tblClickAndInstallInfo.InstallAppID=tblInstalledApps.InstallAppID INNER JOIN tblClickAndInstallApps ON  tblInstalledApps.ApplicationID=tblClickAndInstallApps.ApplicationID WHERE tblInstalledApps.ApplicationID IN (SELECT ApplicationID FROM tblClickAndInstallApps WHERE ResourceID=",category_id,")");
ELSEIF (user_level = "reseller") THEN
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblInstalledApps.InstallAppID,tblWebsites.WebsiteName,tblInstalledApps.WebsiteID,tblInstalledApps.ApplicationID,tblClickAndInstallApps.ApplicationName,tblInstalledApps.IsDisabled,tblClickAndInstallInfo.AppPath,tblUsers.UserName  FROM tblWebsites INNER JOIN tblInstalledApps ON tblWebsites.WebsiteID=tblInstalledApps.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID INNER JOIN tblClickAndInstallInfo ON tblClickAndInstallInfo.InstallAppID=tblInstalledApps.InstallAppID INNER JOIN tblClickAndInstallApps ON  tblInstalledApps.ApplicationID=tblClickAndInstallApps.ApplicationID WHERE tblInstalledApps.ApplicationID IN (SELECT ApplicationID FROM tblClickAndInstallApps WHERE ResourceID=",category_id,") AND tblWebsites.OwnerID IN ( SELECT UserID FROM tblUsers Where OwnerID=",user_ids,")");
ELSE
set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS tblInstalledApps.InstallAppID,tblWebsites.WebsiteName,tblInstalledApps.WebsiteID,tblInstalledApps.ApplicationID,tblClickAndInstallApps.ApplicationName,tblInstalledApps.IsDisabled,tblClickAndInstallInfo.AppPath,tblUsers.UserName  FROM tblWebsites INNER JOIN tblInstalledApps ON tblWebsites.WebsiteID=tblInstalledApps.WebsiteID INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID INNER JOIN tblClickAndInstallInfo ON tblClickAndInstallInfo.InstallAppID=tblInstalledApps.InstallAppID INNER JOIN tblClickAndInstallApps ON  tblInstalledApps.ApplicationID=tblClickAndInstallApps.ApplicationID WHERE tblInstalledApps.ApplicationID IN (SELECT ApplicationID FROM tblClickAndInstallApps WHERE ResourceID=",category_id,")  AND tblWebsites.OwnerID=",user_ids);
END IF;
CASE selection 
WHEN 1 THEN
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;	
WHEN 2 THEN
	CALL sp_parse_query_condition(condition_name,condition_value,',',2,result);
	IF( no_of_records > 0 ) THEN
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field,' LIMIT ?,?');
		PREPARE STMT FROM @query;
		EXECUTE STMT USING @START,@LIMIT;
	ELSE
		set @query = CONCAT(@query,' ',result,' ORDER BY ',sorted_field);
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;

END

go

DROP PROCEDURE IF EXISTS `sp_server_delete`;

go

CREATE PROCEDURE `sp_server_delete`(in server_id INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO tblRegisteredServers (ServerName,ServerIP,ServerType) (SELECT ServerName,ServerIP,ServerType FROM tblServers WHERE ServerID=server_id);
DELETE FROM tblServerRoles WHERE ServerID=server_id;
DELETE FROM tblServers WHERE ServerID=server_id;
END

go

DROP PROCEDURE IF EXISTS `sp_database_select`;

go

CREATE PROCEDURE `sp_database_select`(in database_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblDatabases` WHERE `DatabaseID`= database_id;
WHEN 2 THEN
	SELECT `ServerID` FROM `tblServerRoles` WHERE `ServerRoleID`=(SELECT `ServerRoleID` FROM `tblUsersServers` WHERE `UserID`=(SELECT `OwnerID` FROM `tblWebsites` Where `WebsiteID`=(SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`=database_id)));
WHEN 3 THEN
	SELECT `UserID`,`UserName` FROM `tblUsers` WHERE `UserID`=(SELECT `OwnerID` FROM `tblWebsites` Where `WebsiteID`=(SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`=database_id));
WHEN 4 THEN
	SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`= database_id; 
WHEN 5 THEN 
	select SUM(DiskSpaceUsage) from tblDatabases where WebsiteID IN (select WebsiteID from tblWebsites where OwnerID=database_id);
WHEN 6 THEN 
	select SUM(DiskSpaceUsage) from tblDatabases where WebsiteID=database_id;
WHEN 50 THEN 
	SELECT COUNT(DatabaseID) FROM tblDatabases;
WHEN 7 THEN
	SELECT * FROM `tblDatabases` WHERE `WebsiteID`= database_id;

END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_click_install_app_select`;

go

CREATE PROCEDURE `sp_click_install_app_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 

WHEN 1 THEN
	SELECT `ApplicationName` FROM `tblClickAndInstallApps` WHERE `ResourceID`=field2;
WHEN 2 THEN
	SELECT `ResourceID` FROM `tblClickAndInstallApps`;
WHEN 3 THEN
	SELECT `ApplicationID`,`ApplicationGuid`,`ApplicationName`, `ApplicationVersion` FROM `tblClickAndInstallApps` WHERE `ResourceID`=field2;
WHEN 4 THEN
	SELECT * FROM `tblClickAndInstallApps`;
WHEN 5 THEN
	SELECT `ApplicationGuid` FROM `tblClickAndInstallApps` where `ApplicationID`= field2;
WHEN 6 THEN
	select ResourceID from tblClickAndInstallApps where ApplicationID IN (select ApplicationID from tblInstalledApps where WebsiteID=field2);
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_click_and_install_info_delete1`;

go

CREATE PROCEDURE `sp_click_and_install_info_delete1`(in field INT,in selection INT,out status VARCHAR(10))
BEGIN
CASE selection 
WHEN 1 THEN
	delete from tblClickAndInstallInfo where InstallAppID IN (select InstallAppID from tblInstalledApps where WebsiteID=field);
END CASE;
SET status='success';	
END

go

DROP PROCEDURE IF EXISTS `sp_installed_apps_delete1`;

go

CREATE PROCEDURE `sp_installed_apps_delete1`(in field INT,in selection INT,out status VARCHAR(10))
BEGIN
CASE selection 
WHEN 1 THEN
	delete from tblInstalledApps where WebsiteID=field;
END CASE;
SET status='success';	
END

go

