CREATE TABLE IF NOT EXISTS tblWHMCS
(
   WHMCSID INT NOT NULL  AUTO_INCREMENT,
   WebsiteID INT NOT NULL ,
   DatabaseID INT NOT NULL,
   VirDirName  VARCHAR(250),
   UserID INT NOT NULL,
   UNIQUE(WHMCSID)
) TYPE = ISAM  AUTO_INCREMENT = 1;

go

DROP PROCEDURE IF EXISTS `sp_websites_select`;

go

CREATE PROCEDURE `sp_websites_select`(in field1 INT,in field2 VARCHAR(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	set @query = CONCAT("SELECT `WebsiteID`,`WebsiteName`,`DiskSpaceUsage`  FROM `tblWebsites` WHERE `OwnerID` IN (",field2,")");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
WHEN 2 THEN
	set @query = CONCAT("SELECT tblWebsites.WebsiteID,tblWebsites.WebsiteName,tblUsers.UserName FROM `tblWebsites` INNER JOIN tblUsers ON tblWebsites.OwnerID=tblUsers.UserID WHERE tblWebsites.OwnerID IN (",field2,")");
	PREPARE STMT FROM @query;
	EXECUTE STMT;
WHEN 3 THEN
	SELECT (SELECT ServerRoleID FROM tblUsersServers WHERE UserID=(SELECT OwnerID FROM tblWebsites WHERE WebsiteID=field1)) AS ServerRoleID, ServerID, ServerIP FROM tblServers WHERE ServerID=(SELECT ServerID FROM tblServerRoles WHERE ServerRoleID=(SELECT ServerRoleID FROM tblUsersServers WHERE UserID=(SELECT OwnerID FROM tblWebsites WHERE WebsiteID=field1)));
WHEN 4 THEN
	SELECT UserID,UserName FROM tblUsers WHERE UserID = (SELECT OwnerID FROM tblWebsites WHERE WebsiteID=field1);
WHEN 5 THEN
	SELECT `WebsiteName` FROM tblWebsites WHERE `WebsiteID`=field1;
WHEN 6 THEN
	SELECT `WebsiteID`,`WebsiteName` FROM tblWebsites WHERE `OwnerID` IN (SELECT UserID FROM tblUsers WHERE OwnerID=field1);
WHEN 7 THEN
	SELECT `WebsiteID`,`WebsiteName` FROM tblWebsites WHERE `OwnerID`=field1;
WHEN 8 THEN
	SELECT SUM(DiskSpaceUsage) FROM tblWebsites WHERE OwnerID=field1;
WHEN 9 THEN
	select count(WebsiteID) as TotalWebsites from tblWebsites,tblUsers,tblUsersServers,tblServerRoles,tblServers Where (tblUsers.isdeleted =0 or tblUsers.isdeleted is null) and tblWebsites.IsSubDomain = 0 and tblWebsites.OwnerID = tblUsers.UserID and tblUsers.UserID = tblUsersServers.UserID and tblUsersServers.ServerRoleID = 		tblServerRoles.ServerRoleID and tblServerRoles.ServerID = tblServers.ServerID and tblServers.ServerID = field1;
WHEN 10 THEN
	SELECT WebsiteID FROM `tblWebsites` WHERE `WebsiteName`= field2;
WHEN 11 THEN
	SELECT * from tblWebsites WHERE WebsiteID = field1;
WHEN 12 THEN
	SELECT SUM(BandwidthUsage) FROM tblBandwidth WHERE WebsiteID=field1;
WHEN 13 THEN
	SELECT tblWebsites.`WebsiteID`,tblWebsites.`WebsiteName` FROM tblWebsites INNER JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID WHERE tblWebsites.`OwnerID` IN (SELECT UserID FROM tblUsers WHERE OwnerID=field1) AND tblWebsiteResources.StatsEnabled=0;
WHEN 14 THEN
	SELECT tblWebsites.`WebsiteID`,tblWebsites.`WebsiteName` FROM tblWebsites INNER JOIN tblWebsiteResources ON tblWebsites.WebsiteID=tblWebsiteResources.WebsiteID WHERE tblWebsites.`OwnerID`=field1 AND tblWebsiteResources.StatsEnabled=0;
WHEN 50 THEN
	SELECT COUNT(WebsiteID) FROM tblWebsites;
WHEN 51 THEN
	SELECT `WebsiteID`, `WebsiteName`,`OwnerID`  FROM tblWebsites;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_user_prop_delete`;

go

CREATE PROCEDURE `sp_user_prop_delete`(in user_id INT,in prop_name  varchar(50),in prop_value  varchar(50),in selection INT,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
   CASE selection 
WHEN 1 THEN
	delete from  `tblUserProp` WHERE `UserID`= user_id AND `PropName`=prop_name AND `PropValue` =prop_value;
END CASE;
SET status='success';	
END

go

DROP PROCEDURE IF EXISTS `sp_WHMCS_select`;

go

CREATE PROCEDURE `sp_WHMCS_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `WHMCSID`  FROM `tblWHMCS` WHERE `UserID`= field2;
WHEN 2 THEN
	SELECT `WebsiteID` ,`DatabaseID`,`VirDirName` FROM `tblWHMCS` WHERE `UserID`= field2;
WHEN 3 THEN
	SELECT * FROM `tblWHMCS` ;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_WHMCS_insert`;

go

CREATE PROCEDURE `sp_WHMCS_insert`(in website_id VARCHAR(50), in database_id INT, in vdir_name varchar(250), in user_id int,out status VARCHAR(10))
BEGIN
DECLARE CONTINUE HANDLER FOR SQLSTATE '23000' SET status='error';
SET status='success';
INSERT INTO `tblWHMCS` (`WebsiteID`, `DatabaseID`,`VirDirName`,`UserID`) values (website_id,database_id,vdir_name ,user_id);
END

go

DROP PROCEDURE IF EXISTS `sp_WHMCS_delete`;

go

CREATE PROCEDURE `sp_WHMCS_delete`(in field INT,in selection INT,out status VARCHAR(10))
BEGIN
CASE selection 
WHEN 1 THEN
	delete from tblWHMCS where `UserID`= field;
END CASE;
SET status='success';	
END

go

DROP PROCEDURE IF EXISTS `sp_database_select`;

go

CREATE PROCEDURE `sp_database_select`(in database_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblDatabases` WHERE `DatabaseID`= database_id;
WHEN 2 THEN
	SELECT `ServerID` FROM `tblServerRoles` WHERE `ServerRoleID`=(SELECT `ServerRoleID` FROM `tblUsersServers` WHERE `UserID`=(SELECT `OwnerID` FROM `tblWebsites` Where `WebsiteID`=(SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`=database_id)));
WHEN 3 THEN
	SELECT `UserID`,`UserName` FROM `tblUsers` WHERE `UserID`=(SELECT `OwnerID` FROM `tblWebsites` Where `WebsiteID`=(SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`=database_id));
WHEN 4 THEN
	SELECT `WebsiteID` FROM `tblDatabases` WHERE `DatabaseID`= database_id; 
WHEN 5 THEN 
	select SUM(DiskSpaceUsage) from tblDatabases where WebsiteID IN (select WebsiteID from tblWebsites where OwnerID=database_id);
WHEN 6 THEN 
	select SUM(DiskSpaceUsage) from tblDatabases where WebsiteID=database_id;
WHEN 50 THEN 
	SELECT COUNT(DatabaseID) FROM tblDatabases;
WHEN 7 THEN
	SELECT * FROM `tblDatabases` WHERE `WebsiteID`= database_id;
WHEN 51 THEN
	SELECT `DatabaseName`,`DatabaseUserName`,`DatabaseUserPassword`,`InstanceName` FROM `tblDatabases` WHERE `DatabaseID`= database_id;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_users_select1`;

go

CREATE PROCEDURE `sp_users_select1`(in user_id INT,in server_name VARCHAR(100),in req_user_level VARCHAR(100), in user_level VARCHAR(100),in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
		set @query = CONCAT("SELECT SQL_CALC_FOUND_ROWS DISTINCT(tblUsers.UserName),tblUsers.UserLevel,tblServers.ServerName FROM `tblUsers` INNER JOIN tblUsersServers ON tblUsers.UserID=tblUsersServers.UserID INNER JOIN tblServerRoles ON tblUsersServers.ServerRoleID=tblServerRoles.ServerID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE 1=1");
		IF( user_level != "host" ) THEN
			set @query = CONCAT(@query,' AND tblUsers.UserID IN (SELECT UserID FROM tblUsers WHERE OwnerID=',user_id,')');
			select @query;
		END IF;
		IF( req_user_level != '' ) THEN
			set @query = CONCAT(@query,' AND tblUsers.UserLevel=''',req_user_level,'''');
		END IF;
		IF( server_name != '' ) THEN
			set @query = CONCAT(@query,' AND tblServers.ServerName=''',server_name,'''');
		END IF;
		PREPARE STMT FROM @query;
		EXECUTE STMT;

END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_countries_select1`;

go

CREATE PROCEDURE `sp_countries_select1`(in country_id INT, in country_name VARCHAR(200),in selection int)
BEGIN
CASE selection 
WHEN 1 THEN 
	SELECT `CountryID` FROM `tblCountries` WHERE `CountryName`=country_name;
WHEN 2 THEN 
	SELECT `CountryName` FROM `tblCountries` WHERE `CountryID`=country_id;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_states_select`;

go

CREATE PROCEDURE `sp_states_select`(in country_id int,in state_get VARCHAR(100),in selection int)
BEGIN
CASE selection 
WHEN 1 THEN 
	SELECT * FROM `tblStates` ;
WHEN 2 THEN 
       SELECT * FROM `tblStates`  WHERE `CountryID`=country_id;
WHEN 3 THEN 
       SELECT `StateID`  FROM `tblStates`  WHERE `CountryID`=country_id AND `StateName`=state_get;
WHEN 4 THEN 
       SELECT `StateName`  FROM `tblStates`  WHERE `CountryID`=country_id AND `StateID`=state_get;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_plans_select`;

go

CREATE PROCEDURE `sp_plans_select`(in field1 INT,in field2 varchar(1000), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblPlans` WHERE `PlanID`= field1 AND `IsDeleted`=0;
WHEN 2 THEN
	SELECT * FROM `tblPlans` WHERE `UserID`= field1 AND `PlanName`= field2 AND `IsDeleted`= 0;
WHEN 3 THEN
	SELECT `PlanID`,`PlanName` FROM `tblPlans` WHERE `UserID`= field1 AND `IsDeleted`=0 AND `Status`=1;
WHEN 4 THEN
	SELECT `PlanID`,`PlanName` FROM `tblPlans` WHERE `UserID`= field1 AND `PlanModeID`=2 AND `IsDeleted`=0 AND `Status`=1;
WHEN 5 THEN
	SELECT `PlanName` FROM `tblPlans` WHERE `PlanID`= field1;
WHEN 6 THEN
	SELECT COUNT(`PlanID`) FROM `tblPlans` WHERE `UserID`= field1 AND `IsDeleted`=0;
WHEN 7 THEN
	IF(field2 = '') THEN
		SELECT * FROM `tblPlans` WHERE `UserID`= field1 AND `IsDeleted`=0;
	ELSE
		set @PLAN_NAME=field2;
		set @USER_ID=field1;
		set @query = CONCAT('SELECT * FROM `tblPlans` WHERE `UserID`=', field1,' AND `PlanName` LIKE ','''%',field2,'%'' AND `IsDeleted`=0');
		PREPARE STMT FROM @query;
		EXECUTE STMT;
	END IF;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_resources_select`;

go

CREATE PROCEDURE `sp_resources_select`(in field1 VARCHAR(100),in field2 INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `ResourceID`,`ResourceName`,`ResourceDescName`,`IsBinary`,`DefaultValue`,`DisplayIndex` FROM `tblResources` WHERE `IsInternal`= 1 AND `IsDeleted`=0 AND `IsLinux`=1 AND `IsDisabled`=0 ORDER BY `DisplayIndex` ASC;
WHEN 2 THEN
	SELECT `ResourceID` FROM `tblResources` WHERE `ResourceName`=field1;
WHEN 3 THEN
	SELECT `ResourceName` FROM `tblResources` WHERE `ResourceID`=field2;
WHEN 4 THEN
	SELECT  `ResourceID` , `ResourceName` , `ResourceDescName` , `ResourceDesc` , `ResourceImage` FROM `tblResources` WHERE `IsClickAndInstallResource`= 1;
WHEN 5 THEN
	SELECT  `DisplayIndex`  FROM `tblResources` WHERE `IsClickAndInstallResource`= 1;
WHEN 6 THEN
	SELECT  max(ResourceID)  FROM `tblResources`;
WHEN 7 THEN
	SELECT  `IsLinux`  FROM `tblResources` where `ResourceID` =field2;
WHEN 8 THEN
	SELECT  `ResourceID`  FROM `tblResources` where `ResourceDescName` =field1;
WHEN 9 THEN
	SELECT `ResourceDescName` FROM `tblResources` WHERE `ResourceID`=field2;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_sold_plans_select`;

go

CREATE PROCEDURE `sp_sold_plans_select`(in user_id INT, in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT DISTINCT tblSoldPlans.PlanID,tblPlans.PlanName FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.UserID=user_id AND tblSoldPlans.IsDeleted=0;
WHEN 2 THEN
	SELECT tblUsers.UserID,tblUsers.UserName FROM tblUsers WHERE UserID IN ( SELECT tblSoldPlans.UserID FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.UserID=user_id);
WHEN 3 THEN
	SELECT tblSoldPlans.SoldPlanID,tblPlans.PlanName,tblSoldPlans.DateCreated FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.PlanModeID=2 AND tblSoldPlans.UserID=user_id ORDER BY tblSoldPlans.SoldPlanID ASC ;
WHEN 4 THEN
SELECT Count(tblSoldPlans.SoldPlanID) FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblPlans.UserID=user_id AND tblSoldPlans.IsDeleted=0;
WHEN 5 THEN
select tblSoldPlans.SoldPlanID,tblPlans.PlanName,tblSoldPlans.DateCreated FROM tblSoldPlans INNER JOIN tblPlans ON tblSoldPlans.PlanID=tblPlans.PlanID WHERE tblSoldPlans.UserID=user_id;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_mail_domain_select`;

go

CREATE PROCEDURE `sp_mail_domain_select`(in field1 INT,in field2 VARCHAR(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT * FROM `tblMailDomains` WHERE `MailDomainID` = field1;
WHEN 2 THEN
	SELECT * FROM `tblMailDomains` WHERE `MailDomainName` = field2;
WHEN 3 THEN
	SELECT * FROM `tblMailDomains` WHERE `WebsiteID` = field1;
WHEN 4 THEN
	SELECT WebsiteID FROM `tblMailDomains` WHERE `MailDomainID` = field1;
WHEN 5 THEN 
	select SUM(DiskSpaceUsage) from tblMailDomains where WebsiteID IN (select WebsiteID from tblWebsites where OwnerID=field1);
WHEN 6 THEN 
	select OwnerID from tblWebsites where WebsiteID = (select WebsiteID from tblMailDomains where `MailDomainName` = field2);
WHEN 7 THEN 
	select SUM(DiskSpaceUsage) from tblMailDomains where WebsiteID=field1;
WHEN 8 THEN
	SELECT  			tblMailDomains.MailDomainID,tblMailDomains.MailDomainName,tblMailDomains.ServerRoleID,tblWebsites.WebsiteName,tblWebsites.IsNameBased,tblWebsites.IPAddress,tblServers.ServerName,tblServers.ServerIP,(select UserName from tblUsers where UserID = WebAdmins.OwnerID) AS UserName FROM tblMailDomains INNER JOIN tblWebsites ON tblMailDomains.WebsiteID=tblWebsites.WebsiteID INNER JOIN tblUsers WebAdmins ON tblWebsites.OwnerID=WebAdmins.UserID INNER JOIN tblServerRoles ON tblMailDomains.ServerRoleID=tblServerRoles.ServerRoleID INNER JOIN tblServers ON tblServerRoles.ServerID=tblServers.ServerID WHERE tblWebsites.WebsiteID = field1;
WHEN 50 THEN
	SELECT COUNT(MailDomainID) from tblMailDomains;
END CASE;
END

go

DROP PROCEDURE IF EXISTS `sp_database_user_select`;

go

CREATE PROCEDURE `sp_database_user_select`(in database_id INT, in user_name varchar(100), in selection INT)
BEGIN
CASE selection 
WHEN 1 THEN
	SELECT `DatabaseUserID`,`UserPassword` FROM `tblDatabaseUsers` WHERE `DatabaseID`= database_id AND `UserName`=user_name;
WHEN 2 THEN
	SELECT `DatabaseUserID`,`UserName` FROM `tblDatabaseUsers` WHERE `DatabaseID`= database_id;
WHEN 3 THEN
	SELECT  `DatabaseUserID` FROM `tblDatabaseUsers` WHERE  `UserName`=user_name;
END CASE;
END

go

