<?php

set_time_limit(30*30*30);


function HC_ConnectSocket($soapPacket)
{
	$Path = dirname(__FILE__);
	$Path=$Path."/hcsettings.xml";

	$objDOM = new DOMDocument();
  	$objDOM->load($Path);

	$x = $objDOM->documentElement;
	$domainname = $x;
	$name = $x;

	foreach ($x->childNodes AS $item)
	{
		if($item->nodeName == "hcapi-domain")
		{
		  	#print $item->nodeName . " = " . $item->nodeValue . "<br />";
			$domainname = $item->nodeValue;
		}
		if($item->nodeName == "hcapiname")
		{
			#print $item->nodeName . " = " . $item->nodeValue . "<br />";
			$name = $item->nodeValue;
		}
  	} 

	$result = $header = $errString = $transport = NULL;
	$fp = fsockopen($domainname, 80, $errNo, $errString, 90);
	
	
	
		
	if($fp) 
	{
		$header = "POST /$name/UserManager.php HTTP/1.1\r\n";
		$header .= "HOST: $domainname\n";
		$header .= "Content-Type: text/xml;charset=\"utf-8\"\r\n";
		$header .= "Content-Length: ".strlen($soapPacket)."\r\n\r\n";
		fwrite($fp, $header.$soapPacket);
		
		while (true) { 
			$result1 = fread($fp, 1000);
			if( $result1 != "" )
				$result .= $result1; 
			if(strstr($result, '</SOAP-ENV:Envelope>') || $result1 == "" ) 
				break;
			$result1 = ""; 
		}
		fclose($fp);
		return $result;
	}
	else
	{
		return false;
	}
}

function HC_ConfigOptions() {
	# Should return an array of the module options for each product - maximum of 24
    $configarray = array(
	 "Plan Name" => array( "Type" => "text", "Size" => "25", ),
	);
	return $configarray;
}

function HC_CreateAccount($params) {


    # ** The variables listed below are passed into all module functions **

    $serviceid = $params["serviceid"]; # Unique ID of the product/service in the WHMCS Database
    $pid = $params["pid"]; # Product/Service ID
    $producttype = $params["producttype"]; # Product Type: hostingaccount, reselleraccount, server or other
    $domain = $params["domain"];
    $username = $params["username"];
    $password = $params["password"];
    $clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
    $customfields = $params["customfields"]; # Array of custom field values for the product
    $configoptions = $params["configoptions"]; # Array of configurable option values for the product

    # Product module option settings from ConfigOptions array above
    $configoption1 = $params["configoption1"];
    $configoption2 = $params["configoption2"];
    $configoption3 = $params["configoption3"];
    $configoption4 = $params["configoption4"];
	
    # Additional variables if the product/service is linked to a server
    $server = $params["server"]; # True if linked to a server
    $serverid = $params["serverid"];
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $serveraccesshash = $params["serveraccesshash"];
    $serversecure = $params["serversecure"]; # If set, SSL Mode is enabled in the server config

    $szOptionalParams = "<Parameters>
	<Parameter Name=\"WebserverName\">".$params["serverhostname"]."</Parameter>
	<Parameter Name=\"WebsiteName\">".$params["domain"]."</Parameter>
	<Parameter Name=\"FirstName\">".$clientsdetails["firstname"]."</Parameter>
	<Parameter Name=\"LastName\">".$clientsdetails["lastname"]."</Parameter>
	<Parameter Name=\"EmailAddress\">".$clientsdetails["email"]."</Parameter>
	<Parameter Name=\"CountryName\">".$clientsdetails["country"]."</Parameter>
	<Parameter Name=\"StateName\">".$clientsdetails["state"]."</Parameter>
	<Parameter Name=\"CityName\">".$clientsdetails["city"]."</Parameter>
	<Parameter Name=\"StreetAddress\">".$clientsdetails["address1"]."</Parameter>
	<Parameter Name=\"PostalCode\">".$clientsdetails["postcode"]."</Parameter>
	<Parameter Name=\"PhoneNo\">".$clientsdetails["phonenumber"]."</Parameter>
	<Parameter Name=\"FaxNo\"> </Parameter>
	<Parameter Name=\"Company\">".$clientsdetails["companyname"]."</Parameter>
	<Parameter Name=\"SocialSecurityNo\"> </Parameter></Parameters>";

	$soapPacket = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
	<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
	  <soap:Body>
		<SignupUser xmlns=\"http://tempuri.org/\">
		  <HostUserName>".$serverusername."</HostUserName>
		  <HostPassword>".$serverpassword."</HostPassword>
		  <OwnerName>".$serverusername."</OwnerName>
		   <PlanName>".$configoption1."</PlanName>
		   <NewUserName>".$customfields["Panel Login Name"]."</NewUserName>
			<NewUserPassword>".$customfields["Panel Login Password"]."</NewUserPassword>
			<EmailAddress>".$clientsdetails["email"]."</EmailAddress>
			<szDomainName>".$domain."</szDomainName>
		  <OptionalParam>".$szOptionalParams."</OptionalParam>
		</SignupUser>
		</soap:Body>
	</soap:Envelope>";
	
	$result = HC_ConnectSocket($soapPacket);

	if($result)
	{
		$resultString = explode("<?xml",$result);
		$x = "<?xml".$resultString[1];
		$doc = new DOMDocument();
		$doc->loadXML($x);
		
		
		
		$params = $doc->getElementsByTagName('Status'); 
		foreach ($params as $param) { 
			  $status = $param -> nodeValue.'
			  ';
		} 		

		$params = $doc->getElementsByTagName('ErrorDescription'); 
		foreach ($params as $param) { 
			  $error = $param -> nodeValue.'
			  ';
		} 
		if($status == false)
		{
			$successful = false;
		}
		else
		{
			$successful = true;
		}	
	}
	else
	{
		$successful = false;
		$error = "Unable to connect to API.";
	}
	
	# Code to perform action goes here...

	if ($successful) {
		
		$result = $error;
	} else {
	
		$result = $error;
	}
	
	return $result;
}



function HC_TerminateAccount($params) {

	$domain = $params["domain"];
	$username = $params["username"];
	$password = $params["password"];
	$customfields = $params["customfields"]; # Array of custom field values for the product
	$clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
	$configoptions = $params["configoptions"]; # Array of configurable option values for the product


       # Additional variables if the product/service is linked to a server
       $server = $params["server"]; # True if linked to a server
       $serverid = $params["serverid"];
       $serverip = $params["serverip"];
       $serverusername = $params["serverusername"];
       $serverpassword = $params["serverpassword"];
       $serveraccesshash = $params["serveraccesshash"];
       $serversecure = $params["serversecure"]; # If set, SSL Mode is enabled in the server config
	
       $soapPacket = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
	<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
	  <soap:Body>
		<DeleteUser xmlns=\"http://tempuri.org/\">
		  <HostUserName>".$serverusername."</HostUserName>
		  <HostPassword>".$serverpassword."</HostPassword>
		  <OwnerName>".$serverusername."</OwnerName>
		   <UserName>".$customfields["Panel Login Name"]."</UserName>
			
		</DeleteUser>
		</soap:Body>
	</soap:Envelope>";
	#<OptionalParam><Parameters><Parameter Name=\"AdvanceDelete\">True</Parameter></Parameters></OptionalParam>

	$result= HC_ConnectSocket($soapPacket);	
	if($result)
	{	
		$resultString = explode("<?xml",$result);
		$x = "<?xml".$resultString[1];
		$doc = new DOMDocument();
		$doc->loadXML($x);
		
		$params = $doc->getElementsByTagName('Status'); 
		foreach ($params as $param) { 
			  $status = $param -> nodeValue.'
			  ';
		} 
		
		$params = $doc->getElementsByTagName('ErrorDescription'); 
		foreach ($params as $param) { 
			  $error = $param -> nodeValue.'
			  ';
		} 
		
		if($status == false)
		{
			$successful = false;
		}
		else
		{
			$successful = true;
		}
	}
	else
	{
		$successful = false;
		$error = "Unable to connect to API.";
	}
	
	# Code to perform action goes here...

	if ($successful) {
		$result = $error;
	} else {
		$result = $error;
	}
	return $result ;
}

function HC_SuspendAccount($params) {

    # Code to perform action goes here...
	
    $domain = $params["domain"];
    $username = $params["username"];
    $password = $params["password"];
    $customfields = $params["customfields"]; # Array of custom field values for the product
    $clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
    $configoptions = $params["configoptions"]; # Array of configurable option values for the product

   # Additional variables if the product/service is linked to a server
    $server = $params["server"]; # True if linked to a server
    $serverid = $params["serverid"];
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $serveraccesshash = $params["serveraccesshash"];
    $serversecure = $params["serversecure"]; # If set, SSL Mode is enabled in the server config
	
	$soapPacket = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
	<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
	  <soap:Body>
		<DisableUser xmlns=\"http://tempuri.org/\">
		  <HostUserName>".$serverusername."</HostUserName>
		  <HostPassword>".$serverpassword."</HostPassword>
		  <OwnerName>".$serverusername."</OwnerName>
		   <UserName>".$customfields["Panel Login Name"]."</UserName>
			<OptionalParam></OptionalParam>
		</DisableUser>
		</soap:Body>
	</soap:Envelope>";
	
		$result= HC_ConnectSocket($soapPacket);
		
		
		$resultString = explode("<?xml",$result);
		$x = "<?xml".$resultString[1];
		$doc = new DOMDocument();
		$doc->loadXML($x);
		
		$params = $doc->getElementsByTagName('Status'); 
		foreach ($params as $param) { 
			  $status = $param -> nodeValue.'
			  ';
		} 
		
		$params = $doc->getElementsByTagName('ErrorDescription'); 
		foreach ($params as $param) { 
			  $error = $param -> nodeValue.'
			  ';
		} 
		
		if($status == false)
		{
			$successful = false;
		}
		else
		{
			$successful = true;
		}
		
	

	# Code to perform action goes here...

	if ($successful) {
		$result = "User suspended successfully.";
	} else {
		$result = $error;
	}
	return $result;
}

function HC_UnsuspendAccount($params) {

    # Code to perform action goes here...
	
    $domain = $params["domain"];
    $username = $params["username"];
    $password = $params["password"];
    $customfields = $params["customfields"]; # Array of custom field values for the product
    $clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
    $configoptions = $params["configoptions"]; # Array of configurable option values for the product

   # Additional variables if the product/service is linked to a server
    $server = $params["server"]; # True if linked to a server
    $serverid = $params["serverid"];
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $serveraccesshash = $params["serveraccesshash"];
    $serversecure = $params["serversecure"]; # If set, SSL Mode is enabled in the server config
	
	$soapPacket = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
	<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
	  <soap:Body>
		<EnableUser xmlns=\"http://tempuri.org/\">
		  <HostUserName>".$serverusername."</HostUserName>
		  <HostPassword>".$serverpassword."</HostPassword>
		  <OwnerName>".$serverusername."</OwnerName>
		   <UserName>".$customfields["Panel Login Name"]."</UserName>
			<OptionalParam></OptionalParam>
		</EnableUser>
		</soap:Body>
	</soap:Envelope>";
	
		$result= HC_ConnectSocket($soapPacket);

		
		$resultString = explode("<?xml",$result);
		$x = "<?xml".$resultString[1];
		$doc = new DOMDocument();
		$doc->loadXML($x);
		
		$params = $doc->getElementsByTagName('Status'); 
		foreach ($params as $param) { 
			  $status = $param -> nodeValue.'
			  ';
		} 
		
		$params = $doc->getElementsByTagName('ErrorDescription'); 
		foreach ($params as $param) { 
			  $error = $param -> nodeValue.'
			  ';
		} 
		
		if($status == false)
		{
			$successful = false;
		}
		else
		{
			$successful = true;
		}
		
		
	# Code to perform action goes here...

	if ($successful) {
		$result = "User unsuspended successfully.";
	} else {
		$result = $error;
	}
	return $result;
}

function HC_ChangePassword($params) {

    # Code to perform action goes here...
	
    $domain = $params["domain"];
    $username = $params["username"];
    $password = $params["password"];
    $customfields = $params["customfields"]; # Array of custom field values for the product
    $clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
    $configoptions = $params["configoptions"]; # Array of configurable option values for the product

   # Additional variables if the product/service is linked to a server
    $server = $params["server"]; # True if linked to a server
    $serverid = $params["serverid"];
    $serverip = $params["serverip"];
    $serverusername = $params["serverusername"];
    $serverpassword = $params["serverpassword"];
    $serveraccesshash = $params["serveraccesshash"];
    $serversecure = $params["serversecure"]; # If set, SSL Mode is enabled in the server config
	
	$soapPacket = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
	<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
	  <soap:Body>
		<ChangeUserPassword xmlns=\"http://tempuri.org/\">
		  <HostUserName>".$serverusername."</HostUserName>
		  <HostPassword>".$serverpassword."</HostPassword>
		  <OwnerName>".$serverusername."</OwnerName>
		   <UserName>".$customfields["Panel Login Name"]."</UserName>
			<NewPassword>".$customfields["Panel Login Password"]."</NewPassword>
			<OptionalParam></OptionalParam>
		</ChangeUserPassword>
		</soap:Body>
	</soap:Envelope>";
	
		
		$result= HC_ConnectSocket($soapPacket);

		
		$resultString = explode("<?xml",$result);
		$x = "<?xml".$resultString[1];
		$doc = new DOMDocument();
		$doc->loadXML($x);
		
		$params = $doc->getElementsByTagName('Status'); 
		foreach ($params as $param) { 
			  $status = $param -> nodeValue.'
			  ';
		} 
		
		$params = $doc->getElementsByTagName('ErrorDescription'); 
		foreach ($params as $param) { 
			  $error = $param -> nodeValue.'
			  ';
		} 
		
		if($status == false)
		{
			$successful = false;
		}
		else
		{
			$successful = true;
		}

	# Code to perform action goes here...

	if ($successful) {
		$result = $error;
	} else {
		$result = $error;
	}
	return $result;
}

function HC_ClientArea($params) {
	
	$panelAccessURL = HC_GetPanelAccessURL($params["serverusername"], $params["serverpassword"]);
	
	$code = '<form action="'.$panelAccessURL.'" method="post" target="_blank">
	<input type="hidden" name="user" value="'.$params["username"].'" />
	<input type="hidden" name="pass" value="'.$params["password"].'" />
	<input type="submit" value="Login to Control Panel" />
	<input type="button" value="Login to Webmail" onClick="window.open(\'http://'.$params["serverip"].'/webmail\')" />
	</form>';
	
	return $code;
}

function HC_AdminLink($params) {

	$panelAccessURL = HC_GetPanelAccessURL($params["serverusername"], $params["serverpassword"]);
	$code = '<form action="'.$panelAccessURL.'" method="post" target="_blank">
	<input type="hidden" name="UserName" value="'.$params["serverusername"].'" />
	<input type="hidden" name="Password" value="'.$params["serverpassword"].'" />
	<input type="hidden" name="IsRemoteLogin" value="1" />
	<input type="submit" value="Login to HC" />
	</form>';

	return $code;
}

function HC_LoginLink($params) {

	$customfields = $params["customfields"]; # Array of custom field values for the product
	$clientsdetails = $params["clientsdetails"]; # Array of clients details - firstname, lastname, email, country, etc...
	$panelAccessURL = HC_GetPanelAccessURL($params["serverusername"], $params["serverpassword"]);


	$code = '
	<script language="javascript" type="text/javascript">
		function LoginToHC()
		{	
		     var fHCLogin = document.createElement(\'form\');
		     fHCLogin.setAttribute("id", "fHCLogin");
		     fHCLogin.setAttribute("name", "fHCLogin");
		     fHCLogin.setAttribute("action", "'.$panelAccessURL.'");
		     fHCLogin.setAttribute("method","post");
		     fHCLogin.setAttribute("target", "_blank");
		     
		     fHCLogin.innerHTML =  "<input type=\'hidden\' name=\'UserName\' value=\''.$customfields["Panel Login Name"].'\' /><input type=\'hidden\' name=\'Password\' value=\''.$customfields["Panel Login Password"].'\' /><input type=\'hidden\' name=\'IsRemoteLogin\' value=\'1\' />";
		     document.body.appendChild(fHCLogin); 
		     fHCLogin.submit();
			
		}
	</script>
	<a href="javascript:LoginToHC();" style="color:#cc0000">HostingController Login</a>	
	';	

	echo $code;
}

function HC_GetPanelAccessURL($serverusername, $serverpassword){

	
	# Code to perform action goes here...
	$HCAccessURL = "";
       	$soapPacket = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
	<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">
	  <soap:Body>
		<GetPanelAccessURL xmlns=\"http://tempuri.org/\">
		  <HostUserName>".$serverusername."</HostUserName>
		  <HostPassword>".$serverpassword."</HostPassword>
		  <OptionalParam></OptionalParam>
		</GetPanelAccessURL>
		</soap:Body>
	</soap:Envelope>";

        	$result= HC_ConnectSocket($soapPacket);
		$resultString = explode("<?xml",$result);
		$x = "<?xml".$resultString[1];
		$doc = new DOMDocument();
		$doc->loadXML($x);


		
		$params = $doc->getElementsByTagName('HCAccessURL');
		foreach ($params as $param) {
			  $HCAccessURL = $param -> nodeValue.'
			  ';
		}

	if($HCAccessURL == "")
	{
		$HCAccessURL = 'http://'.$_SERVER['SERVER_ADDR'].':8787/index.php';
	}
	return $HCAccessURL;
}

function HC_AdminCustomButtonArray() {
	# This function can define additional functions your module supports, the example here is a reboot button and then the reboot function is defined below
    $buttonarray = array(
	 
	);
	return $buttonarray;
}
?>
